/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __read, __spreadArray, __values } from "tslib";
import { Brush } from "igniteui-angular-core";
import { XYChart } from "./XYChart";
import { IndicatorPane } from "./IndicatorPane";
import { Base, BaseError, EventArgs, runOn, delegateRemove, delegateCombine, fromEnum, typeCast, EnumUtil, Number_$type, String_$type, enumGetBox, markType, TypeRegistrar, fromEn } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { DataSeriesType_$type } from "igniteui-angular-core";
import { IDataSeriesAdapterRule_$type } from "igniteui-angular-core";
import { SimpleFinancialPriceSeriesRule } from "igniteui-angular-core";
import { SubCollectionsRule } from "igniteui-angular-core";
import { XamDataChart } from "./XamDataChart";
import { FinancialChartVolumeType_$type } from "./FinancialChartVolumeType";
import { FinancialChartXAxisMode_$type } from "./FinancialChartXAxisMode";
import { FinancialChartYAxisMode_$type } from "./FinancialChartYAxisMode";
import { FinancialChartType_$type } from "./FinancialChartType";
import { NumericYAxis } from "./NumericYAxis";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { FinancialChartZoomSliderType_$type } from "./FinancialChartZoomSliderType";
import { BrushCollection } from "igniteui-angular-core";
import { FinancialChartRangeSelectorOptionCollection } from "./FinancialChartRangeSelectorOptionCollection";
import { ObservableCollection$1 } from "igniteui-angular-core";
import { TemplatedHtmlControl } from "./TemplatedHtmlControl";
import { FinancialChartContext } from "./FinancialChartContext";
import { FinancialChartToolbarContext } from "./FinancialChartToolbarContext";
import { FinancialChartViewModel } from "./FinancialChartViewModel";
import { FinancialChartToolbarViewModel } from "./FinancialChartToolbarViewModel";
import { AxisDefaults } from "./AxisDefaults";
import { Defaults } from "./Defaults";
import { BrushUtil } from "igniteui-angular-core";
import { Series } from "./Series";
import { Rect } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { MarkerSeries } from "./MarkerSeries";
import { IZoomableCategoryAxis_$type } from "./IZoomableCategoryAxis";
import { SyncSettings } from "./SyncSettings";
import { SyncManager } from "./SyncManager";
import { FinancialOverlayType_$type } from "./FinancialOverlayType";
import { ArrayExtension } from "igniteui-angular-core";
import { FinancialIndicatorType_$type } from "./FinancialIndicatorType";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { FinancialChartVisualData } from "./FinancialChartVisualData";
import { FinancialChartCustomIndicatorArgs } from "./FinancialChartCustomIndicatorArgs";
import { ScalerParams } from "./ScalerParams";
import { stringReplace, stringJoin, stringIsNullOrEmpty } from "igniteui-angular-core";
import { timeSpanFromDays } from "igniteui-angular-core";
import { dateMaxValue, dateMinValue } from "igniteui-angular-core";
import { isNaN_, isInfinity } from "igniteui-angular-core";
import { FinancialChartTypePicker } from "./FinancialChartTypePicker";
import { FinancialChartIndicatorMenu } from "./FinancialChartIndicatorMenu";
import { TrendLineType_$type } from "igniteui-angular-core";
import { FinancialChartIndicatorMenuContext } from "./FinancialChartIndicatorMenuContext";
import { FinancialChartTypePickerContext } from "./FinancialChartTypePickerContext";
import { FinancialChartRangeSelectorContext } from "./FinancialChartRangeSelectorContext";
import { FinancialChartToolbarVisualData } from "./FinancialChartToolbarVisualData";
import { FinancialChartRangeSelectorViewModel } from "./FinancialChartRangeSelectorViewModel";
import { FinancialChartRangeSelectorView } from "./FinancialChartRangeSelectorView";
/**
 * @hidden
 */
var FinancialChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChart, _super);
    function FinancialChart() {
        var _this = _super.call(this) || this;
        _this.aet = null;
        _this.ahr = null;
        _this.ahp = null;
        _this.ahm = null;
        _this.aho = null;
        _this.ahq = null;
        _this.ahn = null;
        _this.adz = null;
        _this.ah9 = null;
        _this.aia = null;
        _this.ah6 = null;
        _this.aib = null;
        _this.aic = null;
        _this.ah7 = null;
        _this.ah8 = null;
        _this.afh = null;
        _this.agr = 40;
        _this.aen = null;
        _this.ael = null;
        _this.aep = null;
        _this.aeu = null;
        _this.aik = null;
        _this.afd = null;
        _this.af3 = false;
        _this.af2 = false;
        _this.aga = false;
        _this.afp = false;
        _this.ahx = 10;
        _this.agy = NaN;
        _this.ag0 = NaN;
        _this.agz = NaN;
        _this.ag1 = 0;
        _this.ad5 = 0;
        _this.ad8 = 0;
        _this.agt = 3;
        _this.agw = NaN;
        _this.agu = NaN;
        _this.agv = NaN;
        _this.agx = NaN;
        _this.aea = 0;
        _this.afk = true;
        _this.ad1 = 0;
        _this.afl = false;
        _this.aef = null;
        _this.aeh = null;
        _this.agc = null;
        _this.afn = true;
        _this.afm = false;
        _this.afo = false;
        _this.afe = null;
        _this.aec = 1;
        _this.ac3 = null;
        _this.ac4 = null;
        _this.ac5 = null;
        _this.ac6 = null;
        _this.ac8 = null;
        _this.ac7 = null;
        _this.ac2 = null;
        _this.ac1 = null;
        _this.ags = 1;
        _this.agq = 1;
        _this.agp = 2;
        _this.ago = 1;
        _this.aer = null;
        _this.aht = -2147483648;
        _this.agn = 2;
        _this.ahw = 3;
        _this.ahu = 10;
        _this.ahs = 30;
        _this.ahv = 9;
        _this.adw = null;
        _this.adx = null;
        _this.ads = null;
        _this.applyCustomIndicators = null;
        _this.ame = null;
        _this.ag2 = 1;
        _this.afj = false;
        _this.aej = null;
        _this.agk = dateMinValue();
        _this.agj = dateMaxValue();
        _this.agh = null;
        _this.rr();
        _this.agh = new ObservableCollection$1(Base.$, 0);
        if (_this.xAxisBreaks != null) {
            var a = _this.xAxisBreaks;
            a.collectionChanged = delegateCombine(a.collectionChanged, function (a, b) { return _this.al3(); });
        }
        _this.alo();
        return _this;
    }
    FinancialChart.prototype.s0 = function (a, b, c) {
        _super.prototype.s0.call(this, a, b, c);
        switch (a) {
            case "ToolbarTemplate":
            case "RangeSelectorTemplate":
                this.ad0 = new FinancialChartToolbar(this, this.aih);
                break;
            case "Toolbar":
                var d = b;
                if (d != null) {
                    d.chartTypeChanged = delegateRemove(d.chartTypeChanged, runOn(this, this.alb));
                    d.trendLineTypeChanged = delegateRemove(d.trendLineTypeChanged, runOn(this, this.ale));
                    d.volumeTypeChanged = delegateRemove(d.volumeTypeChanged, runOn(this, this.alf));
                    d.l(null);
                }
                if (this.ad0 != null) {
                    this.ad0.ac = this.ad7;
                    this.ad0.ai = this.dq;
                    this.ad0.y = this.ad2;
                    this.ad0.al = this.af0;
                    if (this.aho != null) {
                        this.ad0.l(this.aho);
                    }
                    var e = this.ad0;
                    e.chartTypeChanged = delegateCombine(e.chartTypeChanged, runOn(this, this.alb));
                    ;
                    var f = this.ad0;
                    f.trendLineTypeChanged = delegateCombine(f.trendLineTypeChanged, runOn(this, this.ale));
                    var g = this.ad0;
                    g.volumeTypeChanged = delegateCombine(g.volumeTypeChanged, runOn(this, this.alf));
                }
                break;
            case "ChartType":
                if (this.ad0 != null) {
                    this.ad0.y = this.ad2;
                }
                break;
            case "VolumeType":
                if (this.ad0 != null) {
                    this.ad0.ac = this.ad7;
                }
                break;
            case "TrendLineType":
                if (this.ad0 != null) {
                    this.ad0.ai = this.dq;
                }
                break;
            case "IsToolbarVisible":
                if (this.ad0 == null) {
                    break;
                }
                this.ad0.al = this.af0;
                this.setGridRows();
                break;
        }
    };
    FinancialChart.prototype.alf = function (a, b) {
        this.ad7 = this.ad0.ac;
    };
    FinancialChart.prototype.ale = function (a, b) {
        this.dq = this.ad0.ai;
    };
    FinancialChart.prototype.alb = function (a, b) {
        this.ad2 = this.ad0.y;
    };
    FinancialChart.prototype.alo = function () {
        this.aet = new IndicatorPane();
        this.aek = TypeRegistrar.create("FinancialLegend");
    };
    FinancialChart.prototype.provideGrid = function (a) {
        this.ahr = a;
        this.al9();
        this.setGridRows();
        if (this.ad0 != null) {
            this.ad0.bg(a);
        }
    };
    FinancialChart.prototype.onDocumentClick = function (a) {
        if (this.ad0 != null) {
            this.ad0.bl(a);
        }
    };
    FinancialChart.prototype.getContext = function () {
        var a = this.ad0.v();
        var b = new FinancialChartContext();
        b.vm = new FinancialChartViewModel();
        b.vm.toolbar = a;
        b.container = this.j8;
        b.toolbarContainer = this.aho;
        b.legendContainer = this.ahn;
        b.indicatorsContainer = this.ahm;
        b.volumeContainer = this.ahp;
        b.zoomContainer = this.ahq;
        return b;
    };
    FinancialChart.prototype.provideContainer = function (a) {
        var b = a;
        if (b != null) {
            var c = "financialChartMainGrid";
            var d = b.createElement("div");
            d.setStyleProperty("width", "100%");
            d.setStyleProperty("height", "100%");
            if (this.ad0 == null) {
                this.ad0 = new FinancialChartToolbar(this, this.aih);
            }
            this.ad0.w.isIndicatorMenuVisible = this.afr && this.afs;
            this.aho = b.getSubRenderer(d);
            this.ad0.l(this.aho);
            var e = b.createElement("div");
            e.setStyleProperty("width", "100%");
            e.setStyleProperty("height", "100%");
            var f = b.createElement("div");
            f.setStyleProperty("width", "100%");
            f.setStyleProperty("height", "100%");
            this.ahn = b.getSubRenderer(f);
            var g = b.createElement("div");
            g.setStyleProperty("width", "100%");
            g.setStyleProperty("height", "100%");
            this.ahm = b.getSubRenderer(g);
            var h = b.createElement("div");
            h.setStyleProperty("width", "100%");
            h.setStyleProperty("height", "100%");
            this.ahp = b.getSubRenderer(h);
            var i = b.createElement("div");
            i.setStyleProperty("width", "100%");
            i.setStyleProperty("height", "100%");
            this.ahq = b.getSubRenderer(i);
            a = b.getSubRenderer(e);
        }
        else {
            this.aho = null;
            if (this.ad0 != null) {
                this.ad0.l(null);
            }
            if (this.afi != null) {
                this.afi.provideContainer(null);
                this.afi = null;
            }
            if (this.aek != null) {
                this.aek.provideContainer(null);
            }
        }
        _super.prototype.provideContainer.call(this, a);
        if (b != null) {
            if (this.volumeChart != null) {
                this.volumeChart.provideContainer(this.ahp);
            }
            if (this.aet != null) {
                this.aet.h(this.ahm);
            }
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.provideContainer(this.ahq);
                if (a != null) {
                    this.akv();
                }
                else {
                    this.afi = null;
                }
            }
            if (this.aek != null) {
                this.aek.provideContainer(this.ahn);
            }
            this.setGridRows();
        }
    };
    FinancialChart.prototype.alz = function (a, b, c) {
        if (a != null) {
            a.provideContainer(null);
        }
        if (b != null) {
            b.provideContainer(c);
        }
        this.setGridRows();
    };
    FinancialChart.prototype.amd = function (a, b) {
        this.alz(a, b, this.ahq);
        if (b == null) {
            return;
        }
        this.akv();
    };
    FinancialChart.prototype.akv = function () {
        var _this = this;
        if (this.ahq == null) {
            return;
        }
        if (this.afi != null) {
            this.afi.provideContainer(null);
        }
        this.afi = TypeRegistrar.create("ZoomSlider");
        this.afi.provideContainer(this.ahq);
        var a = this.afi;
        a.windowRectChanged = delegateCombine(a.windowRectChanged, function (a, b) {
            if (_this.dataChart != null) {
                _this.dataChart.tz = new Rect(0, _this.afi.windowRect.left, _this.dataChart.tj.top, _this.afi.windowRect.width, _this.dataChart.tj.height);
            }
        });
        this.akw();
    };
    FinancialChart.prototype.amb = function (a, b) {
        this.alz(a, b, this.ahp);
    };
    FinancialChart.prototype.setGridRows = function () {
        if (this.ahr == null) {
            return;
        }
        var a = new Array(6);
        a[0] = (this.af0 ? this.ag8 : 0) + "px";
        a[1] = this.afw ? "min-content" : "0px";
        a[2] = "auto";
        a[3] = this.indicatorCharts == null || this.indicatorCharts.count == 0 ? "0px" : this.indicatorCharts.count * 150 + "px";
        a[4] = this.volumeChart == null ? "0px" : "100px";
        a[5] = this.zoomSliderChart == null ? "0px" : "100px";
        if (this.afi != null) {
            if (a[5] == "0px") {
                this.afi.hide();
            }
            else {
                this.afi.show();
            }
        }
        this.ahr.setStyleProperty("-ms-grid-rows", stringReplace(stringJoin.apply(void 0, __spreadArray([" "], __read(a))), "auto", "1fr"));
        this.ahr.setStyleProperty("grid-template-rows", stringJoin.apply(void 0, __spreadArray([" "], __read(a))));
        if (this.j8 == null) {
            return;
        }
        if (this.dataChart != null) {
            this.dataChart.notifyContainerResized();
        }
        if (this.aet != null) {
            this.aet.f();
        }
        if (this.volumeChart != null) {
            this.volumeChart.notifyContainerResized();
        }
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.notifyContainerResized();
        }
        if (this.afi != null) {
            this.afi.notifySizeChanged();
        }
    };
    FinancialChart.prototype.r9 = function () {
        var e_1, _a;
        _super.prototype.r9.call(this);
        this.wf = 1;
        this.abu = 0;
        this.yc = 0;
        this.aco = null;
        this.ach = AxisDefaults.g;
        this.xw = AxisDefaults.e;
        this.xv = AxisDefaults.f;
        this.aci = AxisDefaults.j;
        this.ace = null;
        this.amf = AxisDefaults.h;
        this.ahl = AxisDefaults.b;
        this.ft = true;
        this.fm = true;
        this.fn = false;
        this.a9 = 0;
        this.h9 = Defaults.j;
        this.up = Defaults.ae;
        this.uk = Defaults.af;
        this.ul = Defaults.ag;
        this.iv = NaN;
        this.im = 40;
        this.f2 = true;
        this.f9 = false;
        if (this.dataChart != null) {
            var a = this.dataChart.cu.j.e();
            this.adb = a.d;
            this.adc = a.e;
            this.ada = a.d;
            this.amf = this.dataChart.x4;
        }
        var b = new BrushCollection();
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#8BDC5C";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#8961A9";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#6DB1FF";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#82E9D9";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#EA3C63";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#735656";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#F8CE4F";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#A8A8B7";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#E051A9";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#FF903B";
            return $ret;
        })()));
        var c = new BrushCollection();
        try {
            for (var _b = __values(fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                c.add(BrushUtil.m(d, 0.3));
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        this.add = c;
        this.ade = b;
    };
    FinancialChart.prototype.alv = function () {
        if (this.aet != null) {
            this.aet.b = null;
            this.aet.b = this.indicatorCharts;
        }
        this.setGridRows();
    };
    FinancialChart.prototype.alw = function () {
        this.setGridRows();
    };
    FinancialChart.prototype.al5 = function () {
        this.alv();
    };
    FinancialChart.prototype.aku = function () {
        if (this.afi == null || this.zoomSliderChart == null || this.dataChart == null || this.dataChart.series.count == 0) {
            return;
        }
        var a = this.j8.rootWrapper.width();
        var b = this.dataChart.ty.left + this.dataChart.ty.width;
        var c = this.dataChart.ty.left;
        var d = a - b;
        this.afi.startInset = c - this.afi.trackStartInset;
        this.afi.endInset = d - this.afi.trackEndInset;
        if (this.afi.endInset < 0) {
            var e = this.afi.endInset;
            this.afi.endInset = 0;
            this.dataChart.g4 += (e * -1);
        }
        if (this.afi.startInset < 0) {
            var f = this.afi.startInset;
            this.afi.startInset = 0;
            this.dataChart.gz += (f * -1);
        }
        this.zoomSliderChart.gz = c;
        this.zoomSliderChart.g4 = d;
        this.zoomSliderChart.gm = this.afi.barExtent;
    };
    FinancialChart.prototype.all = function () {
        this.aku();
    };
    FinancialChart.prototype.r6 = function (a) {
        _super.prototype.r6.call(this, a);
        if (a != null) {
            a.gl = 0;
        }
    };
    FinancialChart.prototype.amg = function (a) {
        return a.tc();
    };
    FinancialChart.prototype.amj = function () {
        return this.ahn == null ? null : this.ami(this.ahn.rootWrapper);
    };
    FinancialChart.prototype.amh = function (a) {
        if (a == null || a.d == null) {
            return null;
        }
        return this.ami(a.d.rootWrapper);
    };
    FinancialChart.prototype.ami = function (a) {
        if (a == null) {
            return null;
        }
        var b = a.getOffset();
        return new Rect(0, b.left, b.top, a.width(), a.height());
    };
    FinancialChart.prototype.ag3 = function () {
        if (this.ahr == null) {
            return NaN;
        }
        var a = this.ahr.getOffset();
        return this.ahr.width() + (a == null ? 0 : a.left);
    };
    FinancialChart.prototype.si = function (source_, a, b) {
        _super.prototype.si.call(this, source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.mo(source_, a, b);
        }
    };
    FinancialChart.prototype.sj = function (source_, a, b) {
        _super.prototype.sj.call(this, source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.mp(source_, a, b);
        }
    };
    FinancialChart.prototype.sh = function (source_) {
        _super.prototype.sh.call(this, source_);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.mh(source_);
        }
    };
    FinancialChart.prototype.sl = function (source_, a, b, c) {
        _super.prototype.sl.call(this, source_, a, b, c);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.mq(source_, a, b, c);
        }
    };
    FinancialChart.prototype.sc = function (a, b) {
        _super.prototype.sc.call(this, a, b);
        if (this.afx(a)) {
            a.toolTip = null;
        }
    };
    Object.defineProperty(FinancialChart.prototype, "ad0", {
        get: function () {
            return this.adz;
        },
        set: function (a) {
            var b = this.ad0;
            if (a != b) {
                this.adz = a;
                this.sw("Toolbar", b, this.ad0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aig", {
        get: function () {
            return this.ah9;
        },
        set: function (a) {
            var b = this.aig;
            if (a != b) {
                this.ah9 = a;
                this.sw("RangeSelectorTemplate", b, this.aig);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aih", {
        get: function () {
            return this.aia;
        },
        set: function (a) {
            var b = this.aih;
            if (a != b) {
                this.aia = a;
                this.sw("ToolbarTemplate", b, this.aih);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aid", {
        get: function () {
            return this.ah6;
        },
        set: function (a) {
            var b = this.aid;
            if (a != b) {
                this.ah6 = a;
                this.sw("ChartTypePickerTemplate", b, this.aid);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aii", {
        get: function () {
            return this.aib;
        },
        set: function (a) {
            var b = this.aii;
            if (a != b) {
                this.aib = a;
                this.sw("TrendLineTypePickerTemplate", b, this.aii);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aij", {
        get: function () {
            return this.aic;
        },
        set: function (a) {
            var b = this.aij;
            if (a != b) {
                this.aic = a;
                this.sw("VolumeTypePickerTemplate", b, this.aij);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aie", {
        get: function () {
            return this.ah7;
        },
        set: function (a) {
            var b = this.aie;
            if (a != b) {
                this.ah7 = a;
                this.sw("IndicatorMenuTemplate", b, this.aie);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aif", {
        get: function () {
            return this.ah8;
        },
        set: function (a) {
            var b = this.aif;
            if (a != b) {
                this.ah8 = a;
                this.sw("OverlayPickerTemplate", b, this.aif);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "afi", {
        get: function () {
            return this.afh;
        },
        set: function (a) {
            var b = this.afi;
            if (a != b) {
                this.afh = a;
                this.sw("ZoomSlider", b, this.afi);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_im = function () {
        return _super.prototype.get_im.call(this);
    };
    FinancialChart.prototype.set_im = function (a) {
        _super.prototype.set_im.call(this, a);
    };
    FinancialChart.prototype.get_f2 = function () {
        return _super.prototype.get_f2.call(this);
    };
    FinancialChart.prototype.set_f2 = function (a) {
        _super.prototype.set_f2.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "ag8", {
        get: function () {
            return this.agr;
        },
        set: function (a) {
            var b = this.ag8;
            if (a != b) {
                this.agr = a;
                this.sw("ToolbarHeight", b, this.ag8);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.v4 = function () {
        return this.xAxis;
    };
    FinancialChart.prototype.v5 = function () {
        return this.yAxis;
    };
    FinancialChart.prototype.onAttachedToUI = function () {
        _super.prototype.onAttachedToUI.call(this);
        if (this.afi != null) {
            this.afi.onAttachedToUI();
        }
    };
    FinancialChart.prototype.onDetachedFromUI = function () {
        _super.prototype.onDetachedFromUI.call(this);
        if (this.afi != null) {
            this.afi.onDetachedFromUI();
        }
    };
    FinancialChart.prototype.bc = function (a) {
        return 20;
    };
    FinancialChart.prototype.get_gr = function () {
        return ((function () {
            var $ret = new List$1(DataSeriesType_$type, 0);
            $ret.add(20);
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChart.prototype, "gr", {
        get: function () {
            return this.get_gr();
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_gq = function () {
        return ((function () {
            var $ret = new List$1(IDataSeriesAdapterRule_$type, 0);
            $ret.add(new SimpleFinancialPriceSeriesRule());
            $ret.add(new SubCollectionsRule());
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChart.prototype, "gq", {
        get: function () {
            return this.get_gq();
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.adm = function (a) {
        return this.adn(a);
    };
    FinancialChart.prototype.ae0 = function (a) {
        return this.ae1(a);
    };
    FinancialChart.prototype.adl = function (a) {
        var b = this.adm(0);
        b.name = a;
        return b;
    };
    FinancialChart.prototype.rn = function () {
        this.xAxis = this.adl("xAxis");
        this.yAxis = this.ae0(0);
        this.yAxis.name = "yAxis";
        this.volumeAxis = this.ae0(0);
        this.volumeAxis.name = "volumeAxis";
        this.volumeXAxis = this.adl("volumeXAxis");
        this.age = new List$1(NumericYAxis.$, 0);
        this.agg = new List$1(CategoryAxisBase.$, 0);
        this.indicatorAxis = this.ae0(0);
        this.indicatorAxis.name = "indicatorAxis";
        this.indicatorXAxis = this.adl("indicatorXAxis_0");
        this.age.add(this.indicatorAxis);
        this.agg.add(this.indicatorXAxis);
        if (this.xAxis.az == null) {
            this.xAxis.az = new AxisLabelSettings();
        }
        if (this.yAxis.az == null) {
            this.yAxis.az = new AxisLabelSettings();
        }
        if (this.volumeAxis.az == null) {
            this.volumeAxis.az = new AxisLabelSettings();
        }
        if (this.volumeXAxis.az == null) {
            this.volumeAxis.az = new AxisLabelSettings();
        }
        if (this.indicatorAxis.az == null) {
            this.indicatorAxis.az = new AxisLabelSettings();
        }
        if (this.indicatorXAxis.az == null) {
            this.indicatorXAxis.az = new AxisLabelSettings();
        }
        this.zoomSliderAxis = this.ae0(0);
        this.zoomSliderAxis.name = "zoomSliderAxis";
        this.zoomSliderXAxis = this.adl("zoomSliderXAxis");
        if (this.zoomSliderAxis.az == null) {
            this.zoomSliderAxis.az = new AxisLabelSettings();
        }
        if (this.zoomSliderXAxis.az == null) {
            this.zoomSliderXAxis.az = new AxisLabelSettings();
        }
    };
    FinancialChart.prototype.rj = function (a, b) {
        var c = typeCast(MarkerSeries.$, a);
        if (c != null) {
            c.ql = this.cr(a, b);
        }
    };
    FinancialChart.prototype.cq = function (a) {
        if (a != null) {
            return 1;
        }
        return _super.prototype.cq.call(this, a);
    };
    FinancialChart.prototype.tg = function (a) {
        if (a.suggestedSecondaryAxis == 2) {
            this.yAxis.li = true;
            this.yAxis.l9 = 10;
        }
    };
    FinancialChart.prototype.tj = function () {
        this.yAxis.li = this.af7;
        this.yAxis.l9 = this.ah5;
    };
    FinancialChart.prototype.ad4 = function (a) {
        var b;
        if (this.ad2 == 0) {
            if (a == null || a.index > 0 || stringIsNullOrEmpty(a.getMemberPathFor(12))) {
                b = 4;
            }
            else {
                b = 2;
            }
        }
        else {
            b = this.ad2;
        }
        b = this.ad3(b);
        return b;
    };
    FinancialChart.prototype.ad3 = function (a) {
        if ((a == 1 || a == 2)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.aed = function (a) {
        if ((a == 2 || a == 3)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 5;
        }
        if (a == 5) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 6;
        }
        if (a == 6) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.ad6 = function (a) {
        if (a == 2) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 1;
        }
        if (a == 1) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.ais = function (a) {
        var b = a.getMemberPathFor(14);
        if (stringIsNullOrEmpty(b)) {
            b = a.getMemberPathFor(11);
        }
        return b;
    };
    FinancialChart.prototype.adn = function (axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createXAxis(axisType_).i);
        }
        else {
            var a = void 0;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    };
    FinancialChart.prototype.ae1 = function (axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createYAxis(axisType_).i);
        }
        else {
            var a = void 0;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    };
    FinancialChart.prototype.ae7 = function () {
        return this.c3(1);
    };
    FinancialChart.prototype.ae8 = function () {
        return this.c3(0);
    };
    FinancialChart.prototype.ae6 = function () {
        return this.c3(2);
    };
    FinancialChart.prototype.ae9 = function () {
        return this.c3(20);
    };
    Object.defineProperty(FinancialChart.prototype, "afq", {
        get: function () {
            return (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy"));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aeo", {
        get: function () {
            if (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy")) {
                return TypeRegistrar.create("HorizontalAnchoredCategorySeriesProxy");
            }
            else {
                throw new BaseError(1, "horizontal series module is not loaded, but is required.");
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aft", {
        get: function () {
            return (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy"));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aem", {
        get: function () {
            if (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy")) {
                return TypeRegistrar.create("FinancialPriceSeriesProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "afr", {
        get: function () {
            return (TypeRegistrar.isRegistered("IndicatorProxy"));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aeq", {
        get: function () {
            if (TypeRegistrar.isRegistered("IndicatorProxy")) {
                return TypeRegistrar.create("IndicatorProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "afs", {
        get: function () {
            return (TypeRegistrar.isRegistered("OverlayProxy"));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aev", {
        get: function () {
            if (TypeRegistrar.isRegistered("OverlayProxy")) {
                return TypeRegistrar.create("OverlayProxy");
            }
            else {
                throw new BaseError(1, "overlay series module is not loaded, but is required.");
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.c1 = function (a, b) {
        var c = this.ais(a);
        switch (this.ad4(a)) {
            case 3:
                var d = this.ae7();
                this.aeo.setValueMemberPath(d, c);
                this.aeo.setXAxis(d, this.xAxis);
                this.aeo.setYAxis(d, this.yAxis);
                this.aeo.setCategoryMode(d, 1);
                return d;
            case 4:
                var e = this.ae8();
                this.aeo.setValueMemberPath(e, c);
                this.aeo.setXAxis(e, this.xAxis);
                this.aeo.setYAxis(e, this.yAxis);
                this.aeo.setCategoryMode(e, 1);
                return e;
            default:
            case 1:
            case 2:
                var f = this.ae9();
                this.aem.setOpenMemberPath(f, a.getMemberPathFor(11));
                this.aem.setHighMemberPath(f, a.getMemberPathFor(12));
                this.aem.setLowMemberPath(f, a.getMemberPathFor(13));
                this.aem.setCloseMemberPath(f, a.getMemberPathFor(14));
                this.aem.setVolumeMemberPath(f, a.getMemberPathFor(15));
                this.aem.setXAxis(f, this.xAxis);
                this.aem.setYAxis(f, this.yAxis);
                this.aem.setDisplayType(f, this.ad2 == 1 ? 1 : 0);
                this.aem.setCategoryMode(f, 1);
                return f;
        }
    };
    FinancialChart.prototype.ti = function () {
        _super.prototype.ti.call(this);
        this.alj(this.xAxis);
        this.al7(false);
        if (this.ad7 != 0 && this.volumeChart != null) {
            this.alq();
        }
        this.alj(this.volumeXAxis);
        this.alj(this.indicatorXAxis);
        this.al4();
        this.al6();
        if (this.aee != 0) {
            this.alr();
            this.alj(this.zoomSliderXAxis);
        }
    };
    FinancialChart.prototype.abg = function (a, b) {
        var e_2, _a;
        _super.prototype.abg.call(this, a, b);
        a(this.volumeXAxis);
        if (this.agg != null) {
            try {
                for (var _b = __values(fromEnum(this.agg)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    a(c);
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        }
        var d = true;
        switch (b) {
            case "XAxisMajorStroke":
            case "XAxisMajorStrokeThickness":
                d = false;
                break;
        }
        if (d) {
            a(this.zoomSliderXAxis);
        }
    };
    FinancialChart.prototype.abl = function (a, b) {
        var e_3, _a;
        _super.prototype.abl.call(this, a, b);
        if (b) {
            a(this.volumeAxis);
            if (this.age != null) {
                try {
                    for (var _b = __values(fromEnum(this.age)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var c = _c.value;
                        a(c);
                    }
                }
                catch (e_3_1) {
                    e_3 = { error: e_3_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_3)
                            throw e_3.error;
                    }
                }
            }
            a(this.zoomSliderAxis);
        }
    };
    FinancialChart.prototype.aln = function (a) {
        var b = typeCast(IZoomableCategoryAxis_$type, this.xAxis);
        if (b != null) {
            a(b);
        }
    };
    FinancialChart.prototype.abj = function (a) {
        _super.prototype.abj.call(this, a);
        this.aba(this.volumeXAxis, a);
        this.aba(this.indicatorXAxis, a);
        this.aba(this.zoomSliderXAxis, a);
    };
    FinancialChart.prototype.abo = function (a) {
        _super.prototype.abo.call(this, a);
        this.aba(this.volumeAxis, a);
        this.aba(this.indicatorAxis, a);
        this.aba(this.zoomSliderAxis, a);
    };
    FinancialChart.prototype.abm = function (a) {
        _super.prototype.abm.call(this, a);
        this.aa9(this.volumeAxis, a);
        this.aa9(this.indicatorAxis, a);
        this.aa9(this.zoomSliderAxis, a);
    };
    FinancialChart.prototype.abh = function (a) {
        _super.prototype.abh.call(this, a);
        this.aa9(this.volumeXAxis, a);
        this.aa9(this.indicatorXAxis, a);
        this.aa9(this.zoomSliderXAxis, a);
    };
    FinancialChart.prototype.r5 = function (a) {
        var _this = this;
        _super.prototype.r5.call(this, a);
        if (a == null) {
            return;
        }
        if (a == this.zoomSliderChart) {
            a.uu = a.ux = false;
            a.legend = null;
            if (this.dataChart != null) {
                a.ag = this.dataChart.ag;
                a.aj = this.dataChart.aj;
            }
        }
        else {
            SyncManager.d(a, ((function () {
                var $ret = new SyncSettings();
                $ret.syncChannel = _this.ajn();
                $ret.synchronizeHorizontally = true;
                $ret.synchronizeVertically = false;
                return $ret;
            })()));
            SyncManager.c(a);
        }
        a.ci = 2;
    };
    FinancialChart.prototype.ajn = function () {
        if (this.aik == null) {
            FinancialChart.ah4++;
            this.aik = FinancialChart.ah4.toString();
        }
        return this.aik;
    };
    FinancialChart.prototype.ak5 = function (a, b) {
        this.akr();
        this.all();
    };
    FinancialChart.prototype.akr = function () {
        var e_4, _a;
        if (this.yAxis.b8()) {
            return;
        }
        var a = this.yAxis.aw.bd;
        if (this.ad7 != 0) {
            a = Math.max(a, this.volumeAxis.aw.bd);
        }
        try {
            for (var _b = __values(fromEnum(this.age)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                a = Math.max(a, b.aw.bd);
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
        this.aks(a);
    };
    FinancialChart.prototype.aks = function (a) {
        var e_5, _a;
        if (this.yAxis.b8()) {
            return;
        }
        this.yAxis.es = this.volumeAxis.es = a;
        try {
            for (var _b = __values(fromEnum(this.age)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                b.es = a;
            }
        }
        catch (e_5_1) {
            e_5 = { error: e_5_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_5)
                    throw e_5.error;
            }
        }
        this.zoomSliderAxis.es = this.yAxis.es;
    };
    FinancialChart.prototype.akx = function (a) {
        if (this.indicatorCharts == null) {
            return;
        }
        for (var b = 0; b < this.indicatorCharts.count; b++) {
            var c = this.indicatorCharts._inner[b];
            for (var d = 0; d < c.series.count; d++) {
                var e = c.series._inner[d];
                if (!(this.afv(e))) {
                    continue;
                }
                a(c.series._inner[d], b);
            }
        }
    };
    FinancialChart.prototype.ak0 = function (a) {
        if (this.volumeChart == null) {
            return;
        }
        for (var b = 0; b < this.volumeChart.series.count; b++) {
            var c = this.volumeChart.series._inner[b];
            if (c.dd) {
                continue;
            }
            a(this.volumeChart.series._inner[b], b);
        }
    };
    FinancialChart.prototype.aky = function (a) {
        if (this.dataChart == null) {
            return;
        }
        for (var b = 0; b < this.dataChart.series.count; b++) {
            var c = this.dataChart.series._inner[b];
            if (!this.afx(c)) {
                continue;
            }
            a(c, b);
        }
    };
    FinancialChart.prototype.akz = function (a, b) {
        if (this.dataChart == null) {
            return;
        }
        for (var c = 0; c < this.dataChart.series.count; c++) {
            var d = this.dataChart.series._inner[c];
            if (this.afx(d)) {
                continue;
            }
            var e = this.ahy(d, c);
            a(d, e);
        }
        if (b) {
            this.ak1(a);
        }
    };
    FinancialChart.prototype.ak1 = function (a) {
        if (this.zoomSliderChart == null) {
            return;
        }
        for (var b = 0; b < this.zoomSliderChart.series.count; b++) {
            var c = this.zoomSliderChart.series._inner[b];
            if (c.dd) {
                continue;
            }
            a(this.zoomSliderChart.series._inner[b], b);
        }
    };
    FinancialChart.prototype.ahy = function (a, b) {
        if (a.cc != this.dataChart) {
            return b;
        }
        var c = this.bd == null || this.bd.dataSeries == null ? 0 : this.bd.dataSeries.count;
        var d = this.aei == null ? 0 : this.aei.count;
        return b - (c * d);
    };
    FinancialChart.prototype.rv = function (a) {
        _super.prototype.rv.call(this, a);
        this.ak0(a);
        this.akx(a);
        this.ak1(a);
    };
    Object.defineProperty(FinancialChart.prototype, "volumeChart", {
        get: function () {
            return this.afd;
        },
        set: function (a) {
            var b = this.volumeChart;
            if (a != b) {
                this.afd = a;
                this.sw("VolumeChart", b, this.volumeChart);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.alq = function () {
        if (this.dataChart == null) {
            return;
        }
        this.volumeChart.series.clear();
        var a = new List$1(Series.$, 0);
        var b = -1;
        for (var c = 0; c < this.dataChart.series.count; c++) {
            var d = this.dataChart.series._inner[c];
            if (this.afx(d) || d.dd) {
                continue;
            }
            b++;
            var e = void 0;
            var f = this.ad7;
            f = this.ad6(f);
            switch (f) {
                case 2:
                    e = this.ae8();
                    break;
                case 3:
                    e = this.ae6();
                    break;
                default:
                case 1:
                    e = this.ae7();
                    break;
            }
            this.aeo.setCategoryMode(e, 1);
            e.name = "volumeSeries_" + b;
            e.itemsSource = d.itemsSource;
            this.aeo.setXAxis(e, this.volumeXAxis);
            this.aeo.setYAxis(e, this.volumeAxis);
            this.aeo.setValueMemberPath(e, this.bd != null && this.bd.dataSeries != null && this.bd.dataSeries.count > b ? this.bd.dataSeries._inner[b].getMemberPathFor(15) : null);
            e.title = d.title + " Volume";
            e.o9 = ArrayExtension.getModulus$1(Brush.$, this.adf, b);
            e.pe = ArrayExtension.getModulus$1(Brush.$, this.adg, b);
            e.g4 = this.ag9;
            a.add(e);
        }
        var g = this.gn("volume", false);
        if (g != null) {
            a.o(g);
        }
        for (var h = 0; h < a.count; h++) {
            var i = a._inner[h];
            this.volumeChart.series.add(i);
            this.sa(i, h);
        }
    };
    FinancialChart.prototype.afu = function (a) {
        if (!this.afq) {
            return false;
        }
        return this.aeo.matchesType(a);
    };
    FinancialChart.prototype.afy = function (a) {
        if (!this.aft) {
            return false;
        }
        return this.aem.matchesType(a);
    };
    FinancialChart.prototype.afv = function (a) {
        if (!this.afr) {
            return false;
        }
        return this.aeq.matchesType(a);
    };
    FinancialChart.prototype.afx = function (a) {
        if (!this.afs) {
            return false;
        }
        return this.aev.matchesType(a);
    };
    FinancialChart.prototype.alp = function () {
        if (this.dataChart == null) {
            return;
        }
        var a = 0;
        var b = this.aeg == null ? 0 : this.aeg.count;
        var c = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        var d = b + c;
        for (var e = 0; e < d; e++) {
            var f = new List$1(Series.$, 0);
            var g = this.indicatorCharts._inner[e];
            var h = e >= b;
            var i = h ? this.customIndicatorNames._inner[e - b] : EnumUtil.getName(FinancialIndicatorType_$type, this.aeg._inner[e]);
            var j = -1;
            for (var k = 0; k < this.dataChart.series.count; k++) {
                var l = this.dataChart.series._inner[k];
                if (this.afx(l) || l.dd) {
                    continue;
                }
                j++;
                var m = void 0;
                if (h) {
                    var n = this.afa("Custom");
                    this.aeq.handleCustomIndicatorEvent(n, runOn(this, this.ak3));
                    m = n;
                }
                else {
                    m = this.afc(this.aeg._inner[e]);
                }
                if (m == null) {
                    continue;
                }
                m.name = "indicator_" + a++;
                this.aeq.setXAxis(m, this.agg._inner[e]);
                this.aeq.setYAxis(m, this.age._inner[e]);
                m.itemsSource = l.itemsSource;
                this.aeq.setOpenMemberPath(m, this.bd.dataSeries._inner[j].getMemberPathFor(11));
                this.aeq.setHighMemberPath(m, this.bd.dataSeries._inner[j].getMemberPathFor(12));
                this.aeq.setLowMemberPath(m, this.bd.dataSeries._inner[j].getMemberPathFor(13));
                this.aeq.setCloseMemberPath(m, this.bd.dataSeries._inner[j].getMemberPathFor(14));
                this.aeq.setVolumeMemberPath(m, this.bd.dataSeries._inner[j].getMemberPathFor(15));
                m.title = l.title + " " + i;
                m.o9 = ArrayExtension.getModulus$1(Brush.$, this.ac9, e);
                m.g4 = this.ag5;
                if (this.afv(m)) {
                    this.aeq.setNegativeBrush(m, ArrayExtension.getModulus$1(Brush.$, this.ada, e));
                    this.aeq.setDisplayType(m, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.aes, e));
                }
                if (this.ah0 != -2147483648 && this.afv(m)) {
                    this.aeq.setPeriodOverride(m, this.ah0);
                }
                if (this.afv(m)) {
                    this.aeq.setSmoothingPeriod(m, this.ah3);
                }
                if (this.afv(m)) {
                    this.aeq.setSignalPeriod(m, this.ah2);
                }
                if (this.afv(m)) {
                    this.aeq.setShortPeriod(m, this.ah1);
                    this.aeq.setLongPeriod(m, this.ahz);
                }
                this.sa(m, e);
                f.add(m);
            }
            var o = this.gn(i, false);
            for (var p = 0; p < f.count; p++) {
                var q = f._inner[p];
                g.series.add(q);
            }
            if (o != null) {
                for (var r = 0; r < o.count; r++) {
                    var s = o._inner[r];
                    g.series.add(s);
                    this.sa(s, r);
                }
            }
        }
    };
    FinancialChart.prototype.afa = function (indicatorName_) {
        return (this.externalObject.createIndicator(indicatorName_ + 'Indicator').i);
    };
    FinancialChart.prototype.afc = function (a) {
        return this.afa(EnumUtil.getName(FinancialIndicatorType_$type, a));
    };
    FinancialChart.prototype.al7 = function (a) {
        if (this.ad0 == null) {
            return;
        }
        var b = this.xAxis;
        if (b.actualMinimumValue > b.actualMaximumValue) {
            return;
        }
        this.ad0.as = b.actualMinimumValue;
        this.ad0.ar = b.actualMaximumValue;
        if (a) {
            this.ad0.au = b.visibleMinimum;
            this.ad0.at = b.visibleMaximum;
        }
        this.ad0.bn();
    };
    FinancialChart.prototype.j9 = function () {
        var e_6, _a, e_7, _b;
        var _this = this;
        var a = ((function () {
            var $ret = new FinancialChartVisualData();
            $ret.mainChart = _super.prototype.j9.call(_this);
            $ret.volumeChart = _this.volumeChart == null ? null : _this.volumeChart.v6();
            $ret.toolbar = _this.ad0 == null ? null : _this.ad0.aj();
            $ret.zoomChart = _this.zoomSliderChart == null ? null : _this.zoomSliderChart.v6();
            return $ret;
        })());
        if (this.indicatorCharts != null) {
            a.indicatorCharts = new List$1(Base.$, 0);
            try {
                for (var _c = __values(fromEnum(this.indicatorCharts)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var b = _d.value;
                    a.indicatorCharts.add1(b.v6());
                }
            }
            catch (e_6_1) {
                e_6 = { error: e_6_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_6)
                        throw e_6.error;
                }
            }
        }
        if (this.dataChart != null) {
            a.mainChartLeft = this.amg(this.dataChart).x;
            a.mainChartTop = this.amg(this.dataChart).y;
        }
        if (this.volumeChart != null) {
            a.volumeChartLeft = this.amg(this.volumeChart).x;
            a.volumeChartTop = this.amg(this.volumeChart).y;
        }
        if (this.zoomSliderChart != null) {
            a.zoomChartLeft = this.amg(this.zoomSliderChart).x;
            a.zoomChartTop = this.amg(this.zoomSliderChart).y;
        }
        if (this.ad0 != null) {
            var c = this.amh(this.ad0);
            a.toolbarLeft = c.left;
            a.toolbarTop = c.top;
            a.toolbarWidth = c.width;
            a.toolbarHeight = c.height;
        }
        if (this.indicatorCharts != null) {
            a.indicatorChartLefts = new List$1(Number_$type, 0);
            a.indicatorChartTops = new List$1(Number_$type, 0);
            try {
                for (var _e = __values(fromEnum(this.indicatorCharts)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var d = _f.value;
                    a.indicatorChartLefts.add(this.amg(d).x);
                    a.indicatorChartTops.add(this.amg(d).y);
                }
            }
            catch (e_7_1) {
                e_7 = { error: e_7_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_7)
                        throw e_7.error;
                }
            }
        }
        var e = this.amj();
        a.legendLeft = e.left;
        a.legendTop = e.top;
        a.legendWidth = e.width;
        a.legendHeight = e.height;
        a.legend = this.aek == null ? null : this.aek.exportVisualData();
        return a;
    };
    FinancialChart.prototype.aip = function () {
        var a = this.j9();
        a.scaleByViewport();
        return a.serialize();
    };
    FinancialChart.prototype.afb = function (overlayName_) {
        return (this.externalObject.createOverlay(overlayName_ + 'Overlay').i);
    };
    FinancialChart.prototype.al6 = function () {
        var e_8, _a, e_9, _b;
        if (this.dataChart == null) {
            return;
        }
        var a = new List$1(Series.$, 0);
        try {
            for (var _c = __values(fromEnum(this.dataChart.series)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var b = _d.value;
                if (this.afx(b)) {
                    a.add(b);
                }
            }
        }
        catch (e_8_1) {
            e_8 = { error: e_8_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_8)
                    throw e_8.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(a)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var c = _f.value;
                this.dataChart.series.remove(c);
            }
        }
        catch (e_9_1) {
            e_9 = { error: e_9_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_9)
                    throw e_9.error;
            }
        }
        if (this.aei == null) {
            return;
        }
        var d = new List$1(Series.$, 0);
        var e = -1;
        for (var f = 0; f < this.dataChart.series.count; f++) {
            var g = this.dataChart.series._inner[f];
            if (this.afx(g) || g.dd) {
                continue;
            }
            e++;
            for (var h = 0; h < this.aei.count; h++) {
                var i = this.aei._inner[h];
                var j = void 0;
                switch (i) {
                    case 1:
                        j = this.afb(EnumUtil.getName(FinancialOverlayType_$type, i));
                        break;
                    default:
                    case 0:
                        j = this.afb(EnumUtil.getName(FinancialOverlayType_$type, i));
                        break;
                }
                j.name = g.name + "_" + EnumUtil.getName(FinancialOverlayType_$type, i);
                this.aev.setXAxis(j, this.xAxis);
                this.aev.setYAxis(j, this.yAxis);
                j.itemsSource = g.itemsSource;
                var k = e * this.aei.count + h;
                j.o9 = ArrayExtension.getModulus$1(Brush.$, this.add, k);
                j.pe = ArrayExtension.getModulus$1(Brush.$, this.ade, k);
                j.g4 = this.ag7;
                j.title = g.title + " " + EnumUtil.getName(FinancialOverlayType_$type, i);
                var l = g;
                if (l == null) {
                    continue;
                }
                var m = this.bd.dataSeries._inner[e];
                this.aev.setOpenMemberPath(j, m.getMemberPathFor(11));
                this.aev.setHighMemberPath(j, m.getMemberPathFor(12));
                this.aev.setLowMemberPath(j, m.getMemberPathFor(13));
                this.aev.setCloseMemberPath(j, m.getMemberPathFor(14));
                this.aev.setVolumeMemberPath(j, m.getMemberPathFor(15));
                d.add(j);
            }
        }
        var n = new Array(this.dataChart.series.count);
        this.dataChart.series.copyTo(n, 0);
        this.dataChart.skipDataCleanup = true;
        this.dataChart.series.clear();
        this.dataChart.skipDataCleanup = false;
        for (var o = 0; o < n.length; o++) {
            n[o].index = -1;
        }
        d.o(n);
        for (var p = 0; p < d.count; p++) {
            var q = d._inner[p];
            this.dataChart.series.add(q);
            this.sa(q, p);
        }
    };
    FinancialChart.prototype.al4 = function () {
        var e_10, _a;
        if (this.af3) {
            return;
        }
        this.af3 = true;
        if (this.indicatorCharts != null) {
            var a = this.indicatorCharts;
            this.indicatorCharts = null;
            try {
                for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    this.alk(b);
                }
            }
            catch (e_10_1) {
                e_10 = { error: e_10_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_10)
                        throw e_10.error;
                }
            }
        }
        if ((this.aeg == null || this.aeg.count == 0) && (this.customIndicatorNames == null || this.customIndicatorNames.count == 0)) {
            this.indicatorCharts = null;
            if (this.age != null) {
                this.age.clear();
            }
            if (this.agg != null) {
                this.agg.clear();
            }
            this.alv();
            this.al5();
            this.af3 = false;
            return;
        }
        if (this.indicatorCharts == null) {
            this.indicatorCharts = new List$1(XamDataChart.$, 0);
        }
        this.indicatorCharts.clear();
        this.age.clear();
        this.agg.clear();
        var c = this.aeg == null ? 0 : this.aeg.count;
        var d = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        var e = c + d;
        for (var f = 0; f < e; f++) {
            var g = new XamDataChart();
            this.indicatorCharts.add(g);
            this.ali(g);
            var h = f >= c;
            if (h) {
                g.kk = this.customIndicatorNames._inner[f - c];
            }
            else {
                g.kk = this.air(this.aeg._inner[f]);
            }
            if (this.indicatorAxis != null) {
                var i = void 0;
                var j = void 0;
                if (f == 0) {
                    i = this.indicatorAxis;
                    j = this.indicatorXAxis;
                }
                else {
                    i = new NumericYAxis();
                    if (!this.indicatorXAxis.ce) {
                        j = this.adm(0);
                    }
                    else {
                        j = this.adm(1);
                    }
                }
                j.name = "indicatorXAxis_" + f;
                i.name = "indicatorAxis_" + f;
                g.axes.add(i);
                g.axes.add(j);
                this.age.add(i);
                this.agg.add(j);
                if (this.fi) {
                    this.abd(i);
                }
                if (this.fi) {
                    this.abb(j);
                }
            }
        }
        this.alp();
        this.alv();
        if (this.ad0 != null) {
            this.ad0.ae = this.aeg;
        }
        this.akt();
        this.al5();
        this.af3 = false;
    };
    FinancialChart.prototype.r2 = function () {
        var e_11, _a, e_12, _b;
        _super.prototype.r2.call(this);
        this.abb(this.xAxis);
        this.abb(this.volumeXAxis);
        if (this.agg != null) {
            try {
                for (var _c = __values(fromEnum(this.agg)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var a = _d.value;
                    this.abb(a);
                }
            }
            catch (e_11_1) {
                e_11 = { error: e_11_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_11)
                        throw e_11.error;
                }
            }
        }
        this.abd(this.yAxis);
        this.abd(this.volumeAxis);
        if (this.age != null) {
            try {
                for (var _e = __values(fromEnum(this.age)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var b = _f.value;
                    this.abd(b);
                }
            }
            catch (e_12_1) {
                e_12 = { error: e_12_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_12)
                        throw e_12.error;
                }
            }
        }
        this.abb(this.zoomSliderXAxis);
        this.abd(this.zoomSliderAxis);
    };
    FinancialChart.prototype.get_f8 = function () {
        return !this.af1;
    };
    Object.defineProperty(FinancialChart.prototype, "af9", {
        get: function () {
            return (this.externalObject._dynamicContent);
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.amc = function (a, b) {
        this.aly(a, b);
        this.akt();
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.axes.add(this.zoomSliderAxis);
            this.zoomSliderChart.axes.add(this.zoomSliderXAxis);
        }
        this.alr();
        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
        this.alw();
        this.amd(a, b);
    };
    FinancialChart.prototype.alr = function () {
        if (this.dataChart == null || this.zoomSliderChart == null) {
            return;
        }
        this.zoomSliderChart.series.clear();
        var a = new List$1(Series.$, 0);
        for (var b = 0; b < this.dataChart.series.count; b++) {
            var c = this.dataChart.series._inner[b];
            if (this.afx(c) || c.dd) {
                continue;
            }
            var d = void 0;
            var e = this.aee;
            e = this.aed(e);
            var f = this.ahy(c, b);
            if (e == 1) {
                switch (this.ad4(this.bd != null && this.bd.dataSeries != null && this.bd.dataSeries.count > f ? this.bd.dataSeries._inner[f] : null)) {
                    case 1:
                        e = 2;
                        break;
                    case 2:
                        e = 3;
                        break;
                    case 3:
                        e = 4;
                        break;
                    case 4:
                        e = 5;
                        break;
                }
            }
            switch (e) {
                case 2:
                    d = this.ae9();
                    this.aem.setDisplayType(d, 1);
                    break;
                case 3:
                    d = this.ae9();
                    this.aem.setDisplayType(d, 0);
                    break;
                case 5:
                    d = this.ae8();
                    break;
                case 6:
                    d = this.ae6();
                    break;
                default:
                case 4:
                    d = this.ae7();
                    break;
            }
            var g = this.bd != null && this.bd.dataSeries != null && this.bd.dataSeries.count > f ? this.bd.dataSeries._inner[f] : null;
            if (d.dj && !d.ds) {
                this.aeo.setCategoryMode(d, 1);
                this.aeo.setXAxis(d, this.zoomSliderXAxis);
                this.aeo.setYAxis(d, this.zoomSliderAxis);
                this.aeo.setValueMemberPath(d, g == null ? null : this.ais(g));
            }
            else if (d.ds) {
                this.aem.setCategoryMode(d, 1);
                this.aem.setXAxis(d, this.zoomSliderXAxis);
                this.aem.setYAxis(d, this.zoomSliderAxis);
                if (g != null) {
                    this.aem.setOpenMemberPath(d, g.getMemberPathFor(11));
                    this.aem.setHighMemberPath(d, g.getMemberPathFor(12));
                    this.aem.setLowMemberPath(d, g.getMemberPathFor(13));
                    this.aem.setCloseMemberPath(d, g.getMemberPathFor(14));
                    this.aem.setVolumeMemberPath(d, g.getMemberPathFor(15));
                }
            }
            d.name = "zoomSliderSeries_" + f;
            d.itemsSource = c.itemsSource;
            d.title = c.title;
            d.g4 = this.i1;
            a.add(d);
        }
        for (var h = 0; h < a.count; h++) {
            var i = a._inner[h];
            this.zoomSliderChart.series.add(i);
            this.sa(i, h);
        }
    };
    FinancialChart.prototype.sq = function (a, b, c) {
        var e_13, _a;
        _super.prototype.sq.call(this, a, b, c);
        if (a == null || !b) {
            return;
        }
        var d = true;
        var e = true;
        switch (c) {
            case "Brushes":
            case "Outlines":
                d = e = false;
                break;
        }
        if (this.indicatorCharts != null && d) {
            try {
                for (var _b = __values(fromEnum(this.indicatorCharts)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var f = _c.value;
                    a(f);
                }
            }
            catch (e_13_1) {
                e_13 = { error: e_13_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_13)
                        throw e_13.error;
                }
            }
        }
        if (this.volumeChart != null && e) {
            a(this.volumeChart);
        }
        if (this.zoomSliderChart != null) {
            a(this.zoomSliderChart);
        }
    };
    FinancialChart.prototype.ak3 = function (a, b) {
        var c = b;
        var d = a;
        var e = -1;
        if (this.indicatorCharts != null) {
            e = this.indicatorCharts.indexOf(d.cc);
        }
        e -= this.aeg == null ? 0 : this.aeg.count;
        if (this.applyCustomIndicators != null) {
            this.applyCustomIndicators(this, new FinancialChartCustomIndicatorArgs(c, d, e));
        }
    };
    FinancialChart.prototype.al0 = function (a, b, c) {
        if (a != null) {
            if (b != null) {
                a.axes.remove(b);
            }
            a.axes.add(c);
        }
        if (this.fi) {
            this.abb(c);
        }
    };
    Object.defineProperty(FinancialChart.prototype, "af8", {
        get: function () {
            return TypeRegistrar.isRegistered("IgxZoomSliderComponent");
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.ak4 = function (a, b) {
        this.al4();
    };
    FinancialChart.prototype.afz = function (a, b) {
        if (b <= (0)) {
            return false;
        }
        switch (a) {
            case 5: return true;
            case 4:
            case 3: return b >= timeSpanFromDays(365);
            case 2: return b >= timeSpanFromDays(180);
            case 1: return b >= timeSpanFromDays(90);
            case 0: return b >= timeSpanFromDays(30);
        }
        return false;
    };
    FinancialChart.prototype.alu = function () {
        var e_14, _a;
        var a = this.ady != null ? this.ady : new FinancialChartRangeSelectorOptionCollection(1, [5, 4, 3, 2, 1, 0]);
        var b = new FinancialChartRangeSelectorOptionCollection(0);
        var c = this.xAxis;
        var d = +(c.actualMaximumValue) - +(c.actualMinimumValue);
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                if (this.afz(e, d)) {
                    b.add(e);
                }
            }
        }
        catch (e_14_1) {
            e_14 = { error: e_14_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_14)
                    throw e_14.error;
            }
        }
        this.adx = b;
        if (this.ad0 != null) {
            this.ad0.u = this.adx;
        }
    };
    FinancialChart.prototype.ak8 = function (a, b) {
        this.alu();
    };
    FinancialChart.prototype.ald = function (a, b) {
        this.aei = this.ad0.ag;
    };
    FinancialChart.prototype.alc = function (a, b) {
        this.aeg = this.ad0.ae;
    };
    FinancialChart.prototype.ak6 = function (a, b) {
        this.al4();
    };
    FinancialChart.prototype.ak7 = function (a, b) {
        this.al6();
    };
    FinancialChart.prototype.alh = function (a, b) {
        var c = a;
        if (c.bg == null) {
            return;
        }
        if (this.af1) {
            this.alt(c.bg);
        }
    };
    FinancialChart.prototype.alk = function (a) {
        SyncManager.e(a);
        a.axes.clear();
        a.series.clear();
        a.gridAreaRectChanged = delegateRemove(a.gridAreaRectChanged, runOn(this, this.ak5));
        a.provideContainer(null);
        if (this.volumeChart == null && this.indicatorCharts == null) {
            this.yAxis.es = this.volumeAxis.es = this.indicatorAxis.es = 0;
            this.xAxis.az.visibility = this.acz;
        }
    };
    FinancialChart.prototype.ali = function (a) {
        var b = a != this.zoomSliderChart;
        if (b) {
            if (this.dataChart != null) {
                a.tz = new Rect(0, this.dataChart.tj.x, a.tz.y, this.dataChart.tj.width, a.tz.height);
            }
            var c = ((function () {
                var $ret = new SyncSettings();
                $ret.syncChannel = "one";
                $ret.synchronizeHorizontally = true;
                $ret.synchronizeVertically = false;
                return $ret;
            })());
            SyncManager.d(a, c);
            SyncManager.c(a);
        }
        a.gridAreaRectChanged = delegateCombine(a.gridAreaRectChanged, runOn(this, this.ak5));
        this.r4(a);
    };
    FinancialChart.prototype.akt = function () {
        if (this.indicatorCharts != null || this.volumeChart != null) {
            this.aa9(this.xAxis, function (a) { return a.visibility = 1; });
        }
        var _loop_1 = function (a) {
            var b = this_1.agg._inner[a];
            var c = a < this_1.agg.count - 1 || this_1.volumeChart != null;
            this_1.aa9(b, function (d) { return d.visibility = c ? 1 : 0; });
        };
        var this_1 = this;
        for (var a = 0; a < this.agg.count; a++) {
            _loop_1(a);
        }
    };
    FinancialChart.prototype.aly = function (a, b) {
        if (a != null) {
            this.alk(a);
        }
        if (b != null) {
            this.ali(b);
        }
    };
    FinancialChart.prototype.ama = function (a, b) {
        this.aly(a, b);
        this.akt();
        if (this.volumeChart != null) {
            if (this.volumeAxis != null) {
                this.volumeChart.axes.add(this.volumeAxis);
                this.volumeChart.axes.add(this.volumeXAxis);
            }
            this.alq();
            this.volumeXAxis.itemsSource = this.xAxis.itemsSource;
        }
        this.amb(a, b);
    };
    FinancialChart.prototype.ak9 = function (a, b) {
        this.al8();
    };
    FinancialChart.prototype.al8 = function () {
        if (this.ad0 == null || +(this.ad0.au) == +(dateMaxValue()) || +(this.ad0.at) == +(dateMinValue()) || this.dataChart == null) {
            return;
        }
        var a = this.xAxis;
        var b = a.getWindowRectForSelection(this.ad0.au, this.ad0.at);
        if (b.width == 0 || isNaN_(b.width) || isInfinity(b.width)) {
            return;
        }
        this.af2 = true;
        this.dataChart.tz = new Rect(0, b.left, this.dataChart.tz.top, b.width, this.dataChart.tz.height);
        if (this.afi != null) {
            this.afi.windowRect = this.dataChart.tj;
        }
        if (this.af1) {
            this.alt(this.dataChart);
        }
        this.af2 = false;
    };
    FinancialChart.prototype.alg = function (a, b) {
        this.alu();
        this.al7(!this.af2);
    };
    FinancialChart.prototype.ak2 = function (a, b) {
        var _this = this;
        if (!this.af2) {
            if (this.af1) {
                this.alt(a);
            }
            var c = false;
            var d = this.s3(function () { return _this.al7(true); }, c);
            c = d.p1;
            if (this.afi != null) {
                this.afi.windowRect = this.dataChart.tj;
            }
        }
    };
    FinancialChart.prototype.al2 = function (a, b, c, d) {
        var e_15, _a;
        if (a == null || b == null) {
            return;
        }
        if (c != -1) {
            this.af2 = true;
            a.tz = new Rect(0, d, a.tj.top, c, a.tj.height);
            this.af2 = false;
        }
        var e = 1.7976931348623157E+308;
        var f = -1.7976931348623157E+308;
        var g = new Rect(0, 0, 0, 1, 1);
        var h = new ScalerParams(0, g, g, this.yAxis.ch, a.tn);
        try {
            for (var _b = __values(fromEnum(a.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var i = _c.value;
                h.b = i.gg();
                var j = i.ar(a.tj);
                var k = j == null || j.c == 1.7976931348623157E+308 || isNaN_(j.c);
                if (k) {
                    continue;
                }
                var l = b.ej(j.c, h);
                var m = b.ej(j.b, h);
                f = Math.max(f, l);
                e = Math.min(e, m);
            }
        }
        catch (e_15_1) {
            e_15 = { error: e_15_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_15)
                    throw e_15.error;
            }
        }
        var n = a.tj.width;
        if (c != -1) {
            n = c;
        }
        var o = a.tj.left;
        if (d != -1) {
            o = d;
        }
        if (e == 1.7976931348623157E+308 || f == -1.7976931348623157E+308 || isNaN_(e) || isNaN_(f)) {
            return;
        }
        this.af2 = true;
        var p = new Rect(0, o, e, n, f - e);
        a.tz = p;
        this.af2 = false;
    };
    FinancialChart.prototype.al1 = function (a) {
        if (a == null) {
            return;
        }
        if (a == this.dataChart) {
            this.al2(this.dataChart, this.yAxis, -1, -1);
            if (this.volumeChart != null) {
                this.al2(this.volumeChart, this.volumeAxis, this.dataChart.tj.width, this.dataChart.tj.left);
            }
        }
        else if (a == this.volumeChart) {
            this.al2(this.volumeChart, this.volumeAxis, -1, -1);
            this.al2(this.dataChart, this.yAxis, this.volumeChart.tj.width, this.volumeChart.tj.left);
        }
    };
    FinancialChart.prototype.alt = function (a) {
        var _this = this;
        this.s2(function () { return _this.al1(a); });
    };
    FinancialChart.prototype.ala = function (a, b) {
        if (this.af1) {
            this.alt(a);
        }
    };
    FinancialChart.prototype.al9 = function () {
        if (!this.af9) {
            return;
        }
        this.akw();
        if (this.aee == 0) {
            this.zoomSliderChart = null;
        }
        else if (this.zoomSliderChart == null) {
            this.zoomSliderChart = ((function () {
                var $ret = new XamDataChart();
                $ret.name = "ZoomSliderChart";
                return $ret;
            })());
        }
        else {
            this.alr();
        }
    };
    FinancialChart.prototype.akw = function () {
        var container_ = this.ahq.rootWrapper.getNativeElement();
        var containerParent_ = container_.parentElement;
        if (this.afi != null && containerParent_ != null && !this.aga) {
            this.aga = true;
            if (TypeRegistrar.isRegistered("IgxZoomSliderComponent")) {
                var z_ = this.afi;
                var f_ = this.externalObject;
                var sliderComponent_ = TypeRegistrar.get("IgxZoomSliderComponent");
                var sliderInstance_ = TypeRegistrar.create("IgxZoomSliderComponent");
                sliderInstance_._implementation = z_;
                sliderComponent_._staticStyling(container_, sliderInstance_, f_);
            }
        }
    };
    FinancialChart.prototype.al3 = function () {
        var _this = this;
        if (this.ad9 != 1) {
            return;
        }
        this.abf(function (a) {
            var e_16, _a;
            var b;
            b = a.breaks;
            b.clear();
            if (_this.xAxisBreaks == null) {
                return;
            }
            try {
                for (var _b = __values(fromEnum(_this.xAxisBreaks)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    b.add(c);
                }
            }
            catch (e_16_1) {
                e_16 = { error: e_16_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_16)
                        throw e_16.error;
                }
            }
        });
    };
    FinancialChart.prototype.to = function (a, b, c) {
        _super.prototype.to.call(this, a, b, c);
        if (this.bd.dataSeries.count > 0) {
            if (this.ad9 == 1 && stringIsNullOrEmpty(this.lm)) {
                this.b3.setXMemberPath(a, c.getMemberPathFor(17));
            }
            if (stringIsNullOrEmpty(this.lo)) {
                this.b3.setYMemberPath(a, this.ais(c));
            }
            if (stringIsNullOrEmpty(this.li)) {
                this.b3.setLabelMemberPath(a, this.ais(c));
            }
            if (stringIsNullOrEmpty(this.lf)) {
                this.b3.setContentMemberPath(a, this.ais(c));
            }
        }
    };
    FinancialChart.prototype.air = function (a) {
        switch (a) {
            case 0: return "Absolute Volume Oscillator";
            case 1: return "Accumulation/Distribution Indicator";
            case 2: return "Average Directional Index";
            case 3: return "Average True Range Indicator";
            case 4: return "Bollinger Bandwidth";
            case 5: return "Chaikin Oscillator";
            case 6: return "Chaikin Volatility Indicator";
            case 7: return "Commodity Channel Index";
            case 8: return "Detrended Price Oscillator";
            case 9: return "Ease of Movement Indicator";
            case 10: return "Fast Stochastic Oscillator";
            case 11: return "Force Index Indicator";
            case 12: return "Full Stochastic Oscillator";
            case 13: return "Market Facilitation Index";
            case 14: return "Mass Index Indicator";
            case 15: return "Median Price Indicator";
            case 16: return "Money Flow Index";
            case 17: return "MACD Indicator";
            case 18: return "Negative Volume Index";
            case 19: return "On Balance Volume Indicator";
            case 20: return "Percentage Price Oscillator";
            case 21: return "Percentage Volume Oscillator";
            case 22: return "Positive Volume Index";
            case 23: return "Price Volume Trend";
            case 24: return "ROC - Rate of Change Indicator";
            case 25: return "RSI - Relative Strength Index";
            case 26: return "Slow Stochastic Oscillator";
            case 27: return "Standard Deviation Indicator";
            case 28: return "Stoch RSI";
            case 29: return "TRIX Indicator";
            case 30: return "Typical Price Indicator";
            case 31: return "Ultimate Oscillator";
            case 32: return "Weighted Close Indicator";
            case 33: return "Williams %R Indicator";
            default: return "Unknown";
        }
    };
    FinancialChart.prototype.abb = function (a) {
        var e_17, _a;
        var _this = this;
        _super.prototype.abb.call(this, a);
        var b = a;
        this.alj(b);
        if (a.bg != null) {
            try {
                for (var _b = __values(fromEnum(a.bg.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    if (this.afu(c)) {
                        this.aeo.setXAxis(c, b);
                    }
                    else if (this.afy(c)) {
                        this.aem.setXAxis(c, b);
                    }
                    else if (this.afv(c)) {
                        this.aeq.setXAxis(c, b);
                    }
                    else if (this.afx(c)) {
                        this.aev.setXAxis(c, b);
                    }
                }
            }
            catch (e_17_1) {
                e_17 = { error: e_17_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_17)
                        throw e_17.error;
                }
            }
        }
        this.aln(function (d) {
            d.zoomMaximumCategoryRange = _this.aha;
            d.zoomMaximumItemSpan = _this.ahb;
            d.zoomToCategoryRange = _this.ahc;
            d.zoomToCategoryStart = _this.ahd;
            d.zoomToItemSpan = _this.ahe;
        });
        var d = a == this.zoomSliderXAxis;
        if (d) {
            a.jw = this.amf;
            a.er = this.ahl;
            this.aa9(a, function (e) { return e.visibility = 1; });
        }
        var e = a;
        e.minimumValue = this.agm;
        e.maximumValue = this.agl;
        a.b1 = this.af4;
    };
    FinancialChart.prototype.abd = function (a) {
        var e_18, _a;
        _super.prototype.abd.call(this, a);
        if (a.bg != null && a == this.yAxis) {
            try {
                for (var _b = __values(fromEnum(a.bg.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    if (this.afu(b)) {
                        this.aeo.setYAxis(b, this.yAxis);
                    }
                    else if (this.afy(b)) {
                        this.aem.setYAxis(b, this.yAxis);
                    }
                    else if (this.afv(b)) {
                        this.aeq.setYAxis(b, this.yAxis);
                    }
                    else if (this.afx(b)) {
                        this.aev.setYAxis(b, this.yAxis);
                    }
                }
            }
            catch (e_18_1) {
                e_18 = { error: e_18_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_18)
                        throw e_18.error;
                }
            }
        }
        a.la = this.af5;
        a.l5 = this.ahj;
        a.l4 = this.ahi;
        if (a == this.yAxis) {
            a.l1 = this.ahh;
        }
        var c = a == this.zoomSliderAxis;
        if (c) {
            this.aa9(a, function (d) { return d.visibility = 1; });
        }
        a.b1 = this.af6;
    };
    FinancialChart.prototype.alj = function (a) {
        a.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
        a.f0 = XYChart.yy(a, this.bd.dataSeries);
        if (this.bd.dataSeries.count > 0) {
            var b = this.bd.dataSeries._inner[0].getMemberPathFor(17);
            a.hy(b);
        }
    };
    FinancialChart.prototype.sa = function (a, b) {
        _super.prototype.sa.call(this, a, b);
        if (a == null) {
            return;
        }
        var c = this.zoomSliderChart == a.cc;
        var d = this.dataChart != null && this.dataChart.series.contains(a);
        if ((d || c) && a.d6) {
            a.ms(this.adb != null ? ArrayExtension.getModulus$1(Brush.$, this.adb, b) : null, this.adc != null ? ArrayExtension.getModulus$1(Brush.$, this.adc, b) : null);
        }
        var e = this.afv(a);
        if (this.afx(a)) {
            a.o9 = this.add != null ? ArrayExtension.getModulus$1(Brush.$, this.add, b) : null;
            a.pe = this.ade != null ? ArrayExtension.getModulus$1(Brush.$, this.ade, b) : null;
            a.g4 = this.ag7;
        }
        else if (e) {
            a.o9 = this.ac9 != null ? ArrayExtension.getModulus$1(Brush.$, this.ac9, b) : null;
            a.g4 = this.ag5;
        }
        else if (!a.dd && (d || c)) {
            a.o9 = this.ab != null ? ArrayExtension.getModulus$1(Brush.$, this.ab, b) : null;
            a.pe = this.af != null ? ArrayExtension.getModulus$1(Brush.$, this.af, b) : null;
        }
        var f = this.volumeChart != null && this.volumeChart == a.cc;
        if (f) {
            a.g4 = this.ag9;
        }
        a.legend = c || f || e || !a.isUsableInLegend ? null : this.legend != null ? this.legend : this.afw ? this.aek : null;
    };
    FinancialChart.prototype.sw = function (a, b, c) {
        var e_19, _a, e_20, _b;
        var _this = this;
        _super.prototype.sw.call(this, a, b, c);
        switch (a) {
            case "YAxisIsLogarithmic":
                this.yAxis.li = this.af7;
                if (this.volumeAxis != null) {
                    this.volumeAxis.li = this.af7;
                }
                if (this.zoomSliderAxis != null) {
                    this.zoomSliderAxis.li = this.af7;
                }
                break;
            case "YAxisLogarithmBase":
                this.yAxis.l9 = this.ah5;
                if (this.volumeAxis != null) {
                    this.volumeAxis.l9 = this.ah5;
                }
                if (this.zoomSliderAxis != null) {
                    this.zoomSliderAxis.l9 = this.ah5;
                }
                break;
            case "VolumeType":
                var d = EnumUtil.getEnumValue(FinancialChartVolumeType_$type, b);
                if (this.ad7 == 0) {
                    this.volumeChart = null;
                }
                else if (this.volumeChart == null) {
                    this.volumeChart = ((function () {
                        var $ret = new XamDataChart();
                        $ret.name = "VolumeChart";
                        return $ret;
                    })());
                }
                else {
                    this.alq();
                }
                break;
            case "VolumeChart":
                this.ama(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "DataChart":
                if (typeCast(XamDataChart.$, b) !== null) {
                    var e = b;
                    e.gridAreaRectChanged = delegateRemove(e.gridAreaRectChanged, runOn(this, this.ak5));
                    e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, runOn(this, this.ak2));
                    e.seriesDataUpdated = delegateRemove(e.seriesDataUpdated, runOn(this, this.ala));
                }
                if (this.dataChart != null) {
                    var f = this.dataChart;
                    f.gridAreaRectChanged = delegateCombine(f.gridAreaRectChanged, runOn(this, this.ak5));
                    var g = this.dataChart;
                    g.actualWindowRectChanged = delegateCombine(g.actualWindowRectChanged, runOn(this, this.ak2));
                    var h = this.dataChart;
                    h.seriesDataUpdated = delegateCombine(h.seriesDataUpdated, runOn(this, this.ala));
                }
                this.al9();
                break;
            case "XAxisMode":
                this.xAxis = this.adm(this.ad9);
                this.xAxis.name = "xAxis";
                this.volumeXAxis = this.adm(this.ad9);
                this.volumeXAxis.name = "volumeXAxis";
                this.indicatorXAxis = this.adm(this.ad9);
                this.indicatorXAxis.name = "indicatorXAxis_0";
                this.zoomSliderXAxis = this.adm(this.ad9);
                this.zoomSliderXAxis.name = "zoomSliderXAxis";
                this.aa9(this.zoomSliderXAxis, function (i) { return i.visibility = 1; });
                this.akt();
                if (this.ad9 == 1) {
                    this.al3();
                }
                break;
            case "YAxisMode":
                this.yAxis = this.ae0(this.aeb);
                this.yAxis.name = "yAxis";
                this.zoomSliderAxis = this.ae0(this.aeb);
                this.zoomSliderAxis.name = "zoomSliderAxis";
                this.volumeAxis = this.ae0(this.aeb);
                this.volumeAxis.name = "volumeAxis";
                break;
            case "Toolbar":
                var i = typeCast(FinancialChartToolbar.$, b);
                if (i != null) {
                    i.rangeChanged = delegateRemove(i.rangeChanged, runOn(this, this.ak9));
                    i.indicatorTypesChanged = delegateRemove(i.indicatorTypesChanged, runOn(this, this.alc));
                    i.overlayTypesChanged = delegateRemove(i.overlayTypesChanged, runOn(this, this.ald));
                }
                if (this.ad0 != null) {
                    this.ad0.ae = this.aeg;
                    this.ad0.ag = this.aei;
                    this.ad0.u = this.adx;
                    this.al7(true);
                    var j = this.ad0;
                    j.rangeChanged = delegateCombine(j.rangeChanged, runOn(this, this.ak9));
                    var k = this.ad0;
                    k.indicatorTypesChanged = delegateCombine(k.indicatorTypesChanged, runOn(this, this.alc));
                    var l = this.ad0;
                    l.overlayTypesChanged = delegateCombine(l.overlayTypesChanged, runOn(this, this.ald));
                }
                break;
            case "XAxis":
                var m = typeCast(CategoryAxisBase.$, b);
                if (m != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(m);
                    }
                }
                var n = typeCast(ITimeRangeSelectorAxis_$type, b);
                if (n != null) {
                    n.visibleRangeChanged = delegateRemove(n.visibleRangeChanged, runOn(this, this.alg));
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.xAxis);
                }
                if (this.fi) {
                    this.abb(this.xAxis);
                    this.rs();
                }
                this.al7(false);
                this.al8();
                this.alu();
                var o = this.xAxis;
                o.visibleRangeChanged = delegateCombine(o.visibleRangeChanged, runOn(this, this.alg));
                break;
            case "XAxisZoomMaximumCategoryRange":
                this.aln(function (p) { return p.zoomMaximumCategoryRange = _this.aha; });
                break;
            case "XAxisZoomMaximumItemSpan":
                this.aln(function (p) { return p.zoomMaximumItemSpan = _this.ahb; });
                break;
            case "XAxisZoomToCategoryRange":
                this.aln(function (p) { return p.zoomToCategoryRange = _this.ahc; });
                break;
            case "XAxisZoomToCategoryStart":
                this.aln(function (p) { return p.zoomToCategoryStart = _this.ahd; });
                break;
            case "XAxisZoomToItemSpan":
                this.aln(function (p) { return p.zoomToItemSpan = _this.ahe; });
                break;
            case "ChartType":
                this.ti();
                break;
            case "VolumeXAxis":
                this.al0(this.volumeChart, typeCast(Axis.$, b), this.volumeXAxis);
                break;
            case "ZoomSliderXAxis":
                this.al0(this.zoomSliderChart, typeCast(Axis.$, b), this.zoomSliderXAxis);
                break;
            case "IndicatorXAxis":
                this.al4();
                break;
            case "YAxis":
                var p = typeCast(NumericYAxis.$, b);
                if (p != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(p);
                    }
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.yAxis);
                }
                if (this.fi) {
                    this.abd(this.yAxis);
                    this.abd(this.yAxis);
                }
                var q = this.yAxis;
                q.rangeChanged = delegateCombine(q.rangeChanged, runOn(this, this.alh));
                break;
            case "VolumeAxis":
                var r = typeCast(Axis.$, b);
                if (this.volumeChart != null && r != null) {
                    this.volumeChart.axes.remove(r);
                }
                if (this.volumeChart != null && this.volumeAxis != null) {
                    this.volumeChart.axes.add(this.volumeAxis);
                    this.alq();
                }
                if (this.fi) {
                    this.abd(this.volumeAxis);
                }
                var s = this.volumeAxis;
                s.rangeChanged = delegateCombine(s.rangeChanged, runOn(this, this.alh));
                break;
            case "IndicatorAxis":
                if (this.indicatorCharts != null) {
                    for (var t = 0; t < this.indicatorCharts.count; t++) {
                        var u = this.indicatorCharts._inner[t];
                        var v = new List$1(Axis.$, 0);
                        try {
                            for (var _c = (e_19 = void 0, __values(fromEnum(u.axes))), _d = _c.next(); !_d.done; _d = _c.next()) {
                                var w = _d.value;
                                if (typeCast(NumericYAxis.$, w) !== null) {
                                    v.add(w);
                                }
                            }
                        }
                        catch (e_19_1) {
                            e_19 = { error: e_19_1 };
                        }
                        finally {
                            try {
                                if (_d && !_d.done && (_a = _c.return))
                                    _a.call(_c);
                            }
                            finally {
                                if (e_19)
                                    throw e_19.error;
                            }
                        }
                        try {
                            for (var _e = (e_20 = void 0, __values(fromEnum(v))), _f = _e.next(); !_f.done; _f = _e.next()) {
                                var x = _f.value;
                                u.axes.remove(x);
                            }
                        }
                        catch (e_20_1) {
                            e_20 = { error: e_20_1 };
                        }
                        finally {
                            try {
                                if (_f && !_f.done && (_b = _e.return))
                                    _b.call(_e);
                            }
                            finally {
                                if (e_20)
                                    throw e_20.error;
                            }
                        }
                        var y = null;
                        if (t == 0) {
                            y = this.indicatorAxis;
                        }
                        else if (this.aeb == 1) {
                            y = this.ae0(this.aeb);
                        }
                        else if (typeCast(NumericYAxis.$, this.indicatorAxis) !== null) {
                            y = new NumericYAxis();
                        }
                        if (y != null) {
                            u.axes.add(y);
                        }
                        if (this.fi) {
                            this.abd(y);
                        }
                    }
                }
                break;
            case "IsWindowSyncedToVisibleRange":
                if (this.dataChart != null) {
                    this.dataChart.ux = this.f9 && this.f8;
                }
                if (this.volumeChart != null) {
                    this.volumeChart.ux = this.f9 && this.f8;
                }
                if (this.af1) {
                    this.al1(this.dataChart);
                }
                else {
                    this.volumeChart.v4 = 1;
                }
                break;
            case "IndicatorTypes":
                var z = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), b);
                if (z != null) {
                    z.collectionChanged = delegateRemove(z.collectionChanged, runOn(this, this.ak6));
                }
                var aa = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), c);
                if (aa != null) {
                    aa.collectionChanged = delegateCombine(aa.collectionChanged, runOn(this, this.ak6));
                }
                this.al4();
                break;
            case "OverlayTypes":
                var ab = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), b);
                if (ab != null) {
                    ab.collectionChanged = delegateRemove(ab.collectionChanged, runOn(this, this.ak7));
                }
                var ac = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), c);
                if (ac != null) {
                    ac.collectionChanged = delegateCombine(ac.collectionChanged, runOn(this, this.ak7));
                }
                this.al6();
                break;
            case "YAxisAbbreviateLargeNumbers":
                this.abk(function (ad) { return ad.la = _this.af5; });
                break;
            case "YAxisMinimumValue":
                this.abl(function (ad) { return ad.l5 = _this.ahj; }, false);
                break;
            case "YAxisMaximumValue":
                this.abl(function (ad) { return ad.l4 = _this.ahi; }, false);
                break;
            case "YAxisInterval":
                this.abl(function (ad) { return ad.l1 = _this.ahh; }, false);
                break;
            case "Thickness":
            case "ZoomSliderType":
                this.al9();
                break;
            case "ZoomSliderChart":
                if (!this.af8) {
                    return;
                }
                this.amc(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "NegativeBrushes":
            case "NegativeOutlines":
                this.akz(function (ad, ae) {
                    if (ad.d6) {
                        ad.ms(_this.adb != null ? ArrayExtension.getModulus$1(Brush.$, _this.adb, ae) : null, _this.adc != null ? ArrayExtension.getModulus$1(Brush.$, _this.adc, ae) : null);
                    }
                }, true);
                break;
            case "OverlayBrushes":
                this.aky(function (ad, ae) { return ad.o9 = _this.add != null ? ArrayExtension.getModulus$1(Brush.$, _this.add, ae) : null; });
                break;
            case "OverlayOutlines":
                this.aky(function (ad, ae) { return ad.pe = _this.ade != null ? ArrayExtension.getModulus$1(Brush.$, _this.ade, ae) : null; });
                break;
            case "OverlayThickness":
                this.aky(function (ad, ae) { return ad.g4 = _this.ag7; });
                break;
            case "OverlayMultiplier":
                this.aky(function (ad, ae) { return _this.aev.setMultiplier(ad, _this.ag6); });
                break;
            case "VolumeBrushes":
                this.ak0(function (ad, ae) { return ad.o9 = ArrayExtension.getModulus$1(Brush.$, _this.adf, ae); });
                break;
            case "VolumeOutlines":
                this.ak0(function (ad, ae) { return ad.pe = ArrayExtension.getModulus$1(Brush.$, _this.adg, ae); });
                break;
            case "VolumeThickness":
                this.ak0(function (ad, ae) { return ad.g4 = _this.ag9; });
                break;
            case "IndicatorNegativeBrushes":
                this.akx(function (ad, ae) { return _this.aeq.setNegativeBrush(ad, ArrayExtension.getModulus$1(Brush.$, _this.ada, ae)); });
                break;
            case "IndicatorBrushes":
                this.akx(function (ad, ae) { return ad.o9 = ArrayExtension.getModulus$1(Brush.$, _this.ac9, ae); });
                break;
            case "IndicatorThickness":
                this.akx(function (ad, ae) { return ad.g4 = _this.ag5; });
                break;
            case "IndicatorDisplayTypes":
                this.akx(function (ad, ae) { return _this.aeq.setDisplayType(ad, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, _this.aes, ae)); });
                break;
            case "IndicatorPeriod":
                this.akx(function (ad, ae) {
                    if (_this.ah0 == -2147483648) {
                        return;
                    }
                    _this.aeq.setPeriodOverride(ad, _this.ah0);
                });
                break;
            case "IndicatorMultiplier":
                this.akx(function (ad, ae) { return _this.aeq.setMultiplier(ad, _this.ag4); });
                break;
            case "IndicatorSmoothingPeriod":
                this.akx(function (ad, ae) { return _this.aeq.setSmoothingPeriod(ad, _this.ah3); });
                break;
            case "IndicatorShortPeriod":
                this.akx(function (ad, ae) { return _this.aeq.setShortPeriod(ad, _this.ah1); });
                break;
            case "IndicatorLongPeriod":
                this.akx(function (ad, ae) { return _this.aeq.setLongPeriod(ad, _this.ahz); });
                break;
            case "IndicatorSignalPeriod":
                this.akx(function (ad, ae) { return _this.aeq.setSignalPeriod(ad, _this.ah2); });
                break;
            case "RangeSelectorOptions":
                var ad = typeCast(FinancialChartRangeSelectorOptionCollection.$, b);
                if (ad != null) {
                    ad.collectionChanged = delegateRemove(ad.collectionChanged, runOn(this, this.ak8));
                }
                if (this.ady != null) {
                    var ae = this.ady;
                    ae.collectionChanged = delegateCombine(ae.collectionChanged, runOn(this, this.ak8));
                }
                this.alu();
                break;
            case "CustomIndicatorNames":
                var af = typeCast(ObservableCollection$1.$.specialize(String_$type), b);
                if (af != null) {
                    af.collectionChanged = delegateRemove(af.collectionChanged, runOn(this, this.ak4));
                }
                if (this.customIndicatorNames != null) {
                    var ag = this.customIndicatorNames;
                    ag.collectionChanged = delegateCombine(ag.collectionChanged, runOn(this, this.ak4));
                }
                this.al4();
                break;
            case "Legend":
                if (this.zoomSliderChart != null) {
                    this.zoomSliderChart.legend = null;
                }
                break;
            case "Brushes":
                this.akz(function (ah, ai) { return ah.o9 = _this.ab != null ? ArrayExtension.getModulus$1(Brush.$, _this.ab, ai) : null; }, true);
                break;
            case "Outlines":
                this.akz(function (ah, ai) { return ah.pe = _this.af != null ? ArrayExtension.getModulus$1(Brush.$, _this.af, ai) : null; }, true);
                break;
            case "XAxisLabelVisibility":
                if (this.acz == 0 && this.zoomSliderXAxis != null) {
                    this.aa9(this.zoomSliderXAxis, function (ah) { return ah.visibility = 1; });
                }
                this.akt();
                break;
            case "YAxisLabelVisibility":
                if (this.ac0 != 0 || this.zoomSliderAxis == null) {
                    break;
                }
                this.aa9(this.zoomSliderAxis, function (ah) { return ah.visibility = 1; });
                break;
            case "ZoomSliderXAxisMajorStroke":
                this.zoomSliderXAxis.jw = this.amf;
                break;
            case "ZoomSliderXAxisMajorStrokeThickness":
                this.zoomSliderXAxis.er = this.ahl;
                break;
            case "FinancialChartLegend":
            case "IsLegendVisible":
                var ah_1 = this.afw && this.legend == null;
                {
                    var ai = function (aj, ak) {
                        if (aj.isUsableInLegend) {
                            aj.legend = ah_1 ? _this.aek : null;
                        }
                    };
                    this.akz(ai, false);
                    this.aky(ai);
                }
                break;
            case "ZoomSliderAxis":
                var aj = typeCast(Axis.$, b);
                if (aj != null && this.zoomSliderChart != null) {
                    this.zoomSliderChart.axes.remove(aj);
                }
                if (this.zoomSliderAxis != null) {
                    if (this.zoomSliderChart != null) {
                        this.zoomSliderChart.axes.add(this.zoomSliderAxis);
                        this.alr();
                        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
                    }
                    if (this.fi) {
                        this.abd(this.zoomSliderAxis);
                    }
                    this.aa9(this.zoomSliderAxis, function (ak) { return ak.visibility = 1; });
                }
                break;
            case "XAxisMinimumValue":
                this.abf(function (ak) {
                    var al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                    if (al != null) {
                        al.minimumValue = _this.agm;
                    }
                });
                break;
            case "XAxisMaximumValue":
                this.abf(function (ak) {
                    var al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                    if (al != null) {
                        al.maximumValue = _this.agl;
                    }
                });
                break;
            case FinancialChart.aj0:
                this.abg(function (ak) { return ak.b1 = _this.af4; }, a);
                break;
            case FinancialChart.akb:
                this.abk(function (ak) { return ak.b1 = _this.af6; });
                break;
        }
    };
    FinancialChart.prototype.get_b1 = function () {
        return 1;
    };
    Object.defineProperty(FinancialChart.prototype, "b1", {
        get: function () {
            return this.get_b1();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "af7", {
        get: function () {
            return this.afp;
        },
        set: function (a) {
            var b = this.af7;
            if (a != b) {
                this.afp = a;
                this.sw("YAxisIsLogarithmic", b, this.af7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ah5", {
        get: function () {
            return this.ahx;
        },
        set: function (a) {
            var b = this.ah5;
            if (a != b) {
                this.ahx = a;
                this.sw("YAxisLogarithmBase", b, this.ah5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahh", {
        get: function () {
            return this.agy;
        },
        set: function (a) {
            var b = this.ahh;
            if (a != b) {
                this.agy = a;
                this.sw("YAxisInterval", b, this.ahh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahj", {
        get: function () {
            return this.ag0;
        },
        set: function (a) {
            var b = this.ahj;
            if (a != b) {
                this.ag0 = a;
                this.sw("YAxisMinimumValue", b, this.ahj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahi", {
        get: function () {
            return this.agz;
        },
        set: function (a) {
            var b = this.ahi;
            if (a != b) {
                this.agz = a;
                this.sw("YAxisMaximumValue", b, this.ahi);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahk", {
        get: function () {
            return this.ag1;
        },
        set: function (a) {
            var b = this.ahk;
            if (a != b) {
                this.ag1 = a;
                this.sw("YAxisMinorInterval", b, this.ahk);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahg", {
        get: function () {
            return this.yAxis.lx;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahf", {
        get: function () {
            return this.yAxis.lw;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ad7", {
        get: function () {
            return this.ad5;
        },
        set: function (a) {
            var b = this.ad7;
            if (a != b) {
                this.ad5 = a;
                this.sw("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.ad7));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ad9", {
        get: function () {
            return this.ad8;
        },
        set: function (a) {
            var b = this.ad9;
            if (a != b) {
                this.ad8 = a;
                this.sw("XAxisMode", enumGetBox(FinancialChartXAxisMode_$type, b), enumGetBox(FinancialChartXAxisMode_$type, this.ad9));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aha", {
        get: function () {
            return this.agt;
        },
        set: function (a) {
            var b = this.aha;
            if (a != b) {
                this.agt = a;
                this.sw("XAxisZoomMaximumCategoryRange", b, this.aha);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahd", {
        get: function () {
            return this.agw;
        },
        set: function (a) {
            var b = this.ahd;
            if (a != b) {
                this.agw = a;
                this.sw("XAxisZoomToCategoryStart", b, this.ahd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahb", {
        get: function () {
            return this.agu;
        },
        set: function (a) {
            var b = this.ahb;
            if (a != b) {
                this.agu = a;
                this.sw("XAxisZoomMaximumItemSpan", b, this.ahb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahc", {
        get: function () {
            return this.agv;
        },
        set: function (a) {
            var b = this.ahc;
            if (a != b) {
                this.agv = a;
                this.sw("XAxisZoomToCategoryRange", b, this.ahc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahe", {
        get: function () {
            return this.agx;
        },
        set: function (a) {
            var b = this.ahe;
            if (a != b) {
                this.agx = a;
                this.sw("XAxisZoomToItemSpan", b, this.ahe);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aeb", {
        get: function () {
            return this.aea;
        },
        set: function (a) {
            var b = this.aeb;
            if (a != b) {
                this.aea = a;
                this.sw("YAxisMode", enumGetBox(FinancialChartYAxisMode_$type, b), enumGetBox(FinancialChartYAxisMode_$type, this.aeb));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "af0", {
        get: function () {
            return this.afk;
        },
        set: function (a) {
            var b = this.af0;
            if (a != b) {
                this.afk = a;
                this.sw("IsToolbarVisible", b, this.af0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ad2", {
        get: function () {
            return this.ad1;
        },
        set: function (a) {
            var b = this.ad2;
            if (a != b) {
                this.ad1 = a;
                this.sw("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.ad2));
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_abu = function () {
        return _super.prototype.get_abu.call(this);
    };
    FinancialChart.prototype.set_abu = function (a) {
        _super.prototype.set_abu.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "af1", {
        get: function () {
            return this.afl;
        },
        set: function (a) {
            var b = this.af1;
            if (a != b) {
                this.afl = a;
                this.sw("IsWindowSyncedToVisibleRange", b, this.af1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aeg", {
        get: function () {
            return this.aef;
        },
        set: function (a) {
            var b = this.aeg;
            if (a != b) {
                this.aef = a;
                this.sw("IndicatorTypes", b, this.aeg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aei", {
        get: function () {
            return this.aeh;
        },
        set: function (a) {
            var b = this.aei;
            if (a != b) {
                this.aeh = a;
                this.sw("OverlayTypes", b, this.aei);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorCharts", {
        get: function () {
            return this.agc;
        },
        set: function (a) {
            var b = this.indicatorCharts;
            if (a != b) {
                this.agc = a;
                this.sw("IndicatorCharts", b, this.indicatorCharts);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "af5", {
        get: function () {
            return this.afn;
        },
        set: function (a) {
            var b = this.af5;
            if (a != b) {
                this.afn = a;
                this.sw("YAxisAbbreviateLargeNumbers", b, this.af5);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_iv = function () {
        return _super.prototype.get_iv.call(this);
    };
    FinancialChart.prototype.set_iv = function (a) {
        _super.prototype.set_iv.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "af4", {
        get: function () {
            return this.afm;
        },
        set: function (a) {
            var b = this.af4;
            if (a != b) {
                this.afm = a;
                this.sw(FinancialChart.aj0, b, this.af4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "af6", {
        get: function () {
            return this.afo;
        },
        set: function (a) {
            var b = this.af6;
            if (a != b) {
                this.afo = a;
                this.sw(FinancialChart.akb, b, this.af6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderChart", {
        get: function () {
            return this.afe;
        },
        set: function (a) {
            var b = this.zoomSliderChart;
            if (a != b) {
                this.afe = a;
                this.sw("ZoomSliderChart", b, this.zoomSliderChart);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderAxis", {
        get: function () {
            return this.aez;
        },
        set: function (a) {
            var b = this.zoomSliderAxis;
            if (a != b) {
                this.aez = a;
                this.sw("ZoomSliderAxis", b, this.zoomSliderAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderXAxis", {
        get: function () {
            return this.adk;
        },
        set: function (a) {
            var b = this.zoomSliderXAxis;
            if (a != b) {
                this.adk = a;
                this.sw("ZoomSliderXAxis", b, this.zoomSliderXAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aee", {
        get: function () {
            return this.aec;
        },
        set: function (a) {
            var b = this.aee;
            if (a != b) {
                this.aec = a;
                this.sw("ZoomSliderType", enumGetBox(FinancialChartZoomSliderType_$type, b), enumGetBox(FinancialChartZoomSliderType_$type, this.aee));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "adb", {
        get: function () {
            return this.ac3;
        },
        set: function (a) {
            var b = this.adb;
            if (a != b) {
                this.ac3 = a;
                this.sw("NegativeBrushes", b, this.adb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "adc", {
        get: function () {
            return this.ac4;
        },
        set: function (a) {
            var b = this.adc;
            if (a != b) {
                this.ac4 = a;
                this.sw("NegativeOutlines", b, this.adc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "add", {
        get: function () {
            return this.ac5;
        },
        set: function (a) {
            var b = this.add;
            if (a != b) {
                this.ac5 = a;
                this.sw("OverlayBrushes", b, this.add);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ade", {
        get: function () {
            return this.ac6;
        },
        set: function (a) {
            var b = this.ade;
            if (a != b) {
                this.ac6 = a;
                this.sw("OverlayOutlines", b, this.ade);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "adg", {
        get: function () {
            return this.ac8;
        },
        set: function (a) {
            var b = this.adg;
            if (a != b) {
                this.ac8 = a;
                this.sw("VolumeOutlines", b, this.adg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "adf", {
        get: function () {
            return this.ac7;
        },
        set: function (a) {
            var b = this.adf;
            if (a != b) {
                this.ac7 = a;
                this.sw("VolumeBrushes", b, this.adf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ada", {
        get: function () {
            return this.ac2;
        },
        set: function (a) {
            var b = this.ada;
            if (a != b) {
                this.ac2 = a;
                this.sw("IndicatorNegativeBrushes", b, this.ada);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ac9", {
        get: function () {
            return this.ac1;
        },
        set: function (a) {
            var b = this.ac9;
            if (a != b) {
                this.ac1 = a;
                this.sw("IndicatorBrushes", b, this.ac9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ag9", {
        get: function () {
            return this.ags;
        },
        set: function (a) {
            var b = this.ag9;
            if (a != b) {
                this.ags = a;
                this.sw("VolumeThickness", b, this.ag9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ag7", {
        get: function () {
            return this.agq;
        },
        set: function (a) {
            var b = this.ag7;
            if (a != b) {
                this.agq = a;
                this.sw("OverlayThickness", b, this.ag7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ag6", {
        get: function () {
            return this.agp;
        },
        set: function (a) {
            var b = this.ag6;
            if (a != b) {
                this.agp = a;
                this.sw("OverlayMultiplier", b, this.ag6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ag5", {
        get: function () {
            return this.ago;
        },
        set: function (a) {
            var b = this.ag5;
            if (a != b) {
                this.ago = a;
                this.sw("IndicatorThickness", b, this.ag5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aes", {
        get: function () {
            return this.aer;
        },
        set: function (a) {
            var b = this.aes;
            if (a != b) {
                this.aer = a;
                this.sw("IndicatorDisplayTypes", b, this.aes);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ah0", {
        get: function () {
            return this.aht;
        },
        set: function (a) {
            var b = this.ah0;
            if (a != b) {
                this.aht = a;
                this.sw("IndicatorPeriod", b, this.ah0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ag4", {
        get: function () {
            return this.agn;
        },
        set: function (a) {
            var b = this.ag4;
            if (a != b) {
                this.agn = a;
                this.sw("IndicatorMultiplier", b, this.ag4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ah3", {
        get: function () {
            return this.ahw;
        },
        set: function (a) {
            var b = this.ah3;
            if (a != b) {
                this.ahw = a;
                this.sw("IndicatorSmoothingPeriod", b, this.ah3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ah1", {
        get: function () {
            return this.ahu;
        },
        set: function (a) {
            var b = this.ah1;
            if (a != b) {
                this.ahu = a;
                this.sw("IndicatorShortPeriod", b, this.ah1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahz", {
        get: function () {
            return this.ahs;
        },
        set: function (a) {
            var b = this.ahz;
            if (a != b) {
                this.ahs = a;
                this.sw("IndicatorLongPeriod", b, this.ahz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ah2", {
        get: function () {
            return this.ahv;
        },
        set: function (a) {
            var b = this.ah2;
            if (a != b) {
                this.ahv = a;
                this.sw("IndicatorSignalPeriod", b, this.ah2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ady", {
        get: function () {
            return this.adw;
        },
        set: function (a) {
            var b = this.ady;
            if (a != b) {
                this.adw = a;
                this.sw("RangeSelectorOptions", b, this.ady);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "customIndicatorNames", {
        get: function () {
            return this.ads;
        },
        set: function (a) {
            var b = this.ads;
            if (a != b) {
                this.ads = a;
                this.sw("CustomIndicatorNames", b, this.customIndicatorNames);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_f9 = function () {
        return _super.prototype.get_f9.call(this);
    };
    FinancialChart.prototype.set_f9 = function (a) {
        _super.prototype.set_f9.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "amf", {
        get: function () {
            return this.ame;
        },
        set: function (a) {
            var b = this.amf;
            if (a != b) {
                this.ame = a;
                this.sw("ZoomSliderXAxisMajorStroke", b, this.amf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahl", {
        get: function () {
            return this.ag2;
        },
        set: function (a) {
            var b = this.ahl;
            if (a != b) {
                this.ag2 = a;
                this.sw("ZoomSliderXAxisMajorStrokeThickness", b, this.ahl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "afw", {
        get: function () {
            return this.afj;
        },
        set: function (a) {
            var b = this.afw;
            if (a != b) {
                this.afj = a;
                this.sw("IsLegendVisible", b, this.afw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aek", {
        get: function () {
            return this.aej;
        },
        set: function (a) {
            var b = this.aek;
            if (a != b) {
                this.aej = a;
                this.sw("FinancialChartLegend", b, this.aek);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "xAxis", {
        get: function () {
            return this.adj;
        },
        set: function (a) {
            var b = this.xAxis;
            if (a != b) {
                this.adj = a;
                this.sw("XAxis", b, this.xAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "yAxis", {
        get: function () {
            return this.aey;
        },
        set: function (a) {
            var b = this.yAxis;
            if (a != b) {
                this.aey = a;
                this.sw("YAxis", b, this.yAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "volumeAxis", {
        get: function () {
            return this.aex;
        },
        set: function (a) {
            var b = this.volumeAxis;
            if (a != b) {
                this.aex = a;
                this.sw("VolumeAxis", b, this.volumeAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "volumeXAxis", {
        get: function () {
            return this.adi;
        },
        set: function (a) {
            var b = this.volumeXAxis;
            if (a != b) {
                this.adi = a;
                this.sw("VolumeXAxis", b, this.volumeXAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorAxis", {
        get: function () {
            return this.aew;
        },
        set: function (a) {
            var b = this.indicatorAxis;
            if (a != b) {
                this.aew = a;
                this.sw("IndicatorAxis", b, this.indicatorAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorXAxis", {
        get: function () {
            return this.adh;
        },
        set: function (a) {
            var b = this.indicatorXAxis;
            if (a != b) {
                this.adh = a;
                this.sw("IndicatorXAxis", b, this.indicatorXAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "age", {
        get: function () {
            return this.agb;
        },
        set: function (a) {
            var b = this.age;
            if (a != b) {
                this.agb = a;
                this.sw("IndicatorAxes", b, this.age);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "agg", {
        get: function () {
            return this.agd;
        },
        set: function (a) {
            var b = this.agg;
            if (a != b) {
                this.agd = a;
                this.sw("IndicatorXAxes", b, this.agg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "agm", {
        get: function () {
            return this.agk;
        },
        set: function (a) {
            var b = this.agm;
            if (+a != +b) {
                this.agk = a;
                this.sw("XAxisMinimumValue", b, this.agm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "agl", {
        get: function () {
            return this.agj;
        },
        set: function (a) {
            var b = this.agl;
            if (+a != +b) {
                this.agj = a;
                this.sw("XAxisMaximumValue", b, this.agl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "xAxisBreaks", {
        get: function () {
            return this.agh;
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.$t = markType(FinancialChart, 'FinancialChart', XYChart.$);
    FinancialChart.ah4 = 0;
    FinancialChart.aj0 = "XAxisEnhancedIntervalPreferMoreCategoryLabels";
    FinancialChart.akb = "YAxisEnhancedIntervalPreferMoreCategoryLabels";
    return FinancialChart;
}(XYChart));
export { FinancialChart };
/**
 * @hidden
 */
var FinancialChartToolbar = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartToolbar, _super);
    function FinancialChartToolbar(a, b) {
        var _this = _super.call(this, "financialChartToolbar", b, "") || this;
        _this.o = null;
        _this.r = null;
        _this.z = null;
        _this.p = null;
        _this.w = null;
        _this.aq = dateMaxValue();
        _this.ap = dateMinValue();
        _this.ao = dateMaxValue();
        _this.an = dateMinValue();
        _this.rangeChanged = null;
        _this.chartTypeChanged = null;
        _this.trendLineTypeChanged = null;
        _this.volumeTypeChanged = null;
        _this.indicatorTypesChanged = null;
        _this.overlayTypesChanged = null;
        _this.x = 0;
        _this.ah = 0;
        _this.ab = 0;
        _this.ad = null;
        _this.af = null;
        _this.t = null;
        _this.ak = false;
        _this.o = a;
        _this.w = new FinancialChartToolbarViewModel();
        _this.s = new FinancialChartRangeSelector(a != null ? a.aig : null);
        _this.aa = new FinancialChartTypePicker(a != null ? a.aid : null);
        _this.q = new FinancialChartIndicatorMenu(1, a != null ? a.aie : null);
        return _this;
    }
    FinancialChartToolbar.prototype.bg = function (a) {
        var b = a.querySelectorAll(".financialChartToolbarArea");
        if (b != null && b.length > 0) {
            this.g = b[0];
            if (!this.al) {
                this.g.hide();
            }
        }
        var c = a.querySelectorAll(".financialChartIndicatorMenu");
        if (c != null && c.length > 0) {
            this.q.g = c[0];
        }
        var d = a.querySelectorAll(".financialChartRangeSelector");
        if (d != null && d.length > 0) {
            this.s.g = d[0];
        }
        var e = a.querySelectorAll(".financialChartTypePicker");
        if (e != null && e.length > 0) {
            this.aa.g = e[0];
        }
    };
    FinancialChartToolbar.prototype.bl = function (a) {
        this.q.u(a);
        this.aa.u(a);
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "s", {
        get: function () {
            return this.r;
        },
        set: function (a) {
            var b = this.s;
            if (a != b) {
                this.r = a;
                this.bm("RangeSelector", b, this.s);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "aa", {
        get: function () {
            return this.z;
        },
        set: function (a) {
            var b = this.aa;
            if (a != b) {
                this.z = a;
                this.bm("ChartTypePicker", b, this.aa);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "q", {
        get: function () {
            return this.p;
        },
        set: function (a) {
            var b = this.q;
            if (a != b) {
                this.p = a;
                this.bm("IndicatorMenu", b, this.q);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartToolbar.prototype.bm = function (a, b, c) {
        switch (a) {
            case "RangeStart":
                if (this.s != null) {
                    this.s.t = this.as;
                }
                break;
            case "RangeEnd":
                if (this.s != null) {
                    this.s.s = this.ar;
                }
                break;
            case "SelectionStart":
                if (this.s != null) {
                    this.s.v = this.au;
                }
                break;
            case "SelectionEnd":
                if (this.s != null) {
                    this.s.u = this.at;
                }
                break;
            case "RangeSelector":
                var d = b;
                if (d != null) {
                    d.rangeChanged = delegateRemove(d.rangeChanged, runOn(this, this.bj));
                }
                if (this.s != null) {
                    this.s.t = this.as;
                    this.s.s = this.ar;
                    this.s.o = this.u;
                    this.s.v = this.au;
                    this.s.u = this.at;
                    var e = this.s;
                    e.rangeChanged = delegateCombine(e.rangeChanged, runOn(this, this.bj));
                }
                break;
            case "ChartTypePicker":
                var f = b;
                if (f != null) {
                    f.selectionChanged = delegateRemove(f.selectionChanged, runOn(this, this.bi));
                }
                if (this.aa != null) {
                    this.aa.w = this.y;
                    var g = this.aa;
                    g.selectionChanged = delegateCombine(g.selectionChanged, runOn(this, this.bi));
                }
                break;
            case "ChartType":
                if (this.aa != null) {
                    this.aa.w = this.y;
                }
                break;
            case "RangeSelectorOptions":
                if (this.s != null) {
                    this.s.o = this.u;
                }
                break;
            case "IsToolbarVisible":
                if (this.g == null) {
                    break;
                }
                if (this.al) {
                    this.g.show();
                }
                else {
                    this.g.hide();
                }
                break;
            case "IndicatorMenu":
                var h = typeCast(FinancialChartIndicatorMenu.$, b);
                if (h != null) {
                    h.selectionChanged = delegateRemove(h.selectionChanged, runOn(this, this.bh));
                }
                if (this.q != null) {
                    var i = this.q;
                    i.selectionChanged = delegateCombine(i.selectionChanged, runOn(this, this.bh));
                }
                break;
            case "IndicatorTypes":
                if (this.indicatorTypesChanged != null) {
                    this.indicatorTypesChanged(this, EventArgs.empty);
                }
                break;
            case "OverlayTypes":
                if (this.overlayTypesChanged != null) {
                    this.overlayTypesChanged(this, EventArgs.empty);
                }
                break;
            case "TrendLineType":
                if (this.trendLineTypeChanged != null) {
                    this.trendLineTypeChanged(this, EventArgs.empty);
                }
                break;
            case "VolumeType":
                if (this.volumeTypeChanged != null) {
                    this.volumeTypeChanged(this, EventArgs.empty);
                }
                break;
        }
    };
    FinancialChartToolbar.prototype.bh = function (a, b) {
        this.ag = this.q.z;
        this.ae = this.q.y;
        this.ai = this.q.aa;
        this.ac = this.q.x;
    };
    FinancialChartToolbar.prototype.bi = function (a, b) {
        this.y = this.aa.w;
        if (this.chartTypeChanged != null) {
            this.chartTypeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.bj = function (a, b) {
        this.au = this.s.v;
        this.at = this.s.u;
        if (this.rangeChanged != null) {
            this.rangeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.v = function () {
        var _this = this;
        var a = new FinancialChartToolbarContext();
        a.container = this.d;
        a.vm = this.w;
        a.vm.financialChartIndicatorMenu = ((function () {
            var $ret = new FinancialChartIndicatorMenuContext();
            $ret.vm = _this.q.p;
            return $ret;
        })());
        a.vm.financialChartTypePicker = ((function () {
            var $ret = new FinancialChartTypePickerContext();
            $ret.vm = _this.aa.p;
            return $ret;
        })());
        a.vm.financialChartRangeSelector = ((function () {
            var $ret = new FinancialChartRangeSelectorContext();
            $ret.vm = _this.s.q;
            return $ret;
        })());
        return a;
    };
    FinancialChartToolbar.prototype.l = function (a) {
        _super.prototype.l.call(this, a);
        if (a == null) {
            return;
        }
        this.s.l(a);
        this.aa.l(a);
        this.q.l(a);
        this.bk();
    };
    FinancialChartToolbar.prototype.bk = function () {
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "au", {
        get: function () {
            return this.aq;
        },
        set: function (a) {
            var b = this.au;
            if (+a != +b) {
                this.aq = a;
                this.bm("SelectionStart", b, this.au);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "at", {
        get: function () {
            return this.ap;
        },
        set: function (a) {
            var b = this.at;
            if (+a != +b) {
                this.ap = a;
                this.bm("SelectionEnd", b, this.at);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "as", {
        get: function () {
            return this.ao;
        },
        set: function (a) {
            var b = this.as;
            if (+a != +b) {
                this.ao = a;
                this.bm("RangeStart", b, this.as);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ar", {
        get: function () {
            return this.an;
        },
        set: function (a) {
            var b = this.ar;
            if (+a != +b) {
                this.an = a;
                this.bm("RangeEnd", b, this.ar);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartToolbar.prototype.bn = function () {
        if (this.s != null) {
            this.s.ab();
        }
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "y", {
        get: function () {
            return this.x;
        },
        set: function (a) {
            var b = this.y;
            if (a != b) {
                this.x = a;
                this.bm("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.y));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ai", {
        get: function () {
            return this.ah;
        },
        set: function (a) {
            var b = this.ai;
            if (a != b) {
                this.ah = a;
                this.bm("TrendLineType", enumGetBox(TrendLineType_$type, b), enumGetBox(TrendLineType_$type, this.ai));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ac", {
        get: function () {
            return this.ab;
        },
        set: function (a) {
            var b = this.ac;
            if (a != b) {
                this.ab = a;
                this.bm("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.ac));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ae", {
        get: function () {
            return this.ad;
        },
        set: function (a) {
            var b = this.ae;
            if (!FinancialChartToolbar.am(b, a)) {
                this.ad = a;
                this.bm("IndicatorTypes", b, this.ae);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ag", {
        get: function () {
            return this.af;
        },
        set: function (a) {
            var b = this.ag;
            if (!FinancialChartToolbar.am(b, a)) {
                this.af = a;
                this.bm("OverlayTypes", b, this.ag);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartToolbar.am = function (a, b) {
        var e_21, _a;
        if (a == b) {
            return true;
        }
        if ((a == null && b != null) || (a != null && b == null)) {
            return false;
        }
        if (a.count != b.count) {
            return false;
        }
        try {
            for (var _b = __values(fromEn(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                if (!b.contains(c)) {
                    return false;
                }
            }
        }
        catch (e_21_1) {
            e_21 = { error: e_21_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_21)
                    throw e_21.error;
            }
        }
        return true;
    };
    FinancialChartToolbar.prototype.aj = function () {
        var _this = this;
        return ((function () {
            var $ret = new FinancialChartToolbarVisualData();
            $ret.rangeSelector = _this.s == null ? null : _this.s.r();
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "u", {
        get: function () {
            return this.t;
        },
        set: function (a) {
            var b = this.u;
            if (a != b) {
                this.t = a;
                this.bm("RangeSelectorOptions", b, this.u);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "al", {
        get: function () {
            return this.ak;
        },
        set: function (a) {
            var b = this.al;
            if (a != b) {
                this.ak = a;
                this.bm("IsToolbarVisible", b, this.al);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartToolbar.$t = markType(FinancialChartToolbar, 'FinancialChartToolbar', TemplatedHtmlControl.$);
    return FinancialChartToolbar;
}(TemplatedHtmlControl));
export { FinancialChartToolbar };
/**
 * @hidden
 */
var FinancialChartRangeSelector = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartRangeSelector, _super);
    function FinancialChartRangeSelector(a) {
        var _this = _super.call(this, "financialChartRangeSelector", a, "") || this;
        _this.q = null;
        _this.rangeChanged = null;
        _this.p = null;
        _this.p = new FinancialChartRangeSelectorView();
        _this.q = new FinancialChartRangeSelectorViewModel();
        _this.q.onRangeChanged = runOn(_this, _this.z);
        _this.p.c = _this.q;
        return _this;
    }
    Object.defineProperty(FinancialChartRangeSelector.prototype, "v", {
        get: function () {
            return this.q.selectionStart;
        },
        set: function (a) {
            this.q.selectionStart = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "u", {
        get: function () {
            return this.q.selectionEnd;
        },
        set: function (a) {
            this.q.selectionEnd = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "t", {
        get: function () {
            return this.q.rangeStart;
        },
        set: function (a) {
            this.q.rangeStart = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "s", {
        get: function () {
            return this.q.rangeEnd;
        },
        set: function (a) {
            this.q.rangeEnd = a;
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartRangeSelector.prototype.ab = function () {
        if (this.q.onPropertiesChanged()) {
            this.p.g(this.q);
        }
    };
    FinancialChartRangeSelector.prototype.l = function (a) {
        _super.prototype.l.call(this, a);
        this.p.f(this.d, this.q);
    };
    FinancialChartRangeSelector.prototype.z = function () {
        if (this.rangeChanged != null) {
            this.rangeChanged(this, EventArgs.empty);
        }
    };
    FinancialChartRangeSelector.prototype.r = function () {
        return this.p.d(this.g);
    };
    Object.defineProperty(FinancialChartRangeSelector.prototype, "o", {
        get: function () {
            return this.q.options;
        },
        set: function (a) {
            var b = !FinancialChartToolbar.am(this.q.options, a);
            if (b) {
                this.q.options = a;
                this.aa();
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartRangeSelector.prototype.aa = function () {
        if (this.q != null) {
            this.q.ao();
        }
        if (this.p != null) {
            this.p.i(this.o);
        }
    };
    FinancialChartRangeSelector.$t = markType(FinancialChartRangeSelector, 'FinancialChartRangeSelector', TemplatedHtmlControl.$);
    FinancialChartRangeSelector.x = 0;
    return FinancialChartRangeSelector;
}(TemplatedHtmlControl));
export { FinancialChartRangeSelector };
