import { AxisLabelPanelBase } from "./AxisLabelPanelBase";
import { Point, Type, IList$1 } from "igniteui-angular-core";
import { AxisLabelPanelBaseView } from "./AxisLabelPanelBaseView";
import { Rect } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { List$1 } from "igniteui-angular-core";
import { AxisLabelsLocation } from "./AxisLabelsLocation";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { IAngleScaler } from "./IAngleScaler";
import { CategoryAxisRenderer } from "./CategoryAxisRenderer";
import { DependencyProperty } from "igniteui-angular-core";
import { AxisOrientation } from "./AxisOrientation";
import { AxisView } from "./AxisView";
import { PolarAxisRenderingManager } from "./PolarAxisRenderingManager";
import { ScalerParams } from "./ScalerParams";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { Geometry } from "igniteui-angular-core";
import { NumericAxisBase } from "./NumericAxisBase";
import { NumericAxisRenderer } from "./NumericAxisRenderer";
import { NumericAxisRenderingParameters } from "./NumericAxisRenderingParameters";
import { GeometryGroup } from "igniteui-angular-core";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
import { NumericAxisBaseView } from "./NumericAxisBaseView";
/**
 * @hidden
 */
export declare class AngleAxisLabelPanel extends AxisLabelPanelBase {
    static $t: Type;
    ae(): AxisLabelPanelBaseView;
    ch(a: AxisLabelPanelBaseView): void;
    c9: AngleAxisLabelPanelView;
    constructor();
    da: boolean;
    dg: (arg1: number) => Point;
    at(a: number, b: Rect): boolean;
    de: number;
    db: number;
    dd: number;
    dc: number;
    a5(): List$1<Rect>;
    private df;
    ai(): AxisLabelsLocation;
    ay(a: AxisLabelsLocation): boolean;
}
/**
 * @hidden
 */
export declare class CategoryAngleAxis extends CategoryAxisBase implements IAngleScaler {
    static $t: Type;
    a4(): AxisView;
    hs(a: AxisView): void;
    mh: CategoryAngleAxisView;
    protected get_b9(): boolean;
    private mm;
    constructor();
    av(): AxisLabelPanelBase;
    mj: CategoryAxisRenderer;
    private mn;
    private m1;
    private mr;
    private mi;
    private ng;
    private mv;
    private mg;
    getMinMaxAngle(a: Rect, b: number, c: number): {
        p1: number;
        p2: number;
    };
    ac(): void;
    private mk;
    get ml(): NumericRadiusAxis;
    set ml(a: NumericRadiusAxis);
    ak(): Axis;
    m2: number;
    private ms;
    getCategorySize(a: Rect, b: Rect, c: Rect): number;
    k4(a: Rect, b: Rect, c: Rect): number;
    getGroupCenter(a: number, b: Rect, c: Rect, d: Rect): number;
    my(a: number): number;
    protected h9(a: boolean): void;
    mx(a: Rect, b: Rect): number;
    mw(a: Rect, b: Rect): number;
    getScaledAngle(a: number): number;
    getUnscaledAngle(a: number): number;
    ej(a: number, b: ScalerParams): number;
    em(a: number, b: ScalerParams): number;
    protected hw(a: any, b: string, c: any, d: any): void;
    private na;
    nc(a: NumericRadiusAxis): void;
    static readonly nd: DependencyProperty;
    get mz(): number;
    set mz(a: number);
    private mp;
    get mt(): number;
    set mt(a: number);
    ev(): number;
    static readonly ne: DependencyProperty;
    get m0(): number;
    set m0(a: number);
    private mq;
    get mu(): number;
    set mu(a: number);
    protected mo(): boolean;
    protected get_a2(): AxisOrientation;
    get a2(): AxisOrientation;
    c3(): boolean;
    private m3;
    get m4(): number;
    set m4(a: number);
    j5(a: number, b: Rect, c: Rect, d?: any, e?: any): Geometry;
    get isVertical(): boolean;
    j$d(a: number, b: ScalerParams): number;
    j$c(a: number, b: ScalerParams): number;
    j$e(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$g(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    get j$b(): boolean;
    j$a(): number[];
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class NumericAngleAxis extends NumericAxisBase implements IAngleScaler {
    static $t: Type;
    a4(): AxisView;
    hs(a: AxisView): void;
    nh: NumericAngleAxisView;
    nk: PolarAxisRenderingManager;
    protected get_b9(): boolean;
    constructor();
    av(): AxisLabelPanelBase;
    private no;
    private nq;
    private nl;
    private nm;
    ky(): NumericAxisRenderer;
    private nx;
    ej(a: number, b: ScalerParams): number;
    getScaledAngle1(a: number, b: boolean, c: boolean): number;
    getScaledAngle(a: number): number;
    em(a: number, b: ScalerParams): number;
    getUnscaledAngle(a: number): number;
    nr: number;
    private nn;
    protected hw(a: any, b: string, c: any, d: any): void;
    private nt;
    k2(): NumericAxisRenderingParameters;
    k1(a: Rect, b: Rect, c: Rect, d: Rect): NumericAxisRenderingParameters;
    getMinMaxAngle(a: Rect, b: number, c: number): {
        p1: number;
        p2: number;
    };
    protected h9(a: boolean): void;
    private ni;
    get nj(): NumericRadiusAxis;
    set nj(a: NumericRadiusAxis);
    ak(): Axis;
    nv(a: NumericRadiusAxis): void;
    protected ip(a: Rect, b: Rect): void;
    protected get_a2(): AxisOrientation;
    get a2(): AxisOrientation;
    j5(a: number, b: Rect, c: Rect, d?: any, e?: any): Geometry;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class NumericRadiusAxis extends NumericAxisBase {
    static $t: Type;
    a4(): AxisView;
    hs(a: AxisView): void;
    nj: NumericRadiusAxisView;
    protected get_cm(): boolean;
    ei(): number;
    private ns;
    private nr;
    private nk;
    constructor();
    av(): AxisLabelPanelBase;
    nl: boolean;
    private np;
    private nm;
    ky(): NumericAxisRenderer;
    ej(a: number, b: ScalerParams): number;
    nv(a: number, b: boolean, c: boolean, d: number, e: number): number;
    nu(a: number): number;
    nw(a: number): number;
    em(a: number, b: ScalerParams): number;
    ny: number;
    no: number;
    nx: number;
    nn: number;
    protected hw(a: any, b: string, c: any, d: any): void;
    protected nq: number;
    n3(a: Axis): void;
    private nh;
    get ni(): Axis;
    set ni(a: Axis);
    ak(): Axis;
    k2(): NumericAxisRenderingParameters;
    k1(a: Rect, b: Rect, c: Rect, d: Rect): NumericAxisRenderingParameters;
    private n4;
    private nz;
    nt(): number;
    m2(a: AxisRangeChangedEventArgs): void;
    protected h9(a: boolean): void;
    protected ip(a: Rect, b: Rect): void;
    n2(a: GeometryGroup, b: Rect, c: Rect, d: Rect, e: Rect): void;
    protected get_a2(): AxisOrientation;
    get a2(): AxisOrientation;
    j5(a: number, b: Rect, c: Rect, d?: any, e?: any): Geometry;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AngleAxisLabelPanelView extends AxisLabelPanelBaseView {
    static $t: Type;
    protected az: AngleAxisLabelPanel;
    constructor(a: AngleAxisLabelPanel);
    an(): void;
    a0(a: List$1<Rect>, b: List$1<boolean>): void;
    o(): number;
    p(): number;
    q(): number;
    r(): number;
}
/**
 * @hidden
 */
export declare class CategoryAngleAxisView extends CategoryAxisBaseView {
    static $t: Type;
    protected bj: CategoryAngleAxis;
    constructor(a: CategoryAngleAxis);
    aj(): void;
}
/**
 * @hidden
 */
export declare class NumericAngleAxisView extends NumericAxisBaseView {
    static $t: Type;
    protected bj: NumericAngleAxis;
    constructor(a: NumericAngleAxis);
    aj(): void;
}
/**
 * @hidden
 */
export declare class NumericRadiusAxisView extends NumericAxisBaseView {
    static $t: Type;
    protected bj: NumericRadiusAxis;
    constructor(a: NumericRadiusAxis);
    aj(): void;
}
