import { Control } from "igniteui-angular-core";
import { INotifyPropertyChanged, Base, Type, Point, EventArgs, PropertyChangedEventArgs, IEnumerable, IEnumerable$1, IList$1 } from "igniteui-angular-core";
import { ILegendOwner } from "igniteui-angular-core";
import { IInternalLegendOwner } from "igniteui-angular-core";
import { IDataLegendTarget } from "igniteui-angular-core";
import { IToolbarTarget } from "igniteui-angular-core";
import { ISeriesViewerWidget } from "./ISeriesViewerWidget";
import { SRProvider } from "igniteui-angular-core";
import { ToolCommand } from "igniteui-angular-core";
import { SeriesPlotAreaMarginHorizontalMode } from "./SeriesPlotAreaMarginHorizontalMode";
import { SeriesPlotAreaMarginVerticalMode } from "./SeriesPlotAreaMarginVerticalMode";
import { SeriesViewerScrollbarMode } from "./SeriesViewerScrollbarMode";
import { DoubleAnimator } from "igniteui-angular-core";
import { BrushCollection } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { DependencyObject } from "igniteui-angular-core";
import { MarkerAutomaticBehavior } from "./MarkerAutomaticBehavior";
import { IChartLegend } from "igniteui-angular-core";
import { SeriesHighlightingMode } from "./SeriesHighlightingMode";
import { SeriesViewerHorizontalScrollbarPosition } from "./SeriesViewerHorizontalScrollbarPosition";
import { SeriesViewerVerticalScrollbarPosition } from "./SeriesViewerVerticalScrollbarPosition";
import { Brush } from "igniteui-angular-core";
import { SeriesHighlightingBehavior } from "./SeriesHighlightingBehavior";
import { LegendHighlightingMode } from "./LegendHighlightingMode";
import { LegendItemBadgeShape } from "igniteui-angular-core";
import { LegendItemBadgeMode } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { ChartHitTestMode } from "./ChartHitTestMode";
import { InteractionState } from "igniteui-angular-core";
import { WindowResponse } from "./WindowResponse";
import { Visibility } from "igniteui-angular-core";
import { IOverviewPlusDetailPane } from "igniteui-angular-core";
import { SeriesViewerComponentsFromView } from "./SeriesViewerComponentsFromView";
import { ZoomCoercionMode } from "./ZoomCoercionMode";
import { ModifierKeys } from "igniteui-angular-core";
import { DataTemplate } from "igniteui-angular-core";
import { HorizontalAlignment } from "igniteui-angular-core";
import { CanvasRenderScheduler } from "igniteui-angular-core";
import { SyncSettings } from "./SyncSettings";
import { ToolActionInfo } from "igniteui-angular-core";
import { ToolCommandExecutionState } from "igniteui-angular-core";
import { ICommandAvailabilityListener } from "igniteui-angular-core";
import { ICommandStateChangedListener } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { SeriesViewerComponentsForView } from "./SeriesViewerComponentsForView";
import { Dictionary$2 } from "igniteui-angular-core";
import { IDataLegend } from "igniteui-angular-core";
import { PropertyUpdatedEventArgs } from "igniteui-angular-core";
import { NotifyCollectionChangedEventArgs } from "igniteui-angular-core";
import { ObservableCollection$1 } from "igniteui-angular-core";
import { Size } from "igniteui-angular-core";
import { FrameworkElement } from "igniteui-angular-core";
import { EventProxy } from "igniteui-angular-core";
import { MouseEventArgs } from "igniteui-angular-core";
import { MouseButtonEventArgs } from "igniteui-angular-core";
import { Tuple$2 } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { SeriesViewerManipulationEventArgs } from "./SeriesViewerManipulationEventArgs";
import { Key } from "igniteui-angular-core";
import { RectChangedEventArgs } from "igniteui-angular-core";
import { RefreshCompletedEventArgs } from "./RefreshCompletedEventArgs";
import { Thickness } from "igniteui-angular-core";
import { AxisTitlePosition } from "./AxisTitlePosition";
import { FontInfo } from "igniteui-angular-core";
import { IFastItemsSource } from "igniteui-angular-core";
import { CoercionInfo } from "./CoercionInfo";
import { IDataLegendSeries } from "igniteui-angular-core";
import { CaptureImageSettings } from "igniteui-angular-core";
import { CultureInfo } from "igniteui-angular-core";
import { ImageCapturedEventArgs } from "igniteui-angular-core";
import { ChartContentType } from "./ChartContentType";
import { ISchedulableRender } from "igniteui-angular-core";
import { Rectangle } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { Line } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
import { TextBlock } from "igniteui-angular-core";
import { ITileZoomTile } from "./ITileZoomTile";
import { IExecutionContext } from "igniteui-angular-core";
import { RenderSurface } from "./RenderSurface";
import { PathGeometry } from "igniteui-angular-core";
import { Geometry } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { LabelPanelsArrangeState } from "./LabelPanelsArrangeState";
import { DataTemplateRenderInfo } from "igniteui-angular-core";
import { DataTemplateMeasureInfo } from "igniteui-angular-core";
import { AxisLabelsLocation } from "./AxisLabelsLocation";
import { IProvidesViewport } from "./IProvidesViewport";
import { ActualLegendItemBadgeShape } from "./ActualLegendItemBadgeShape";
import { StandardLegendItems } from "igniteui-angular-core";
import { DomRenderer, DomWrapper } from "igniteui-angular-core";
import { PointerTooltipStyle } from "./PointerTooltipStyle";
import { DefaultPaletteInfo } from "./DefaultPaletteInfo";
import { AxisRange } from "./AxisRange";
import { AxisAnnotationCollection } from "./AxisAnnotationCollection";
import { VerticalAlignment } from "igniteui-angular-core";
import { Canvas } from "igniteui-angular-core";
import { IFastItemsSourceProvider } from "igniteui-angular-core";
import { AxisExtentType } from "./AxisExtentType";
import { DoubleCollection } from "igniteui-angular-core";
import { LabelPosition } from "./LabelPosition";
import { BindingFormatter } from "igniteui-angular-core";
import { LabelFontHeuristics } from "./LabelFontHeuristics";
import { AxisOrientation } from "./AxisOrientation";
import { Pool$1 } from "igniteui-angular-core";
import { AxisComponentsFromView } from "./AxisComponentsFromView";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { GeometryCollection } from "igniteui-angular-core";
import { PathRenderingInfo } from "./PathRenderingInfo";
import { RenderRequestedEventArgs } from "./RenderRequestedEventArgs";
import { CategoryMode } from "./CategoryMode";
import { GridMode } from "./GridMode";
import { Panel } from "igniteui-angular-core";
import { UIElement } from "igniteui-angular-core";
import { TickmarkValues } from "./TickmarkValues";
import { ICategoryScaler } from "./ICategoryScaler";
import { FastItemsSourceEventArgs } from "igniteui-angular-core";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { AxisRangeBufferMode } from "./AxisRangeBufferMode";
import { NumericAxisRenderingParameters } from "./NumericAxisRenderingParameters";
import { AxisRenderingParametersBase } from "./AxisRenderingParametersBase";
import { AutomaticSeriesPurpose } from "./AutomaticSeriesPurpose";
import { HighlightingState } from "./HighlightingState";
import { Marker } from "./Marker";
import { Polyline } from "igniteui-angular-core";
import { ContentControl } from "igniteui-angular-core";
import { Polygon } from "igniteui-angular-core";
import { AutoMarginsAndAngleUpdateMode } from "./AutoMarginsAndAngleUpdateMode";
import { ComputedPlotAreaMarginMode } from "./ComputedPlotAreaMarginMode";
import { ILegendSeries } from "igniteui-angular-core";
import { ILegendSeriesInternal } from "igniteui-angular-core";
import { ILegendTemplateProvider } from "igniteui-angular-core";
import { PenLineJoin } from "igniteui-angular-core";
import { PenLineCap } from "igniteui-angular-core";
import { Color } from "igniteui-angular-core";
import { SeriesVisibleRangeMode } from "./SeriesVisibleRangeMode";
import { SeriesOutlineMode } from "./SeriesOutlineMode";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { SeriesComponentsForView } from "./SeriesComponentsForView";
import { MarkerOutlineMode } from "./MarkerOutlineMode";
import { MarkerFillMode } from "./MarkerFillMode";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { ValueLayerValueMode } from "./ValueLayerValueMode";
import { SeriesComponentsFromView } from "./SeriesComponentsFromView";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { ISortingAxis } from "./ISortingAxis";
import { DataLegendSeriesGroup } from "igniteui-angular-core";
import { MarkerType } from "./MarkerType";
import { Style } from "igniteui-angular-core";
import { HashPool$2 } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class SeriesViewer extends Control implements INotifyPropertyChanged, ILegendOwner, IInternalLegendOwner, IDataLegendTarget, IToolbarTarget {
    static $t: Type;
    private _widget;
    get widget(): ISeriesViewerWidget;
    set widget(a: ISeriesViewerWidget);
    cu: SeriesViewerView;
    static staticInit(): void;
    private c7;
    private get c8();
    private an;
    ao(a: SeriesViewer): AutomaticSeriesManager;
    getDesiredToolbarActions(): ToolActionInfo[];
    onToolCommandExecuting(a: ToolCommand): ToolCommandExecutionState;
    addCommandAvailabilityListener(a: ICommandAvailabilityListener): void;
    removeCommandAvailabilityListener(a: ICommandAvailabilityListener): void;
    private fo;
    addCommandStateChangedListener(a: ICommandStateChangedListener): void;
    removeCommandStateChangedListener(a: ICommandStateChangedListener): void;
    private _commandCompleted;
    get commandCompleted(): (arg1: ToolCommand) => void;
    set commandCompleted(a: (arg1: ToolCommand) => void);
    private _invalidateActions;
    get invalidateActions(): () => void;
    set invalidateActions(a: () => void);
    private me;
    private a5;
    get a6(): IDataChartToolbarProvider;
    get ep(): boolean;
    private a8;
    get a9(): ISeriesViewerInteractionManager;
    get ei(): boolean;
    constructor();
    private cm;
    l9(): void;
    private n9;
    protected get_e0(): boolean;
    get e0(): boolean;
    protected get_ez(): boolean;
    get ez(): boolean;
    ma(): void;
    get series(): SeriesCollection;
    private bp;
    private o4;
    private bw;
    get bx(): SeriesPlotAreaMarginHorizontalMode;
    set bx(a: SeriesPlotAreaMarginHorizontalMode);
    private by;
    get bz(): SeriesPlotAreaMarginVerticalMode;
    set bz(a: SeriesPlotAreaMarginVerticalMode);
    mc(): void;
    protected my(): void;
    private _skipDataCleanup;
    get skipDataCleanup(): boolean;
    set skipDataCleanup(a: boolean);
    protected oy(a: any): void;
    private o5;
    mg(a: number, b: number, c: boolean, d: boolean): {
        p0?: number;
        p1?: number;
    };
    d4(): boolean;
    get fc(): boolean;
    protected get ee(): boolean;
    protected get dx(): boolean;
    protected get dw(): boolean;
    get dv(): boolean;
    get a7(): IHighlightingManager;
    get ba(): ISeriesViewerScrollbarManager;
    private l3;
    cv: DoubleAnimator;
    cw: DoubleAnimator;
    private l8;
    pi(a: number): void;
    l7(): void;
    sq(a: number): Brush;
    sw(a: number): Brush;
    su(a: number): Brush;
    sv(a: number): Brush;
    private sp;
    ag: BrushCollection;
    aj: BrushCollection;
    ah: BrushCollection;
    ai: BrushCollection;
    be: MarkerAutomaticBehavior;
    ar: ChartContentManager;
    get ta(): Point;
    set ta(a: Point);
    private s9;
    ou(): void;
    get eh(): boolean;
    get legend(): IChartLegend;
    set legend(a: IChartLegend);
    static readonly q2: DependencyProperty;
    get dt(): boolean;
    set dt(a: boolean);
    plotAreaMouseLeftButtonDown: (sender: any, e: PlotAreaMouseButtonEventArgs) => void;
    plotAreaMouseLeftButtonUp: (sender: any, e: PlotAreaMouseButtonEventArgs) => void;
    plotAreaClicked: (sender: any, e: PlotAreaMouseButtonEventArgs) => void;
    plotAreaMouseEnter: (sender: any, e: PlotAreaMouseEventArgs) => void;
    plotAreaMouseLeave: (sender: any, e: PlotAreaMouseEventArgs) => void;
    plotAreaMouseOver: (sender: any, e: PlotAreaMouseEventArgs) => void;
    no(a: Point, b: boolean): void;
    private bf;
    private bj;
    np(a: Point, b: boolean, c: boolean): void;
    static readonly p7: DependencyProperty;
    get eq(): boolean;
    set eq(a: boolean);
    static readonly qy: DependencyProperty;
    get fb(): boolean;
    set fb(a: boolean);
    static readonly rl: DependencyProperty;
    get bv(): SeriesHighlightingMode;
    set bv(a: SeriesHighlightingMode);
    static readonly qh: DependencyProperty;
    get b5(): SeriesViewerScrollbarMode;
    set b5(a: SeriesViewerScrollbarMode);
    protected b3: SeriesViewerScrollbarMode;
    static readonly qp: DependencyProperty;
    get b6(): SeriesViewerScrollbarMode;
    set b6(a: SeriesViewerScrollbarMode);
    protected b4: SeriesViewerScrollbarMode;
    static readonly rz: DependencyProperty;
    get b2(): SeriesViewerHorizontalScrollbarPosition;
    set b2(a: SeriesViewerHorizontalScrollbarPosition);
    static readonly qr: DependencyProperty;
    get b7(): SeriesViewerVerticalScrollbarPosition;
    set b7(a: SeriesViewerVerticalScrollbarPosition);
    static readonly r1: DependencyProperty;
    get sy(): Brush;
    set sy(a: Brush);
    static readonly ql: DependencyProperty;
    get sz(): Brush;
    set sz(a: Brush);
    static readonly qq: DependencyProperty;
    get gv(): number;
    set gv(a: number);
    static readonly qt: DependencyProperty;
    get gu(): number;
    set gu(a: number);
    static readonly qo: DependencyProperty;
    get gr(): number;
    set gr(a: number);
    static readonly qk: DependencyProperty;
    get gs(): number;
    set gs(a: number);
    static readonly qm: DependencyProperty;
    get gt(): number;
    set gt(a: number);
    static readonly qn: DependencyProperty;
    get gx(): number;
    set gx(a: number);
    static readonly qv: DependencyProperty;
    get gw(): number;
    set gw(a: number);
    static readonly qu: DependencyProperty;
    get d6(): boolean;
    set d6(a: boolean);
    static readonly i8: string;
    static readonly qs: DependencyProperty;
    get s7(): Brush;
    set s7(a: Brush);
    static readonly rw: DependencyProperty;
    get s8(): Brush;
    set s8(a: Brush);
    static readonly r0: DependencyProperty;
    get hh(): number;
    set hh(a: number);
    static readonly r3: DependencyProperty;
    get hg(): number;
    set hg(a: number);
    static readonly ry: DependencyProperty;
    get he(): number;
    set he(a: number);
    static readonly rv: DependencyProperty;
    get hk(): number;
    set hk(a: number);
    lu(): void;
    private nr;
    static readonly r6: DependencyProperty;
    get hf(): number;
    set hf(a: number);
    static readonly rx: DependencyProperty;
    get hj(): number;
    set hj(a: number);
    static readonly r5: DependencyProperty;
    get hi(): number;
    set hi(a: number);
    static readonly r4: DependencyProperty;
    get fk(): boolean;
    set fk(a: boolean);
    static readonly k5: string;
    static readonly r2: DependencyProperty;
    private bu;
    private br;
    get bs(): SeriesHighlightingBehavior;
    get bt(): SeriesHighlightingBehavior;
    set bt(a: SeriesHighlightingBehavior);
    static readonly qg: DependencyProperty;
    get bb(): LegendHighlightingMode;
    set bb(a: LegendHighlightingMode);
    static readonly qz: DependencyProperty;
    get bd(): LegendItemBadgeShape;
    set bd(a: LegendItemBadgeShape);
    static readonly q1: DependencyProperty;
    get bc(): LegendItemBadgeMode;
    set bc(a: LegendItemBadgeMode);
    static readonly q0: DependencyProperty;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected oi(a: string, b: any, c: any): void;
    nf(): void;
    ng(a: IEnumerable): void;
    ns(a: Series, b: any, c: any): void;
    nw(a: Series, b: any, c: any): void;
    nt(a: Series, b: any, c: any): void;
    nu(a: Series, b: any, c: any): void;
    nv(a: Series, b: any, c: any): void;
    ll(a: Rect, b: ScalerParams): Tuple$2<boolean, number>;
    get ew(): boolean;
    private dh;
    mx(): void;
    nx(a: Series, b: any, c: any): void;
    ny(a: Series, b: any, c: any): void;
    seriesCursorMouseMove: (sender: any, e: ChartCursorEventArgs) => void;
    ol(a: Series, b: any): void;
    seriesMouseLeftButtonDown: (sender: any, e: DataChartMouseButtonEventArgs) => void;
    op(a: Series, b: any, c: MouseButtonEventArgs): void;
    seriesMouseLeftButtonUp: (sender: any, e: DataChartMouseButtonEventArgs) => void;
    oq(a: Series, b: any, c: MouseButtonEventArgs): void;
    seriesMouseMove: (sender: any, e: ChartMouseEventArgs) => void;
    o9(a: Point): void;
    pa(a: Point): void;
    or(a: Series, b: any, c: MouseEventArgs): void;
    seriesMouseEnter: (sender: any, e: ChartMouseEventArgs) => void;
    on(a: Series, b: any, c: MouseEventArgs): void;
    seriesMouseLeave: (sender: any, e: ChartMouseEventArgs) => void;
    oo(a: Series, b: any, c: MouseEventArgs): void;
    private dc;
    mw(): void;
    private ti;
    protected get_ty(): Rect;
    get ty(): Rect;
    private tg;
    get tn(): Rect;
    set tn(a: Rect);
    protected get_d5(): boolean;
    get d5(): boolean;
    ts(a: Rect, b: Rect, c: Rect): Rect;
    private da;
    private tf;
    protected get_tm(): Rect;
    get tm(): Rect;
    tq(a: Rect, b: Rect, c: Rect): Rect;
    protected tl(a: Rect): Rect;
    tr(): Rect;
    protected pe(a: Axis): void;
    tz: Rect;
    fj: boolean;
    dq: boolean;
    e6: boolean;
    h0: number;
    private hs;
    get hv(): number;
    set hv(a: number);
    hy: number;
    hz: number;
    protected ex: boolean;
    protected ds: boolean;
    oc(a: Rect, b: Rect): void;
    private b0;
    b1(): SeriesViewerComponentsForView;
    private df;
    lt(a: Point, b: boolean): void;
    el: boolean;
    private at;
    get av(): ChartHitTestMode;
    set av(a: ChartHitTestMode);
    ot(): void;
    protected aw(): ChartHitTestMode;
    private as;
    get au(): ChartHitTestMode;
    set au(a: ChartHitTestMode);
    em: boolean;
    seriesAnimating: (series: Series) => void;
    ok(a: Series): void;
    abstract es(): boolean;
    abstract et(): boolean;
    er(): boolean;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    get cl(): InteractionState;
    set cl(a: InteractionState);
    private dd;
    private ch;
    ni(a: Point): void;
    nj(a: Point, b: boolean): void;
    e4(a: Point, b: number): boolean;
    m8(a: Point): void;
    e3(a: Key): boolean;
    private dj;
    d0: boolean;
    private db;
    get du(): boolean;
    set du(a: boolean);
    protected get_ej(): boolean;
    get ej(): boolean;
    na(a: Point): void;
    get d3(): boolean;
    ku: string;
    nn(a: Point): void;
    nb(a: Point, b: boolean): void;
    m9(a: Point): void;
    get e5(): boolean;
    set e5(a: boolean);
    private n7;
    nm(a: Point): void;
    n8(a: Point, b: number, c: number, d: number): void;
    nl(a: number): void;
    n4(a: Point, b: number, c: number, d: number): void;
    nh(a: Point): void;
    nk(a: number): void;
    nc(a: Point): void;
    n3(a: Point, b: number, c: number, d: number): void;
    n0(): void;
    ne(a: Size): void;
    l6(): void;
    m1(a: Point, b: boolean): void;
    cj(a: boolean): InteractionState;
    viewerManipulationStarting: (sender: any, e: SeriesViewerManipulationEventArgs) => void;
    viewerManipulationEnding: (sender: any, e: SeriesViewerManipulationEventArgs) => void;
    private dn;
    n6(): void;
    n5(): void;
    pb(): void;
    l1(): void;
    lw(): void;
    lv(): void;
    oa(): void;
    ox(): void;
    ov(): void;
    m0(a: Point, b: boolean): void;
    e9(): boolean;
    private dk;
    get fe(): boolean;
    set fe(a: boolean);
    mz(a: Point, b: boolean, c: boolean): void;
    po(a: any, b: PropertyUpdatedEventArgs): void;
    pn(a: SyncLink, b: SyncLink): void;
    lx(a: Point): void;
    pr(a: Rect, b: boolean): void;
    ps(a: Rect, b: boolean, c: boolean): void;
    ob(a: Rect, b: boolean): void;
    get en(): boolean;
    private _fn;
    fn(): IEnumerable$1<SeriesViewer>;
    td(a: Point): Point;
    tb(a: Point): Point;
    tx(a: Rect): Rect;
    windowRectChanged: (sender: any, e: RectChangedEventArgs) => void;
    private os;
    n2(a: Rect, b: Rect): void;
    sizeChanged: (sender: any, e: RectChangedEventArgs) => void;
    nz(a: Size, b: Size): void;
    d9: boolean;
    e7(a: Rect, b: Rect): boolean;
    actualWindowRectChanged: (sender: any, e: RectChangedEventArgs) => void;
    private of;
    pt(a: number): void;
    pu(a: number): void;
    o3(): void;
    gridAreaRectChanged: (sender: any, e: RectChangedEventArgs) => void;
    private og;
    protected get_ek(): boolean;
    get ek(): boolean;
    nq(a: Rect, b: Rect): void;
    cb: WindowResponse;
    mf(): void;
    d2: boolean;
    ho: number;
    hn: number;
    private fx;
    get gj(): number;
    set gj(a: number);
    private fw;
    get gi(): number;
    set gi(a: number);
    hq: number;
    hp: number;
    private _syncChannel;
    get syncChannel(): string;
    set syncChannel(a: string);
    private b8;
    get actualSyncLink(): SyncLink;
    set actualSyncLink(a: SyncLink);
    ff: boolean;
    md(): void;
    t4: Visibility;
    private dm;
    m6(): void;
    m4(): void;
    m5(): void;
    get cn(): IOverviewPlusDetailPane;
    protected pk(a: boolean): void;
    t3: Visibility;
    d8: boolean;
    fi: boolean;
    sx: Brush;
    s6: Brush;
    private cc;
    get cd(): ZoomCoercionMode;
    set cd(a: ZoomCoercionMode);
    ce(): ZoomCoercionMode;
    cf: ZoomCoercionMode;
    s1: Brush;
    sn: Brush;
    s0: Brush;
    dz(): boolean;
    dr(): boolean;
    t0: Rect;
    lq(): void;
    private hu;
    private notifyCrosshairUpdate;
    pp(a: number, b: number): void;
    pq(a: number, b: number, c: number, d: number): void;
    gp(): number;
    gq(): number;
    private g3;
    private g2;
    protected od(a: any, b: string, c: any, d: any): void;
    get ef(): boolean;
    protected get e2(): boolean;
    bo: Series;
    pj(a: Point): void;
    private lk;
    pm(): void;
    protected mt(): void;
    pl(): void;
    private dl;
    protected fg: boolean;
    ci: InteractionState;
    ck: InteractionState;
    sj: ModifierKeys;
    sk: ModifierKeys;
    private th;
    get tt(): Rect;
    set tt(a: Rect);
    fr: Date;
    fl: boolean;
    protected pd(): void;
    lm(a: Rect, b: Rect): void;
    protected mu(a: Rect, b: Rect): void;
    hl: number;
    hm: number;
    private tw;
    refreshCompleted: (sender: any, e: RefreshCompletedEventArgs) => void;
    oj(): void;
    protected abstract ct(): SeriesViewerView;
    protected n1(a: SeriesViewerView): void;
    static tv: Rect;
    pv: DataTemplate;
    p4: DataTemplate;
    p1: DataTemplate;
    p2: DataTemplate;
    pw: DataTemplate;
    pz: DataTemplate;
    px: DataTemplate;
    p3: DataTemplate;
    p0: DataTemplate;
    py: DataTemplate;
    kk: string;
    si: HorizontalAlignment;
    sh: HorizontalAlignment;
    private h6;
    get kr(): string;
    set kr(a: string);
    private h5;
    get kf(): string;
    set kf(a: string);
    private sm;
    get s5(): Brush;
    set s5(a: Brush);
    private sl;
    get s4(): Brush;
    set s4(a: Brush);
    private gc;
    get hc(): number;
    set hc(a: number);
    private ga;
    get ha(): number;
    set ha(a: number);
    private gb;
    get hb(): number;
    set hb(a: number);
    private f9;
    get g9(): number;
    set g9(a: number);
    private f8;
    get g8(): number;
    set g8(a: number);
    private f6;
    get g6(): number;
    set g6(a: number);
    private f7;
    get g7(): number;
    set g7(a: number);
    private f5;
    get g5(): number;
    set g5(a: number);
    j8: string;
    t1(): Thickness;
    t2(): Thickness;
    ap(a: Axis): AxisTitlePosition;
    aq(a: Axis): AxisTitlePosition;
    abstract getFontInfo(): FontInfo;
    getFontHeight(): number;
    protected get_e1(): boolean;
    get e1(): boolean;
    m3(): void;
    abstract getFontBrush(): Brush;
    abstract so(): Brush;
    h3: any;
    provideContainer(a: any): void;
    m2(a: number, b: number): void;
    notifyContainerResized(): void;
    to(): Rect;
    l2(): void;
    tc(): Point;
    cy(): FontInfo;
    cx(): FontInfo;
    sr(): Brush;
    ss(): Brush;
    lo(a: Series): void;
    oz(a: Series): void;
    al: CanvasRenderScheduler;
    am: CanvasRenderScheduler;
    ak: CanvasRenderScheduler;
    private di;
    get ey(): boolean;
    set ey(a: boolean);
    private c9;
    get dp(): boolean;
    set dp(a: boolean);
    private _syncSettings;
    get syncSettings(): SyncSettings;
    set syncSettings(a: SyncSettings);
    ln(a: any): void;
    o1(a: any): void;
    mq(source_: any, a: number, b: any, c: any): void;
    mh(source_: any): void;
    mo(source_: any, a: number, b: any): void;
    mp(source_: any, a: number, b: any): void;
    destroyed: boolean;
    protected h1: any;
    protected fm: Dictionary$2<string, any>;
    ev: boolean;
    destroy(): void;
    protected l0(): void;
    o8(source_: any): void;
    o2(): void;
    o7(a: string, source_: any): void;
    o0(a: string, b: boolean): void;
    protected o6(a: Series, b: any): void;
    protected pg(a: any): void;
    protected ph(): void;
    private gd;
    get hd(): number;
    set hd(a: number);
    private f2;
    get gz(): number;
    set gz(a: number);
    private f4;
    get g4(): number;
    set g4(a: number);
    private f0;
    get gm(): number;
    set gm(a: number);
    private fz;
    get gl(): number;
    set gl(a: number);
    private fy;
    get gk(): number;
    set gk(a: number);
    e8(): boolean;
    private de;
    get eb(): boolean;
    set eb(a: boolean);
    private f3;
    get g0(): number;
    set g0(a: number);
    private f1;
    get gy(): number;
    set gy(a: number);
    static cg(a: string, b: any): CoercionInfo;
    private h4;
    get jp(): string;
    set jp(a: string);
    private ft;
    get gf(): number;
    set gf(a: number);
    private fs;
    get ge(): number;
    set ge(a: number);
    fa: boolean;
    private te;
    get tj(): Rect;
    set tj(a: Rect);
    tp(): Rect;
    d7: boolean;
    private mb;
    tu(): Rect;
    protected tk(): Rect;
    h2(a: number, b: number): any;
    private fu;
    get gg(): number;
    set gg(a: number);
    private fv;
    get gh(): number;
    set gh(a: number);
    ms(): void;
    mr(): void;
    flush(): void;
    l5(a: boolean, b: boolean, c: boolean): void;
    fh(): boolean;
    private p5;
    private ax;
    protected ow(a: DependencyObject, b: (arg1: boolean) => void): void;
    protected pc(a: DependencyObject): void;
    ly(): void;
    ec: boolean;
    ed: boolean;
    ea: boolean;
    nd(): void;
    private dg;
    get eo(): boolean;
    lp(): void;
    eu(): boolean;
    private ht;
    hx(): number;
    c1(): FontInfo;
    c0(): FontInfo;
    pf(): void;
    protected dy: boolean;
    s3: Brush;
    s2: Brush;
    g1: number;
    eg: boolean;
    seriesDataUpdated: (sender: any, e: EventArgs) => void;
    om(): void;
    ml(): void;
    mm(): void;
    private mn;
    mk(a: Point): void;
    private fp;
    attachDataLegend(a: IDataLegend): void;
    detachDataLegend(a: IDataLegend): void;
    getDataLegendSeries(): IDataLegendSeries[];
    protected fq: List$1<CaptureImageSettings>;
    lr(a: CaptureImageSettings): void;
    private ls;
    protected ik(a: CaptureImageSettings, b: (arg1: string, arg2: any) => void): string;
    imageCaptured: (sender: any, args: ImageCapturedEventArgs) => void;
    protected oh(a: CaptureImageSettings, b: string, c?: any): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class SeriesViewerView extends Base implements ISchedulableRender {
    static $t: Type;
    constructor(a: SeriesViewer);
    l(): IExecutionContext;
    co(): void;
    p: SeriesViewer;
    c4(): void;
    e(): Series;
    private cn;
    a: CanvasRenderScheduler;
    n: IOverviewPlusDetailPane;
    private dn;
    private dm;
    em(): void;
    private ct;
    private cs;
    o: OverviewPlusDetailViewportHost;
    cb(a: number, b: number, c: RenderSurface): void;
    d5(): void;
    cd(): void;
    d7(): void;
    ck(): void;
    cc(): void;
    ce(): void;
    dy(a: Series): void;
    dc(): void;
    private er;
    aq(a: Series): boolean;
    protected g: SeriesCollection;
    protected b: AxisCollection;
    private ai;
    get au(): boolean;
    set au(a: boolean);
    bp(a: Series): void;
    dt(a: RenderingContext): void;
    bx(): void;
    bt(): void;
    cf(): void;
    ca(): void;
    dr(): void;
    protected fi: Rectangle;
    protected ff: Path;
    d8(): void;
    eg(a: Rect): void;
    bw(): void;
    df(): void;
    eo(a: number, b: number, c: number, d: number): void;
    protected fe: Line;
    protected fd: Line;
    ed(): void;
    cl(): void;
    eh(a: number, b: number, c: number, d: number): void;
    d9(): void;
    cg(): void;
    cj(): void;
    private e6;
    private e7;
    en(a: Rect, b: Rect): void;
    ec(): void;
    ep(a: Rect): void;
    dw(a: Axis): void;
    dx(a: Axis): void;
    bo(a: Axis): void;
    bl(a: Axis): void;
    private h;
    i(): SeriesViewerComponentsFromView;
    static aw(a: Series): List$1<Series>;
    d2(): void;
    j: SeriesViewerViewManager;
    protected w: RenderingContext;
    z: RenderingContext;
    y: RenderingContext;
    x: RenderingContext;
    an: boolean;
    ao: boolean;
    bi: any;
    c0(a: any): void;
    private al;
    protected cy(a: Point, b: boolean): void;
    protected cz(a: Point, b: boolean): void;
    protected c3(a: Point): void;
    protected cx(a: Point, b: boolean, c: boolean): void;
    du(a: RenderingContext): void;
    protected get_ap(): boolean;
    get ap(): boolean;
    k: EventProxy;
    ef(): void;
    a9: number;
    f(a: Point, b: boolean, c: DataContext, d: boolean): {
        ret: Series;
        p2: DataContext;
    };
    bd(): number;
    bc(): number;
    a8: number;
    a7: number;
    private e9;
    private aj;
    cu(): void;
    c1(a: number, b: number): void;
    private fg;
    private fh;
    b6(a: Rectangle): void;
    b9(a: Rectangle): void;
    b8(): void;
    d3(): void;
    private a1;
    private az;
    private a0;
    private ay;
    private ak;
    private aa;
    private b2;
    private ek;
    v(): FontInfo;
    u(): FontInfo;
    private e5;
    private e4;
    private bf;
    private a2;
    private be;
    fm(): Thickness;
    fl(): Thickness;
    protected dv(a: Rect): void;
    cq(): void;
    private fa;
    protected d0(): void;
    isValid(): boolean;
    preRender(): void;
    protected ds(): void;
    protected ab: boolean;
    protected d1(): void;
    c2(): void;
    cw(): void;
    fb(): Rect;
    e8(): Point;
    private d6;
    ee(): void;
    dp(): void;
    protected as(a: Point): boolean;
    c8(a: Point, b: boolean, c: boolean): void;
    protected c7(a: Point): void;
    protected c6(a: Point): void;
    protected c9(a: Point): void;
    d4(): void;
    get ez(): ModifierKeys;
    eq(a: Rect): void;
    cr(a: boolean): void;
    bk(a: boolean): void;
    protected el(): void;
    private af;
    get isDirty(): boolean;
    set isDirty(a: boolean);
    undirty(a: boolean): void;
    get index(): number;
    postRender(): void;
    b7(): void;
    protected ae: boolean;
    ch(): void;
    ea(): void;
    bv(a: boolean): void;
    bm(a: any): void;
    ei(a: number): void;
    ej(a: number): void;
    bn(a: any): void;
    dz(a: any): void;
    da(a: Brush): void;
    bu(a: Point): void;
    av: boolean;
    m(a: boolean): InteractionState;
    c5(): void;
    private et;
    private es;
    bb(a: TextBlock, b: FontInfo): number;
    ba(a: string, b: FontInfo): number;
    dj(): void;
    private eu;
    di(): void;
    de(): void;
    c(a: Axis): AxisTitlePosition;
    d(a: Axis): AxisTitlePosition;
    dk(): void;
    dl(): void;
    t(): FontInfo;
    e3(): Brush;
    q(): FontInfo;
    e0(): Brush;
    s(): FontInfo;
    r(): FontInfo;
    e2(): Brush;
    e1(): Brush;
    get a4(): number;
    get a5(): number;
    get a6(): number;
    get a3(): number;
    get ew(): TextBlock;
    get ev(): TextBlock;
    fc(): Rect;
    fk(): Thickness;
    fj(): Thickness;
    private ad;
    private ac;
    dd(a: any, b: any): void;
    dh(a: any, b: any): void;
    ey(): HorizontalAlignment;
    ex(): HorizontalAlignment;
    private ag;
    bq(): void;
    am(): boolean;
    b5(): void;
    cp(): void;
    at(a: Point): boolean;
    dq(): void;
    private ax;
    b3(a: Dictionary$2<any, ITileZoomTile>, b: List$1<ITileZoomTile>, c: number): void;
    bh(a: Rect, b: ITileZoomTile, c: number): any;
    b0(): void;
    b1(a: ITileZoomTile): void;
    cm(): void;
    ar: boolean;
    private bg;
    by(): void;
    br(): void;
    bz(a: number): void;
    bs(): void;
    private ah;
    ci(): void;
    eb(): void;
    dg(): void;
    cv(): void;
    db(): void;
    b4(a: any): void;
    bj(a: number, b: number, c: number): any;
}
/**
 * @hidden
 */
export declare class OverviewPlusDetailViewportHost extends Base implements IProvidesViewport {
    static $t: Type;
    constructor(a: SeriesViewerView);
    a: SeriesViewerView;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    getEffectiveViewport(): Rect;
    getMainContentViewport(): Rect;
}
/**
 * @hidden
 */
export declare class LegendTemplates extends Base {
    static $t: Type;
    private static readonly z;
    private static readonly ae;
    private static readonly ad;
    private static readonly ah;
    private static readonly ab;
    private static readonly y;
    private static readonly aa;
    private static readonly ac;
    static af(a: Series): DataTemplate;
    static a(a: DataTemplateRenderInfo): RenderingContext;
    static v(a: DataContext): void;
    private static b;
    private static c;
    static u(a: DataTemplateRenderInfo, b: number, c: Brush, d: Brush, e: number, f: number, g: number, h: number): void;
    static s(a: DataTemplateRenderInfo): void;
    static r(a: DataTemplateRenderInfo, b: number, c: number): void;
    static t(a: DataTemplateRenderInfo, b?: number): void;
    static j(a: DataTemplateRenderInfo): void;
    static n(a: DataTemplateRenderInfo): void;
    static o(a: DataTemplateRenderInfo): void;
    static q(a: DataTemplateRenderInfo): void;
    static p(a: DataTemplateRenderInfo): void;
    static i(a: DataTemplateRenderInfo): void;
    static l(a: DataTemplateRenderInfo): void;
    static m(a: DataTemplateRenderInfo): void;
    static k(a: DataTemplateRenderInfo): void;
    static g(a: DataTemplateRenderInfo): void;
    private static readonly w;
    private static readonly x;
    static resolveLegendItemTemplate(a: StandardLegendItems): DataTemplate;
    static e(a: DataTemplateRenderInfo): void;
    static f(a: DataTemplateMeasureInfo): void;
    static d(a: DataTemplateMeasureInfo): void;
    static h(a: DataTemplateMeasureInfo): void;
}
/**
 * @hidden
 */
export declare class SeriesViewerViewManager extends Base {
    static $t: Type;
    ae: DomRenderer;
    protected af: DomWrapper;
    protected aj: DomWrapper;
    protected ai: DomWrapper;
    protected ag: DomWrapper;
    ak: DomWrapper;
    t: RenderingContext;
    w: RenderingContext;
    v: RenderingContext;
    u: RenderingContext;
    x: RenderingContext;
    f: EventProxy;
    private j;
    constructor(a: SeriesViewerView);
    protected ah: DomWrapper;
    bj(): void;
    bg(a: any): void;
    static by(a: DomRenderer, b: () => void): void;
    private bi;
    ba(): void;
    g(): IOverviewPlusDetailPane;
    bm(): void;
    bn(): void;
    b3(): Brush;
    private ab;
    private aa;
    private ac;
    az(a: number, b: number, c: number): void;
    b8(): Point;
    y(): boolean;
    bc(a: boolean): void;
    a8(a: BrushCollection, b: BrushCollection, c: Brush, d: FontInfo, e: Brush): {
        p0: BrushCollection;
        p1: BrushCollection;
        p2: Brush;
        p3: FontInfo;
        p4: Brush;
    };
    e(): DefaultPaletteInfo;
    a7(a: number, b: number[], c: Brush, d: Brush, e: number, f: boolean): {
        p0: number;
        p1: number[];
        p2: Brush;
        p3: Brush;
        p4: number;
        p5: boolean;
    };
    ay(): void;
    bu(x_: number): void;
    private ad;
    bv(y_: number): void;
    au(a: any): void;
    a9(): void;
    bo(): void;
    av(a: any): void;
    bk(a: any): void;
    bd(): void;
    private l;
    p(): FontInfo;
    private ca;
    ce(): Thickness;
    private aq;
    as(): string;
    private ap;
    ar(): string;
    private b9;
    cd(): Thickness;
    private b0;
    b5(): Brush;
    private bz;
    b4(): Brush;
    private k;
    o(): FontInfo;
    private a;
    c(): AxisTitlePosition;
    private b;
    d(): AxisTitlePosition;
    private n;
    r(): FontInfo;
    private b2;
    b7(): Brush;
    private m;
    q(): FontInfo;
    private b1;
    b6(): Brush;
    private cb;
    cf(): Thickness;
    private cc;
    cg(): Thickness;
    bp(): void;
    private bx;
    private br;
    private bq;
    private bs;
    private bt;
    a6(a: number, b: number): void;
    private h;
    i(): PointerTooltipStyle;
    bb(a: boolean): void;
    private z;
    an(a: Rect, b: ITileZoomTile, c: number): any;
    a3(a: ITileZoomTile): void;
    a2(): void;
    bl(a: List$1<ITileZoomTile>): void;
    private al;
    a0(): void;
    aw(): void;
    private am;
    a1(a: number): void;
    ax(): void;
    private s;
    be(): void;
    bw(a: boolean): void;
    a4(): void;
    a5(): void;
    bh(): void;
    bf(): void;
    ao(a: number, b: number, c: number): any;
    at(a: number, b: number, c: number, d: string, e?: (arg1: string, arg2: any) => void): string;
}
/**
 * @hidden
 */
export declare class AutoRangeCalculator extends Base {
    static $t: Type;
    static a(a: NumericAxisBase, b: number, c: number, d: boolean, e: number, f: number, g: number): {
        p5: number;
        p6: number;
    };
}
/**
 * @hidden
 */
export interface IAxisAnnotationManager {
    owner: Axis;
    onAutoAnnotionsChanged(a: Axis, b: AxisAnnotationCollection, c: NotifyCollectionChangedEventArgs): void;
    onAutoAnnotionsReset(a: Axis, b: AxisAnnotationCollection, c: EventArgs): void;
    onAnnotionsChanged(a: Axis, b: AxisAnnotationCollection, c: NotifyCollectionChangedEventArgs): void;
    onAnnotionsReset(a: Axis, b: AxisAnnotationCollection, c: EventArgs): void;
    onAddAnnotations(a: Axis): void;
    arrangeAnnotations(a: Axis, b: AxisLabelPanelBaseView, c: List$1<FrameworkElement>, d: List$1<Rect>, e: boolean, f: number, g: number, h: number, i: number, j: number): void;
}
/**
 * @hidden
 */
export declare let IAxisAnnotationManager_$type: Type;
/**
 * @hidden
 */
export declare class AxisLabelSettings extends Base implements INotifyPropertyChanged {
    static $t: Type;
    constructor();
    private ab;
    get textStyle(): string;
    set textStyle(a: string);
    private ay;
    get textColor(): Brush;
    set textColor(a: Brush);
    get location(): AxisLabelsLocation;
    set location(a: AxisLabelsLocation);
    private b;
    get visibility(): Visibility;
    set visibility(a: Visibility);
    private a3;
    get showFirstLabel(): boolean;
    set showFirstLabel(a: boolean);
    private i;
    c: AxisLabelsLocation;
    a: Axis;
    registerAxis(a: Axis): void;
    unregisterAxis(a: Axis): void;
    get angle(): number;
    set angle(a: number);
    private n;
    get extent(): number;
    set extent(a: number);
    private p;
    set margin(a: number);
    get leftMargin(): number;
    set leftMargin(a: number);
    private q;
    get rightMargin(): number;
    set rightMargin(a: number);
    private r;
    get topMargin(): number;
    set topMargin(a: number);
    private s;
    get bottomMargin(): number;
    set bottomMargin(a: number);
    private o;
    private av;
    get horizontalAlignment(): HorizontalAlignment;
    set horizontalAlignment(a: HorizontalAlignment);
    private a0;
    get verticalAlignment(): VerticalAlignment;
    set verticalAlignment(a: VerticalAlignment);
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    as(a: string, b: any, c: any): void;
    protected ar(a: any, b: string, c: any, d: any): void;
    k(): boolean;
    l(): boolean;
    static readonly extentPropertyDefault: number;
    get j(): boolean;
    private f;
    get g(): FontInfo;
    set g(a: FontInfo);
    h(a: DomRenderer): FontInfo;
}
/**
 * @hidden
 */
export declare class TitleSettings extends AxisLabelSettings {
    static $t: Type;
    constructor();
    private a5;
    get position(): AxisTitlePosition;
    set position(a: AxisTitlePosition);
    protected ar(a: any, b: string, c: any, d: any): void;
}
/**
 * @hidden
 */
export declare abstract class Axis extends Control implements INotifyPropertyChanged {
    static $t: Type;
    a4(): AxisView;
    a5: AxisView;
    hs(a: AxisView): void;
    abstract ag(): number[];
    hf(): void;
    private bt;
    get bu(): SRProvider;
    private a9;
    get ba(): IAxisVisualDataManager;
    ei(): number;
    f2(): any;
    f1(): any;
    protected get_cb(): boolean;
    get cb(): boolean;
    protected get_cj(): boolean;
    get cj(): boolean;
    protected get_b9(): boolean;
    get b9(): boolean;
    protected get_cm(): boolean;
    get cm(): boolean;
    protected get_cp(): boolean;
    get cp(): boolean;
    protected get_cn(): boolean;
    get cn(): boolean;
    protected get_ce(): boolean;
    get ce(): boolean;
    protected get_ck(): boolean;
    get ck(): boolean;
    protected get_cl(): boolean;
    get cl(): boolean;
    protected get_cc(): boolean;
    get cc(): boolean;
    protected get_cd(): boolean;
    get cd(): boolean;
    ak(): Axis;
    constructor();
    private a7;
    get a8(): IAxisAnnotationManager;
    get ca(): boolean;
    private hd;
    private he;
    private hb;
    private hc;
    provideRenderer(a: DomRenderer): void;
    au: (item: any) => string;
    hp(a: Rect, b: Rect): void;
    abstract av(): AxisLabelPanelBase;
    ac(): void;
    ir: Canvas;
    get bo(): IFastItemsSourceProvider;
    set bo(a: IFastItemsSourceProvider);
    private bn;
    get bi(): SeriesViewer;
    set bi(a: SeriesViewer);
    private bh;
    get bg(): XamDataChart;
    set bg(a: XamDataChart);
    readonly bs: (sender: any, e: RectChangedEventArgs) => void;
    private by;
    get c6(): boolean;
    set c6(a: boolean);
    private dl;
    get e6(): number;
    set e6(a: number);
    private df;
    get dx(): number;
    set dx(a: number);
    private ds;
    get fc(): number;
    set fc(a: number);
    private dp;
    get e9(): number;
    set e9(a: number);
    private as;
    get at(): AxisExtentType;
    set at(a: AxisExtentType);
    private dk;
    get e5(): number;
    set e5(a: number);
    dw: number;
    private dr;
    get fb(): number;
    set fb(a: number);
    private dn;
    get e8(): number;
    set e8(a: number);
    private bk;
    private bj;
    get bm(): FontInfo;
    set bm(a: FontInfo);
    private f3;
    get gx(): string;
    set gx(a: string);
    private dm;
    get e7(): number;
    set e7(a: number);
    dy: number;
    private dt;
    get fd(): number;
    set fd(a: number);
    private dq;
    get fa(): number;
    set fa(a: number);
    private fo;
    get ft(): number;
    set ft(a: number);
    private fn;
    get fs(): number;
    set fs(a: number);
    private fm;
    get fr(): number;
    set fr(a: number);
    fp: number;
    private kj;
    get km(): VerticalAlignment;
    set km(a: VerticalAlignment);
    private dv;
    get ff(): number;
    set ff(a: number);
    private du;
    get fe(): number;
    set fe(a: number);
    ih(): void;
    private h5;
    private h6;
    is: TextBlock;
    g6: string;
    jz: Brush;
    jv: Brush;
    fg: number;
    j3: DoubleCollection;
    jy: Brush;
    jw: Brush;
    jt: Brush;
    er: number;
    j1: DoubleCollection;
    jx: Brush;
    ju: Brush;
    eu: number;
    j2: DoubleCollection;
    j0: Brush;
    fi: number;
    j4: DoubleCollection;
    fh: number;
    dz: number;
    private ik;
    cf: boolean;
    ch: boolean;
    ci: boolean;
    cu: boolean;
    private bw;
    private dg;
    get b4(): boolean;
    get b7(): boolean;
    ig(a: number): void;
    ia(): void;
    ef(): number;
    ew(): number;
    cv: boolean;
    cw: boolean;
    cx: boolean;
    bz: boolean;
    c5: boolean;
    get c4(): boolean;
    set c4(a: boolean);
    static readonly jp: DependencyProperty;
    fq: number;
    b1: boolean;
    az: AxisLabelSettings;
    d5(): number;
    jr(): HorizontalAlignment;
    kk(): VerticalAlignment;
    js(): HorizontalAlignment;
    kl(): VerticalAlignment;
    d7(): number;
    d9(): number;
    d8(): number;
    d6(): number;
    ec(): number;
    ee(): number;
    ed(): number;
    eb(): number;
    a0(): AxisLabelsLocation;
    a1(): AxisLabelsLocation;
    aj: Axis;
    fv: any;
    rangeChanged: (sender: any, e: AxisRangeChangedEventArgs) => void;
    protected h3(a: AxisRangeChangedEventArgs): void;
    bf: TitleSettings;
    ea(): number;
    d4(): number;
    get an(): AxisAnnotationCollection;
    private al;
    get ao(): AxisAnnotationCollection;
    private am;
    private j6;
    get kd(): Rect;
    set kd(a: Rect);
    kc: Rect;
    il(): void;
    c8(a: Rect, b: Rect, c: AxisView): boolean;
    co(): boolean;
    dc: List$1<any>;
    dd: List$1<LabelPosition>;
    aw: AxisLabelPanelBase;
    protected ip(a: Rect, b: Rect): void;
    private bx;
    get cq(): boolean;
    set cq(a: boolean);
    protected ka(): Rect;
    protected iq(a: Rect, b: Rect): void;
    h4(): void;
    a6: ContentInfo;
    fl: DomRenderer;
    ai: BindingFormatter;
    protected hw(a: any, b: string, c: any, d: any): void;
    hu(): void;
    hv(): void;
    private _coercionMethods;
    get coercionMethods(): any;
    set coercionMethods(a: any);
    private bv;
    protected get_expectFunctions(): boolean;
    protected set_expectFunctions(a: boolean): void;
    get expectFunctions(): boolean;
    set expectFunctions(a: boolean);
    cy: boolean;
    private ic;
    c7: boolean;
    protected hr(a: GeometryCollection, b: number, c: number, d: Rect): void;
    protected hq(a: GeometryCollection, b: number, c: Rect, d: PathRenderingInfo, e: boolean): void;
    protected io(a: GeometryCollection, b: number, c: number, d: Rect): void;
    protected im(a: GeometryCollection, b: number, c: Rect, d: PathRenderingInfo, e: boolean): void;
    private cg;
    protected ie(a: number, b: number, c: Rect, d: Rect, e: Rect, f: number, g: number): {
        p0: number;
        p1: number;
    };
    d0(a: number, b: number, c: number, d: PathRenderingInfo): number;
    hi(a: GeometryCollection): void;
    protected hh(): void;
    h7(): void;
    h8(a: boolean): void;
    renderRequested: (sender: any, e: RenderRequestedEventArgs) => void;
    bc: LabelFontHeuristics;
    static et: number;
    ez(): number;
    e3(): number;
    e1(): number;
    e2(): number;
    e0(): number;
    ex(): number;
    d2(a: number, b: boolean, c: Rect, d: Rect, e: Rect): number;
    private eq;
    private eh;
    cz(a: number, b: Rect, c: Rect, d: Rect): boolean;
    protected eg(a: number, b: Rect, c: Rect, d: Rect): number;
    ey(): number;
    protected get c0(): boolean;
    cr: boolean;
    hk(a: boolean): void;
    private di;
    private b2;
    ib(): void;
    protected b6(): boolean;
    d1(a: number, b: ScalerParams): number;
    protected id(): void;
    private dj;
    bb(): LabelFontHeuristics;
    bl(): FontInfo;
    private hl;
    cs: boolean;
    c1(): boolean;
    c2(a: boolean): boolean;
    c3(): boolean;
    protected h9(a: boolean): void;
    ij(): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected h2(a: string, b: any, c: any): void;
    de: List$1<Series>;
    ct(a: Series): boolean;
    b0(a: Series): boolean;
    f0: any;
    gg: string;
    ah: any[];
    fx(a: any, b: string): any;
    private da;
    protected gs(a: string): string;
    private c9;
    protected fy(a: any, b: string, c: string): any;
    fz(a: any): any;
    gd(a: number): string;
    ev(): number;
    ej(a: number, b: ScalerParams): number;
    ek(a: number, b: ScalerParams, c: CategoryMode): number;
    j9(a: Rect): Rect;
    j8(): Rect;
    j7(): Rect;
    protected kb(a: Rect, b: Rect): Rect;
    el(a: number, b: Rect, c: Rect): number;
    hn(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    hm(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    em(a: number, b: ScalerParams): number;
    en(a: number, b: ScalerParams, c: CategoryMode): number;
    eo(a: number, b: Rect, c: Rect): number;
    ho(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    e4(a: number): number;
    abstract get a2(): AxisOrientation;
    ki: Size;
    ht(a: Size): void;
    ii(): void;
    ap: AxisComponentsForView;
    aq(): AxisComponentsForView;
    d3: number;
    private dh;
    get es(): number;
    set es(a: number);
    b8(): boolean;
    ep(): number;
    protected hg(): void;
    hj(a: AxisRangeChangedEventArgs): void;
    br: Pool$1<TextBlock>;
    bq: Pool$1<TextBlock>;
    bp: Pool$1<Rectangle>;
    get ke(): Path;
    get kf(): Path;
    get kh(): Path;
    get kg(): Path;
    be(): SyncSettings;
    ar(): AxisComponentsFromView;
    private ax;
    get ay(): AxisLabelSettings;
    hx(a: RenderingContext, b: RenderingContext): void;
    b5(): boolean;
    fw(): any;
    private _db;
    db(): IEnumerable$1<Series>;
    hy(a: string): void;
    h1(a: any): void;
    h0(a: any): void;
    fk: CultureInfo;
    j5(a: number, b: Rect, c: Rect, d?: any, e?: any): Geometry;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AxisCollection extends ObservableCollection$1<Axis> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class AxisLabelManager extends Base {
    static $t: Type;
    e: List$1<any>;
    f: List$1<LabelPosition>;
    b: AxisLabelPanelBase;
    a: Axis;
    c: (arg1: number) => void;
    constructor();
    n(a: Rect, b: Rect): void;
    i(a: any, b: LabelPosition): void;
    t(): void;
    static j(a: FrameworkElement, b: AxisLabelSettings): void;
    private static k;
    private static l;
    static m(a: FrameworkElement, b: TitleSettings): void;
    h(a: FrameworkElement): void;
    r(a: number): void;
    o(a: number): void;
    u(a: number): FrameworkElement;
    s(a: number): void;
    get d(): boolean;
    q(): void;
    p(): void;
    g(): void;
}
/**
 * @hidden
 */
export declare abstract class AxisLabelPanelBase extends Panel {
    static $t: Type;
    ae(): AxisLabelPanelBaseView;
    ch(a: AxisLabelPanelBaseView): void;
    af: AxisLabelPanelBaseView;
    cx: Rect;
    b8(): void;
    cp(): void;
    co(): void;
    constructor();
    bw: number;
    ad: Axis;
    private ak;
    get az(): boolean;
    set az(a: boolean);
    private a3;
    get a9(): List$1<any>;
    set a9(a: List$1<any>);
    ba: List$1<LabelPosition>;
    c4: Rect;
    private cw;
    get c5(): Rect;
    set c5(a: Rect);
    private cv;
    get c1(): Rect;
    set c1(a: Rect);
    c2: Rect;
    private bc;
    get bg(): number;
    set bg(a: number);
    bx: () => boolean;
    bb: List$1<FrameworkElement>;
    a8: List$1<Rect>;
    ag: AxisLabelSettings;
    bn(): number;
    ao: boolean;
    c3: Rect;
    cl(): void;
    ar: boolean;
    av: boolean;
    aw: boolean;
    ax: boolean;
    bz: any;
    al: boolean;
    protected an(a: List$1<Rect>, b: List$1<boolean>): boolean;
    protected by(a: number, b: List$1<Rect>, c: List$1<boolean>): {
        ret: number;
        p1?: List$1<Rect>;
    };
    a5(): List$1<Rect>;
    b6(): void;
    b2(a: Size): void;
    get ap(): boolean;
    bl(): number;
    bq(): number;
    at(a: number, b: Rect): boolean;
    bk(a: any): number;
    bv(a: any): number;
    bm(a: any): number;
    bj(a: any): number;
    aq(): boolean;
    protected ct(a: Rect, b: Rect): void;
    protected cd(a: Rect, b: Rect): void;
    a7(): List$1<Rect>;
    a6(a: List$1<Rect>): List$1<Rect>;
    protected cy(a: number, b: Rect, c: Thickness): Rect;
    protected as(a: List$1<Rect>, b: List$1<number>, c: Thickness): boolean;
    protected a4(a: List$1<Rect>): List$1<number>;
    bp(a: number, b: Size): number;
    bo(a: number, b: Size): number;
    bt(): number;
    br(): number;
    bs(): number;
    bu(): number;
    c6(a: Size): Size;
    protected get am(): boolean;
    c0(): Rect;
    protected b5(a: Size): void;
    protected b4(a: Size): void;
    protected b9(): void;
    protected a2(): IEnumerable$1<number>;
    get ah(): AxisLabelsLocation;
    cs(a: GeometryCollection, b: number, c: number, d: number, e: Rect, f: PathRenderingInfo): void;
    cc(a: GeometryCollection, b: number, c: number, d: number, e: Rect, f: PathRenderingInfo): void;
    cm(a: FrameworkElement, b: number): void;
    protected get_au(): boolean;
    get au(): boolean;
    ac(a: Rect, b: number): Point[];
    cz(a: Rect, b: number): Rect;
    cn(a: FrameworkElement): void;
    cb(a: FrameworkElement, b: number): void;
    c8(a: Size): Size;
    static readonly cu: DependencyProperty;
    get bh(): number;
    set bh(a: number);
    bd: number;
    aj(a: TitleSettings): AxisTitlePosition;
    ai(): AxisLabelsLocation;
    ay(a: AxisLabelsLocation): boolean;
    private _a0;
    a0(): IEnumerable$1<any>;
    b1(a: number, b: TextBlock, c: number, d: number, e: number): string;
    b7(a: any): void;
    cg(a: FrameworkElement): void;
    private _a1;
    a1(): IEnumerable$1<any>;
    protected be: number;
    protected bf: number;
    ca(): void;
    cr(): void;
    ce(): void;
    bi(a: Rect): number;
    c7: Size;
    ci(): void;
    cq(): void;
    cf(): void;
    cj(a: RenderingContext): void;
    b3(): void;
    ck(): void;
}
/**
 * @hidden
 */
export declare abstract class CategoryAxisBase extends Axis implements ICategoryScaler {
    static $t: Type;
    a4(): AxisView;
    ag(): number[];
    protected get_cd(): boolean;
    hs(a: AxisView): void;
    kn: CategoryAxisBaseView;
    protected eg(a: number, b: Rect, c: Rect, d: Rect): number;
    constructor();
    c8(a: Rect, b: Rect, c: AxisView): boolean;
    l1(): void;
    l0(): void;
    ky: List$1<number>;
    protected get_cb(): boolean;
    me(a: Point, b: boolean, c: number): Rect;
    mf(a: Point, b: boolean, c: number, d: boolean): Rect;
    kr: IFastItemsSource;
    private kq;
    get itemsSource(): IEnumerable;
    set itemsSource(a: IEnumerable);
    static readonly l9: DependencyProperty;
    private ld;
    lf: number;
    get lg(): number;
    set lg(a: number);
    get categoryMode(): CategoryMode;
    set categoryMode(a: CategoryMode);
    private ko;
    k1: number;
    protected lb(a: Rect, b: Rect, c: Rect): number;
    k8: number;
    k0: number;
    k9: number;
    la: number;
    kv: boolean;
    get lh(): number;
    set lh(a: number);
    private le;
    em(a: number, b: ScalerParams): number;
    getUnscaledValue3(a: number, b: Rect, c: Rect, d: CategoryMode): number;
    getCategorySize(a: Rect, b: Rect, c: Rect): number;
    k4(a: Rect, b: Rect, c: Rect): number;
    getGroupCenter(a: number, b: Rect, c: Rect, d: Rect): number;
    lc(a: number): number;
    private _kx;
    private kx;
    private kt;
    ku(a: SeriesViewer): boolean;
    private _kw;
    private kw;
    private ks;
    l5(a: boolean): void;
    protected hw(a: any, b: string, c: any, d: any): void;
    protected lt(): void;
    lv(a: any, b: FastItemsSourceEventArgs): void;
    protected l2(a: FastItemsSourceEventArgs): void;
    private l6;
    ct(a: Series): boolean;
    b0(a: Series): boolean;
    private l3;
    ls(): void;
    l4(): void;
    lu(a: NotifyCollectionChangedEventArgs): void;
    lz(a: number, b: any, c: any): void;
    lw(): void;
    lx(a: number, b: any): void;
    ly(a: number, b: any): void;
    k5(a: Rect, b: Rect, c: Rect, d: number): number;
    k6(a: Rect, b: Rect, c: Rect, d: number, e: number): number;
    getSeriesOffset(a: Rect, b: Rect, c: Rect, d: number, e: number): number;
    get isVertical(): boolean;
    j$d(a: number, b: ScalerParams): number;
    j$c(a: number, b: ScalerParams): number;
    j$e(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$g(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    get j$b(): boolean;
    j$a(): number[];
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class HorizontalAxisLabelPanelBase extends AxisLabelPanelBase {
    static $t: Type;
    ae(): AxisLabelPanelBaseView;
    ch(a: AxisLabelPanelBaseView): void;
    c9: HorizontalAxisLabelPanelBaseView;
    dl: number;
    di: number;
    dk: number;
    dj: number;
    b6(): void;
    db(): boolean;
    dc(): boolean;
    aq(): boolean;
    a5(): List$1<Rect>;
    dn(a: List$1<Rect>, b: List$1<boolean>, c: number): void;
    private dm;
    private dp;
    protected dq(a: List$1<Rect>, b: List$1<boolean>): void;
    protected dr(): void;
    protected get_au(): boolean;
    cm(a: FrameworkElement, b: number): void;
    protected dd(): boolean;
    protected da(): boolean;
    protected by(a: number, b: List$1<Rect>, c: List$1<boolean>): {
        ret: number;
        p1?: List$1<Rect>;
    };
    c0(): Rect;
    dh(): number;
    de(): number;
    dg(): number;
    df(): number;
    protected b9(): void;
    a6(a: List$1<Rect>): List$1<Rect>;
}
/**
 * @hidden
 */
export declare class HorizontalAxisLabelPanel extends HorizontalAxisLabelPanelBase {
    static $t: Type;
    ai(): AxisLabelsLocation;
    ay(a: AxisLabelsLocation): boolean;
}
/**
 * @hidden
 */
export declare abstract class NumericAxisBase extends Axis {
    static $t: Type;
    a4(): AxisView;
    ag(): number[];
    hs(a: AxisView): void;
    d1(a: number, b: ScalerParams): number;
    kx: NumericAxisBaseView;
    protected get_cj(): boolean;
    constructor();
    get ku(): AxisRangeBufferMode;
    set ku(a: AxisRangeBufferMode);
    private ks;
    get kv(): AxisRangeBufferMode;
    set kv(a: AxisRangeBufferMode);
    static readonly ne: DependencyProperty;
    l5: number;
    get lx(): number;
    set lx(a: number);
    private lp;
    l3: number;
    f2(): any;
    get l0(): number;
    set l0(a: number);
    private ls;
    l4: number;
    get lw(): number;
    set lw(a: number);
    private lo;
    f1(): any;
    l2: number;
    private lr;
    get lz(): number;
    set lz(a: number);
    l1: number;
    private ln;
    get lv(): number;
    set lv(a: number);
    ev(): number;
    l6: number;
    private lq;
    get ly(): number;
    set ly(a: number);
    l7: number;
    li: boolean;
    private k8;
    get lb(): boolean;
    set lb(a: boolean);
    ld: boolean;
    private k9;
    get lc(): boolean;
    set lc(a: boolean);
    get lj(): boolean;
    l9: number;
    ma: number;
    k0: NumericAxisRenderer;
    protected lk: boolean;
    protected ll: boolean;
    protected h9(a: boolean): void;
    h1(a: any): void;
    h0(a: any): void;
    ko: BindingFormatter;
    protected hw(a: any, b: string, c: any, d: any): void;
    protected m1(): void;
    kq: AxisRange;
    kr(): AxisRange;
    lu: number;
    lt: number;
    private lm;
    private kw;
    my(a: NumericAxisBase, b: number, c: number, d: boolean, e: number, f: number, g: number): {
        p5: number;
        p6: number;
    };
    private kt;
    c3(): boolean;
    private mz;
    m2(a: AxisRangeChangedEventArgs): void;
    ct(a: Series): boolean;
    b0(a: Series): boolean;
    kz(a: AxisLabelManager): NumericAxisRenderer;
    ky(): NumericAxisRenderer;
    kp: (item: any) => string;
    mb: string;
    kn: any[];
    lh: boolean;
    k2(): NumericAxisRenderingParameters;
    m0(): void;
    k3(): NumericScaler;
    k1(a: Rect, b: Rect, c: Rect, d: Rect): NumericAxisRenderingParameters;
    l8(a: number): number;
    le(): boolean;
    get lg(): boolean;
    get lf(): boolean;
    private m3;
    static readonly ng: DependencyProperty;
    get k6(): TickmarkValues;
    set k6(a: TickmarkValues);
    private k4;
    get k5(): TickmarkValues;
    set k5(a: TickmarkValues);
    private k7;
    get la(): boolean;
    set la(a: boolean);
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class NumericScaler extends DependencyObject {
    static $t: Type;
    static readonly ac: Rect;
    abstract t(a: NumericAxisBase, b: number, c: number, d: number, e: number): {
        p3: number;
        p4: number;
    };
    l: number;
    k: number;
    protected o: number;
    protected n: number;
    y(a: number): void;
    x(a: number): void;
    protected w(a: string, b: any, c: any): void;
    private z;
    protected m: number;
    abstract q(a: number, b: ScalerParams): number;
    abstract p(a: number, b: ScalerParams): number;
    j(a: IList$1<number>, b: number, c: number, d: ScalerParams): IList$1<number>;
    v(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    u(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AxisRendererBase extends Base {
    static $t: Type;
    constructor(a: AxisLabelManager);
    u: () => void;
    o: (viewportRect: Rect, windowRect: Rect) => boolean;
    v: () => void;
    m: (p: AxisRenderingParametersBase, value: number) => number;
    l: (p: AxisRenderingParametersBase, geometry: GeometryCollection, startValue: number, endValue: number) => void;
    k: (p: AxisRenderingParametersBase, geometry: GeometryCollection, value: number) => void;
    q: (p: AxisRenderingParametersBase, value: number) => boolean;
    n: (p: AxisRenderingParametersBase, value: number) => boolean;
    j: (p: AxisRenderingParametersBase) => void;
    e: (p: AxisRenderingParametersBase) => void;
    p: (p: AxisRenderingParametersBase, position: number, isLastLabel: boolean) => boolean;
    h: (p: AxisRenderingParametersBase, value: number) => LabelPosition;
    t: (p: AxisRenderingParametersBase, value: number) => number;
    b: AxisLabelManager;
    g: (item: any, fromAbbreviator: boolean) => any;
    d: (viewportRect: Rect, windowRect: Rect, effectiveViewportRect: Rect, contentViewport: Rect) => AxisRenderingParametersBase;
    r: (p: AxisRenderingParametersBase, value: number, absoluteIndex: number, interval: number) => number;
    a: (p: AxisRenderingParametersBase, value: number, absolueIndex: number, interval: number) => number;
    f: (index: number, window: Rect, viewport: Rect, effectiveViewport: Rect) => number;
    i: (index: number) => number;
    c(a: boolean, b: Rect, c: Rect, d: Rect, e: Rect): AxisRenderingParametersBase;
    private aa;
    private ab;
    protected x(a: Rect, b: Rect): void;
    private z;
    private s;
    private y;
    w(a: AxisRenderingParametersBase, b: number, c: number, d: number): any;
}
/**
 * @hidden
 */
export declare class NumericAxisRenderer extends AxisRendererBase {
    static $t: Type;
    constructor(a: AxisLabelManager);
    w(a: AxisRenderingParametersBase, b: number, c: number, d: number): any;
    private ac;
    private ad;
    private ae;
}
/**
 * @hidden
 */
export declare class VerticalAxisLabelPanel extends AxisLabelPanelBase {
    static $t: Type;
    ae(): AxisLabelPanelBaseView;
    ch(a: AxisLabelPanelBaseView): void;
    c9: VerticalAxisLabelPanelView;
    di: number;
    df: number;
    dh: number;
    dg: number;
    b6(): void;
    bq(): number;
    db(): number;
    dd(): number;
    de(): number;
    dc(): number;
    a5(): List$1<Rect>;
    private dj;
    private dk;
    cm(a: FrameworkElement, b: number): void;
    protected da(): boolean;
    c0(): Rect;
    aj(a: TitleSettings): AxisTitlePosition;
    ai(): AxisLabelsLocation;
    ay(a: AxisLabelsLocation): boolean;
    protected b9(): void;
}
/**
 * @hidden
 */
export interface IHasCategoryAxis {
    readonly categoryAxis: CategoryAxisBase;
    getOffsetValue(): number;
    getCategoryWidth(): number;
}
/**
 * @hidden
 */
export declare let IHasCategoryAxis_$type: Type;
/**
 * @hidden
 */
export interface IHasCategoryModePreference extends IHasCategoryAxis {
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
}
/**
 * @hidden
 */
export declare let IHasCategoryModePreference_$type: Type;
/**
 * @hidden
 */
export declare class AutomaticSeriesManager extends Base {
    static $t: Type;
    private g;
    private c;
    e(a: AutomaticSeriesPurpose): boolean;
    constructor(a: SeriesViewer);
    private i;
    private n;
    private m;
    protected f: boolean;
    private j;
    private k;
    l(a: AutomaticSeriesPurpose): void;
    private h;
    private d;
    private a;
    get b(): AutomaticSeriesRequestCollection;
}
/**
 * @hidden
 */
export declare class AutomaticSeriesRequest extends Base {
    static $t: Type;
    a: AutomaticSeriesPurpose;
    d: Series;
    b: Series;
    c: Series;
    e: boolean;
    f: boolean;
}
/**
 * @hidden
 */
export declare class AutomaticSeriesRequestCollection extends ObservableCollection$1<AutomaticSeriesRequest> {
    static $t: Type;
    constructor();
}
/**
 * @hidden
 */
export interface IDataChartToolbarProvider {
    container: any;
    getDesiredToolbarActions(): ToolActionInfo[];
    onToolCommandExecuting(a: SeriesViewer, b: ToolCommand): ToolCommandExecutionState;
}
/**
 * @hidden
 */
export declare let IDataChartToolbarProvider_$type: Type;
/**
 * @hidden
 */
export interface ISeriesViewerScrollbarManager {
    executionContext: IExecutionContext;
    animator: DoubleAnimator;
    owner: SeriesViewer;
    onHorizontalScrollbarModeChanged(a: SeriesViewerScrollbarMode): void;
    onVerticalScrollbarModeChanged(a: SeriesViewerScrollbarMode): void;
    updateScrollbars(a: SeriesViewer, b: Rect, c: Rect, d: Rect, e: Rect): void;
    updateBarDimensions(a: SeriesViewer, b: number, c: number, d: number, e: boolean, f: number, g: number, h: number, i: number, j: number, k: boolean, l: number, m: number): void;
    updateBarAppearance(a: SeriesViewer, b: Brush, c: Brush, d: Brush, e: Brush, f: number, g: number, h: number, i: number): void;
    onCrosshairMoved(a: Point): void;
    shouldHandleInteraction(a: Point, b: boolean): boolean;
    onScrollbarDrag(a: Point, b: boolean): void;
    onScrollbarDragComplete(a: Point, b: boolean): void;
    onScrollbarDragCancel(): void;
    updateVerticalScrollbarPosition(a: SeriesViewerVerticalScrollbarPosition): void;
    updateHorizontalScrollbarPosition(a: SeriesViewerHorizontalScrollbarPosition): void;
}
/**
 * @hidden
 */
export declare let ISeriesViewerScrollbarManager_$type: Type;
/**
 * @hidden
 */
export interface IHighlightingManager {
    startHighlight(a: HighlightingInfo): void;
    endHighlight(a: HighlightingInfo): void;
    clear(): void;
    getHighlightingInfo(a: Series, b: IFastItemsSource, c: number, d: number, e: boolean): HighlightingInfo;
    tick(a: number): boolean;
    inProgress: boolean;
    maxHighlightingProgress: number;
    totalHighlightingProgress: number;
    sumHighlightingProgress: number;
    maxMarkerHighlightingProgress: number;
    sumMarkerHighlightingProgress: number;
    readonly dirtySeries: List$1<Series>;
    readonly allDirty: boolean;
    isCrossSeriesHighlight(a: Series): boolean;
    executionContext: IExecutionContext;
    ensureAnimator: () => void;
    highlightingBehavior: SeriesHighlightingBehavior;
}
/**
 * @hidden
 */
export declare let IHighlightingManager_$type: Type;
/**
 * @hidden
 */
export declare class HighlightingInfo extends Base {
    static $t: Type;
    constructor();
    i: number;
    h: number;
    g: number;
    a: HighlightingState;
    f: number;
    e: boolean;
    d: boolean;
    c: boolean;
    b: Series;
}
/**
 * @hidden
 */
export interface ISeriesInteractionManager {
    a$j(a: Series, b: Point, c: number, d: Axis, e: ScalerParams, f: number, g: number, h: (arg1: Point) => number): number;
    a$m(a: Series, b: IList$1<number>, c: Point, d: Axis, e: ScalerParams, f: number, g: (arg1: Point) => number, h: boolean, i: boolean): number;
    a$l(a: Series, b: number, c: IList$1<number>, d: number, e: number, f: number, g: number, h: number, i: boolean): number;
    a$o(a: Series, b: Point, c: boolean, d: Axis, e: (arg1: Point) => number, f: IList$1<number>): number;
    a$d(a: Series, b: Point, c: boolean): boolean;
    a$a(a: Series, b: CategoryAxisBase, c: List$1<number[]>, d: number, e: number, f: Point, g: boolean): number[][];
    a$e(a: Series, b: Point, c: boolean, d: PathGeometry): boolean;
    a$f(a: Series, b: Point, c: PathGeometry): boolean;
    a$n(a: Series, b: Point, c: boolean, d: Axis, e: (arg1: Point) => number, f: IList$1<number>): number;
    a$k(a: Series, b: Point, c: Axis): number;
    a$g(a: Series, b: Point, c: boolean): boolean;
    a$al(a: Series, b: Point, c: boolean, d: boolean, e: number, f: Axis, g: Axis, h: (arg1: Point, arg2: boolean, arg3: boolean) => number, i: (arg1: Point, arg2: boolean) => number, j: (arg1: Point, arg2: boolean) => number): Point;
    a$v(a: Series, b: any, c: Point, d: boolean, e: boolean, f: boolean, g: boolean, h: boolean, i: boolean): void;
    a$s(): void;
    a$ak(a: Series, b: HighlightingInfo, c: Brush): Brush;
    a$i(a: Series, b: HighlightingInfo, c: number, d: number, e: number, f: number, g: boolean): number;
    a$y(a: Series, b: Point, c: any, d: any, e: boolean): void;
    a$ai(a: Series, b: Point): void;
    a$ab(a: Series, b: Point, c: any, d: any, e: boolean): void;
    a$z(a: Series, b: Point, c: any, d: any, e: boolean): void;
    a$w(a: Series, b: Point, c: any, d: any): void;
    a$aa(a: Series, b: Point, c: any, d: any): void;
    a$x(a: Series, b: Point, c: any, d: any): void;
    a$ac(a: Series, b: Point, c: any, d: any): void;
    a$ad(a: Series, b: Point, c: any, d: any): void;
    a$q(a: Series): string;
    a$r(a: Series): string;
    readonly a$b: boolean;
    readonly a$p: any;
    a$aj(a: Series, b: any): void;
    a$ah(a: Series, b: Point, c: (arg1: any) => void): void;
    a$u(a: Series): void;
    a$ag(a: Series): void;
    readonly a$c: boolean;
    readonly a$h: Dictionary$2<string, SeriesView>;
    a$t(a: Series, b: Rect, c: Rect, d: string, e: number): void;
    a$ae(a: Series, b: SeriesViewer): void;
    a$af(a: Series, b: string, c: SeriesViewer): void;
}
/**
 * @hidden
 */
export declare let ISeriesInteractionManager_$type: Type;
/**
 * @hidden
 */
export interface ISeriesViewerInteractionManager {
    f$a(a: SeriesViewer): ChartHitTestMode;
    f$ag(a: SeriesViewer): void;
    f$q(a: SeriesViewer, b: Point): void;
    f$ae(a: SeriesViewer, b: Point): void;
    f$r(a: SeriesViewer, b: Point, c: boolean): void;
    f$p(a: SeriesViewer, b: Point): void;
    f$al(a: SeriesViewer): void;
    f$ad(a: SeriesViewer, b: Point): void;
    f$am(a: SeriesViewer, b: Point, c: number, d: number, e: number): void;
    f$ac(a: SeriesViewer, b: number): void;
    f$ai(a: SeriesViewer, b: Point, c: number, d: number, e: number): void;
    f$z(a: SeriesViewer, b: Point): void;
    f$ab(a: SeriesViewer, b: number): void;
    f$s(a: SeriesViewer, b: Point): void;
    f$y(a: SeriesViewer, b: Point): void;
    f$ah(a: SeriesViewer, b: Point, c: number, d: number, e: number): void;
    f$n(a: SeriesViewer, b: Point, c: boolean): void;
    f$ak(a: SeriesViewer): void;
    f$aj(a: SeriesViewer): void;
    f$ap(a: SeriesViewer): void;
    f$k(a: SeriesViewer): void;
    f$h(a: SeriesViewer): void;
    f$m(a: SeriesViewer, b: Point, c: boolean): void;
    f$l(a: SeriesViewer, b: Point, c: boolean, d: boolean): void;
    f$an(a: SeriesViewer): void;
    f$af(a: SeriesViewer): void;
    f$e(a: SeriesViewer, b: Key): boolean;
    f$f(a: SeriesViewer, b: Point, c: number): boolean;
    f$o(a: SeriesViewer, b: Point): void;
    f$j(a: SeriesViewer): void;
    f$i(a: SeriesViewer): void;
    readonly f$b: IHighlightingManager;
    readonly f$c: ISeriesViewerScrollbarManager;
    f$ao(a: SeriesViewer, b: Point): void;
    f$d(a: SeriesViewer, b: SeriesCollection, c: RenderingContext, d: Point, e: boolean, f: DataContext, g: boolean): {
        ret: Series;
        p5: DataContext;
    };
    f$g(a: SeriesViewer, b: Point): boolean;
    f$w(a: SeriesViewer, b: SeriesCollection, c: RenderingContext, d: Point, e: boolean, f: boolean): void;
    f$v(a: SeriesViewer, b: Point): void;
    f$u(a: SeriesViewer, b: EventProxy, c: Point): void;
    f$x(a: SeriesViewer, b: EventProxy, c: Point): void;
    f$t(a: SeriesViewer, b: Point, c: boolean): void;
    f$aa(a: SeriesViewer, b: boolean): void;
}
/**
 * @hidden
 */
export declare let ISeriesViewerInteractionManager_$type: Type;
/**
 * @hidden
 */
export interface IDataChartVisualDataManager {
    exportVisualData(a: XamDataChart): any;
}
/**
 * @hidden
 */
export declare let IDataChartVisualDataManager_$type: Type;
/**
 * @hidden
 */
export interface IAxisVisualDataManager {
    exportVisualData(a: Axis): any;
}
/**
 * @hidden
 */
export declare let IAxisVisualDataManager_$type: Type;
/**
 * @hidden
 */
export interface ISeriesVisualDataManager {
    exportVisualData(a: Series, b: Rect): any;
    exportMarkerVisualData(a: MarkerSeries, b: any): void;
    getMarkerVisualData(a: Series, b: Marker, c: DataTemplate): any;
    copyVisualData(a: any, b: any): void;
    exportTrendlineData(a: Series, b: any, c: Polyline): void;
    exportStackedVisualData(a: Series, b: Rect): any;
    createFragmentVisualData(a: Series, b: Rect, c: string, d: string): any;
    addSubSeriesVisualData(a: any, b: any): void;
    exportRectangleData(a: any, b: Rectangle, c: string, d: string[]): void;
    exportMarkerVisualDataFromMarker(a: Series, b: any, c: ContentControl): void;
    exportPathData(a: any, b: Path, c: string, d: string[]): void;
    exportPolylineData(a: any, b: Polyline, c: string, d: string[]): void;
    exportPolygonData(a: any, b: Polygon, c: string, d: string[]): void;
    exportSeriesPixelsData(a: any, b: number[], c: number, d: number): void;
    addPointerTooltipData(a: any, b: any, c: number, d: number, e: List$1<string>): void;
    addPointerTooltipWithDataLegend(a: any, b: any, c: number, d: number, e: any): void;
    exportPointerTooltipData(a: Polygon, b: Polyline, c: Rectangle, d: Rect): any;
    exportCalloutData(a: number, b: number, c: number, d: number, e: any, f: Rectangle, g: TextBlock, h: FontInfo, i: Line, j: string, k: string[]): void;
}
/**
 * @hidden
 */
export declare let ISeriesVisualDataManager_$type: Type;
/**
 * @hidden
 */
export declare class XamDataChart extends SeriesViewer {
    static $t: Type;
    static vt: number;
    static vs: number;
    private _xsr;
    private get XSRP();
    private ub;
    get uc(): IDataChartVisualDataManager;
    static staticInit(): void;
    static v5(a: Series): number;
    constructor();
    protected od(a: any, b: string, c: any, d: any): void;
    ou(): void;
    m3(): void;
    protected mu(a: Rect, b: Rect): void;
    protected my(): void;
    xc(): void;
    private w7;
    private x7;
    private xe;
    private uh;
    private ug;
    private ue;
    private ud;
    private x8;
    private x9;
    protected get_d5(): boolean;
    uw: boolean;
    gp(): number;
    gq(): number;
    protected pd(): void;
    v3: number;
    v4: number;
    private vc;
    get vo(): number;
    set vo(a: number);
    private vd;
    get vp(): number;
    set vp(a: number);
    es(): boolean;
    et(): boolean;
    ut: boolean;
    u6: boolean;
    uu: boolean;
    ux: boolean;
    ua: GridMode;
    uq: boolean;
    u1: boolean;
    u2: boolean;
    vv: number;
    vr: number;
    vq: number;
    get uo(): boolean;
    protected get_e1(): boolean;
    get up(): boolean;
    u4: boolean;
    u0: boolean;
    u3: boolean;
    u5: boolean;
    t5: AutoMarginsAndAngleUpdateMode;
    uv: boolean;
    uz: boolean;
    uy: boolean;
    private ve;
    private vf;
    private vw;
    private vx;
    protected get_e0(): boolean;
    protected get_ez(): boolean;
    xb(): void;
    xa(): void;
    w9(a: AxisLabelPanelBase, b: Rect, c: Rect, d: Rect): void;
    private v2;
    private vu;
    private w6;
    x6: Brush;
    x4: Brush;
    x5: Brush;
    get axes(): AxisCollection;
    private t6;
    private w3;
    private w4;
    axisRangeChanged: (sender: any, e: ChartAxisRangeChangedEventArgs) => void;
    private w5;
    private static w8;
    pn(a: SyncLink, b: SyncLink): void;
    private uk;
    getFontInfo(): FontInfo;
    xd(): void;
    getFontBrush(): Brush;
    protected l0(): void;
    so(): Brush;
    e8(): boolean;
    protected ph(): void;
    d4(): boolean;
    private us;
    protected ct(): SeriesViewerView;
    protected n1(a: SeriesViewerView): void;
    uj: XamDataChartView;
    ov(): void;
    private un;
    static v8: string;
    private u9;
    get vl(): number;
    set vl(a: number);
    static wa: string;
    private vb;
    get vn(): number;
    set vn(a: number);
    static v9: string;
    private va;
    get vm(): number;
    set vm(a: number);
    static v7: string;
    private u8;
    get vk(): number;
    set vk(a: number);
    t8: ComputedPlotAreaMarginMode;
    uf: SeriesPlotAreaMarginHorizontalMode;
    ui: SeriesPlotAreaMarginVerticalMode;
    private vh;
    get vz(): number;
    set vz(a: number);
    private vj;
    get v1(): number;
    set v1(a: number);
    private vi;
    get v0(): number;
    set v0(a: number);
    private vg;
    get vy(): number;
    set vy(a: number);
    protected tl(a: Rect): Rect;
    tr(): Rect;
    v6(): any;
    wl(): string;
    oa(): void;
    ox(): void;
    u7(a: Axis): List$1<Axis>;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class LabelPanelArranger extends Base {
    static $t: Type;
    static e(a: List$1<AxisLabelPanelBase>, b: Rect): Rect;
    private static a;
    static b(a: AxisLabelPanelBase): AxisLabelsLocation;
    private static c;
    static d(a: List$1<AxisLabelPanelBase>, b: LabelPanelsArrangeState, c: Rect, d: (arg1: AxisLabelPanelBase, arg2: Rect) => void): void;
}
/**
 * @hidden
 */
export declare class ChartContentManager extends DependencyObject {
    static $t: Type;
    private l;
    private r;
    private t;
    private get u();
    private set u(value);
    constructor(a: SeriesViewer);
    k(a: ChartContentType, b: DependencyObject, c: (arg1: boolean) => void): ContentInfo;
    ad(a: ChartContentType, b: DependencyObject): void;
    private m;
    private v;
    aa(a: DomRenderer): void;
    z(): void;
    ac(a: ChartContentType, b: DependencyObject, c: ContentInfo, d: boolean): void;
    private q;
    private j;
    y(): void;
    private w;
    private _s;
    private s;
    x(a: Size): void;
    o: boolean;
    n: boolean;
    p: boolean;
    ae(a: ChartContentType, b: DependencyObject, c: ContentInfo, d: Rect): void;
    ab(a: Axis, b: ContentInfo): void;
}
/**
 * @hidden
 */
export declare class ContentInfo extends Base {
    static $t: Type;
    h: DependencyObject;
    a: (arg1: boolean) => void;
    b: boolean;
    c: boolean;
    i: Rect;
    get d(): boolean;
    g(): void;
    f(): void;
    e: boolean;
}
/**
 * @hidden
 */
export declare abstract class Series extends Control implements INotifyPropertyChanged, IProvidesViewport, ILegendSeries, ILegendSeriesInternal, ILegendOwner, ILegendTemplateProvider, IDataLegendSeries {
    static $t: Type;
    b1: SeriesView;
    private static hf;
    ht: number;
    py: Rect;
    protected get_dataLegendKey(): string;
    get dataLegendKey(): string;
    dh: boolean;
    private hd;
    get he(): DomRenderer;
    set he(a: DomRenderer);
    provideRenderer(a: DomRenderer): void;
    jw(): string;
    constructor();
    m5(a: MarkerOutlineMode): void;
    m4(a: MarkerFillMode): void;
    m6(a: number): void;
    private static readonly oz;
    protected ku(a: any, b: PropertyChangedEventArgs): void;
    private cn;
    get co(): SRProvider;
    private a8;
    get a9(): ISeriesVisualDataManager;
    protected get fg(): Dictionary$2<string, SeriesView>;
    private a6;
    get a7(): ISeriesInteractionManager;
    get d2(): boolean;
    cf: DoubleAnimator;
    l4(a: SeriesView): void;
    l2(): void;
    l3(): void;
    bz(): SeriesView;
    protected by(): SeriesView;
    nf: Canvas;
    fa(): boolean;
    h1(a: any, b: string): any;
    onLegendItemOver(a: any): void;
    onLegendItemPointerUp(a: any): void;
    onLegendItemPointerDown(a: any): void;
    onLegendItemEnter(a: any): void;
    onLegendItemLeave(a: any): void;
    private ff;
    protected jv(a: string): string;
    private fe;
    protected h2(a: any, b: string, c: string): any;
    f9(a: Point): number;
    hk(a: Point): number;
    protected get_ec(): boolean;
    get ec(): boolean;
    as(): CategoryAxisBase;
    hi(a: Point): number;
    p8(): Thickness;
    qa(a: SeriesPlotAreaMarginHorizontalMode, b: SeriesPlotAreaMarginVerticalMode): Thickness;
    p9(a: SeriesPlotAreaMarginHorizontalMode, b: SeriesPlotAreaMarginVerticalMode): Thickness;
    bw(): SeriesPlotAreaMarginHorizontalMode;
    bx(): SeriesPlotAreaMarginVerticalMode;
    hy(a: Point): any;
    protected h3(a: Series, b: Point): any;
    protected az(a: Series, b: any, c: Point, d: boolean): HighlightingInfo;
    protected a0(a: Series, b: any, c: Point, d: boolean): HighlightingInfo;
    hh(): number;
    hl(): number;
    hq(): number;
    get container(): ILegendOwner;
    get hasSubItems(): boolean;
    protected c4(): boolean;
    forSubItems(a: (arg1: any) => void): void;
    protected le(a: (arg1: any) => void): void;
    lf(a: (arg1: Series) => boolean): void;
    ju(): string;
    pf(): Brush;
    pg(): Brush;
    resolveLegendIndex(): number;
    bg(): Series;
    protected get_dd(): boolean;
    get dd(): boolean;
    protected get_da(): boolean;
    get da(): boolean;
    protected get_c9(): boolean;
    get c9(): boolean;
    protected get_dc(): boolean;
    get dc(): boolean;
    protected get_db(): boolean;
    get db(): boolean;
    protected get_de(): boolean;
    get de(): boolean;
    protected get_isVertical(): boolean;
    get isVertical(): boolean;
    protected get_dx(): boolean;
    get dx(): boolean;
    protected get_dg(): boolean;
    get dg(): boolean;
    protected get_df(): boolean;
    get df(): boolean;
    protected get_c7(): boolean;
    get c7(): boolean;
    protected get_em(): boolean;
    get em(): boolean;
    protected get_d4(): boolean;
    get d4(): boolean;
    protected get_d3(): boolean;
    get d3(): boolean;
    protected get_ej(): boolean;
    get ej(): boolean;
    protected get_dk(): boolean;
    get dk(): boolean;
    protected get_di(): boolean;
    get di(): boolean;
    protected get_en(): boolean;
    get en(): boolean;
    protected get_eb(): boolean;
    get eb(): boolean;
    protected get_ea(): boolean;
    get ea(): boolean;
    protected get_d8(): boolean;
    get d8(): boolean;
    protected get_d7(): boolean;
    get d7(): boolean;
    protected get_el(): boolean;
    get el(): boolean;
    protected get_ek(): boolean;
    get ek(): boolean;
    protected get_eh(): boolean;
    get eh(): boolean;
    protected get_d9(): boolean;
    get d9(): boolean;
    protected get_ef(): boolean;
    get ef(): boolean;
    protected get_ed(): boolean;
    get ed(): boolean;
    protected get_isStacked(): boolean;
    get isStacked(): boolean;
    protected get_ds(): boolean;
    get ds(): boolean;
    protected get_ee(): boolean;
    get ee(): boolean;
    protected get_dj(): boolean;
    get dj(): boolean;
    protected get_dy(): boolean;
    get dy(): boolean;
    protected get_eg(): boolean;
    get eg(): boolean;
    protected get_isValueOverlay(): boolean;
    get isValueOverlay(): boolean;
    bf(): Series;
    protected get_c5(): boolean;
    get c5(): boolean;
    protected get_dv(): boolean;
    get dv(): boolean;
    protected get_du(): boolean;
    get du(): boolean;
    protected get_dt(): boolean;
    get dt(): boolean;
    protected get_dw(): boolean;
    get dw(): boolean;
    protected get_dm(): boolean;
    get dm(): boolean;
    protected get_dn(): boolean;
    get dn(): boolean;
    f7(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    protected f8(a: Point, b: number, c: Axis, d: ScalerParams, e: number, f: number, g: (arg1: Point) => number): number;
    protected get_fc(): boolean;
    get fc(): boolean;
    protected gp(a: IList$1<number>, b: Point, c: Axis, d: ScalerParams, e: number, f: (arg1: Point) => number, g: boolean, h: boolean): number;
    gd(a: number, b: IList$1<number>, c: number, d: number, e: number, f: number, g: number, h: boolean): number;
    hp(a: Point, b: boolean, c: Axis, d: (arg1: Point) => number, e: IList$1<number>): number;
    gc(a: boolean): number;
    ah(a: Point): Point[][];
    ai(a: Point): Point[][];
    protected ey(a: Point, b: boolean): boolean;
    aj(a: CategoryAxisBase, b: List$1<number[]>, c: number, d: number, e: Point, f: boolean): number[][];
    protected e0(a: Point, b: boolean, c: PathGeometry): boolean;
    protected e1(a: Point, b: PathGeometry): boolean;
    hn(a: Point, b: boolean, c: Axis, d: (arg1: Point) => number, e: IList$1<number>): number;
    gb(a: Point, b: Axis): number;
    ho(a: Point, b: boolean): number;
    hm(a: Point, b: boolean): number;
    gn(a: Point, b: boolean, c: boolean): number;
    ps(a: Point, b: boolean, c: boolean): Point;
    p3(a: Point): Rect;
    ak(a: Point): Rect[];
    p4(a: Point): Rect;
    al(a: Point): Rect[];
    p5(a: Point): Rect;
    p6(a: Point): Rect;
    protected e2(a: Point, b: boolean): boolean;
    protected pu(a: Point, b: boolean, c: boolean, d: number, e: Axis, f: Axis, g: (arg1: Point, arg2: boolean, arg3: boolean) => number, h: (arg1: Point, arg2: boolean) => number, i: (arg1: Point, arg2: boolean) => number): Point;
    gj(a: Point, b: boolean, c: boolean): number;
    po(a: Point, b: boolean, c: boolean): Point;
    gl(a: Point, b: boolean, c: boolean): number;
    pq(a: Point, b: boolean, c: boolean): Point;
    pt(a: Point, b: boolean, c: boolean): Point;
    go(a: Point, b: boolean, c: boolean): number;
    pp(a: Point, b: boolean, c: boolean): Point;
    gk(a: Point, b: boolean, c: boolean): number;
    pr(a: Point, b: boolean, c: boolean): Point;
    gm(a: Point, b: boolean, c: boolean): number;
    hj(a: Point): number;
    ge(): number;
    ga(a: Point): number;
    hz(a: Point): any;
    c2(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number): boolean;
    gt(a: Marker): number;
    i4(): string;
    gq(a: ValueLayerValueMode, b: Axis): number;
    am(a: ValueLayerValueMode): number[];
    pv(a: ValueLayerValueMode): Point;
    pw(a: number[]): Point;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected raisePropertyChanged(a: string, b: any, c: any): void;
    protected get_hasMarkers(): boolean;
    get hasMarkers(): boolean;
    li(): void;
    lj(): void;
    pc(): Brush;
    pd(): Brush;
    nj(): DataTemplate;
    f6(): number;
    px(a: Point): Point;
    pn(a: Point): Point;
    h4(a: any, b: Point): any;
    eq(a: any): boolean;
    aq(a: Axis): AxisRange;
    ar(a: Rect): AxisRange;
    ap(a: AxisRange, b: NumericAxisBase, c: Rect): AxisRange;
    protected lb(): void;
    mn(a: boolean): void;
    renderRequested: (sender: any, e: RenderRequestedEventArgs) => void;
    private k8;
    mo(a: boolean): void;
    protected e4: boolean;
    protected ky(): void;
    protected k3(): void;
    b0: SeriesView;
    mp(a: Rect, b: RenderSurface): void;
    mm(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    getEffectiveViewport1(a: SeriesView): Rect;
    getMainContentViewport(): Rect;
    pz(a: SeriesView): Rect;
    p2(a: Rect): Rect;
    p1(a: SeriesView): Rect;
    getEffectiveViewport(): Rect;
    mh(): void;
    protected get_c3(): boolean;
    get c3(): boolean;
    protected get_c6(): boolean;
    get c6(): boolean;
    private mi;
    mj(a: string): void;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    fd(a: Rect, b: Rect, c: SeriesView): boolean;
    k2(a: boolean, b: SeriesView): void;
    protected cx(): boolean;
    cy(a: SeriesView): boolean;
    l5(a: Rect, b: Rect): void;
    protected nb(a: Rect, b: Rect): void;
    protected na(a: Rect, b: Rect): void;
    at: ContentInfo;
    private ct;
    get e3(): boolean;
    set e3(a: boolean);
    protected ld(a: Series): void;
    protected lv(): void;
    lp(): void;
    lu(): void;
    protected get_d1(): boolean;
    get d1(): boolean;
    protected get_isUsableInLegend(): boolean;
    get isUsableInLegend(): boolean;
    protected l0(): void;
    lw(): void;
    protected l6(): void;
    l7(): void;
    protected ew: boolean;
    protected ex: boolean;
    protected ep(): boolean;
    protected l8(a: boolean): void;
    private cu;
    protected get e5(): boolean;
    protected set e5(a: boolean);
    protected get e6(): boolean;
    protected v(): void;
    protected w(a: Visibility, b: Visibility): void;
    protected lz(): void;
    protected l9(a: any, b: string, c: any, d: any): void;
    protected m0(): void;
    m8(a: Point): void;
    la(): void;
    protected get_d0(): boolean;
    protected get d0(): boolean;
    cz: boolean;
    protected k7(a: Series): void;
    get b9(): SyncLink;
    set b9(a: SyncLink);
    private b8;
    get ce(): SeriesViewer;
    set ce(a: SeriesViewer);
    private cd;
    get cc(): XamDataChart;
    set cc(a: XamDataChart);
    readonly fk: (sender: any, e: NotifyCollectionChangedEventArgs) => void;
    readonly be: (sender: any, e: PropertyUpdatedEventArgs) => void;
    readonly cm: (sender: any, e: RectChangedEventArgs) => void;
    get itemsSource(): IEnumerable;
    set itemsSource(a: IEnumerable);
    static readonly n4: DependencyProperty;
    cl: IFastItemsSource;
    ha: (sender: any, e: FastItemsSourceEventArgs) => void;
    protected k5(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    get legend(): IChartLegend;
    set legend(a: IChartLegend);
    static readonly oa: DependencyProperty;
    get ne(): Control;
    set ne(a: Control);
    private nc;
    h5(): any;
    protected nd(): Control;
    get a2(): IChartLegend;
    set a2(a: IChartLegend);
    private a1;
    qb: Visibility;
    get legendItemBadgeTemplate(): DataTemplate;
    set legendItemBadgeTemplate(a: DataTemplate);
    static readonly n7: DependencyProperty;
    ng: DataTemplate;
    private ni;
    o7: Brush;
    o6: Brush;
    b7: StandardLegendItems;
    b6: StandardLegendItems;
    legendItemBadgeShape: LegendItemBadgeShape;
    ba: LegendItemBadgeMode;
    get legendItemTemplate(): DataTemplate;
    set legendItemTemplate(a: DataTemplate);
    static readonly n8: DependencyProperty;
    get nh(): DataTemplate;
    set nh(a: DataTemplate);
    static readonly nw: DependencyProperty;
    get index(): number;
    set index(a: number);
    static readonly nz: DependencyProperty;
    m9(): void;
    k9(): void;
    protected m1(): void;
    cg: (time: number) => number;
    ch: (time: number) => number;
    c1: boolean;
    hr: number;
    g5: number;
    cw(): boolean;
    mw(): void;
    private cs;
    private fn;
    get fx(): number;
    set fx(a: number);
    protected gz(): number;
    gy: number;
    private fr;
    protected get f2(): number;
    protected set f2(a: number);
    g9: number;
    private fo;
    protected get fz(): number;
    protected set fz(a: number);
    g6: number;
    private fp;
    protected get f0(): number;
    protected set f0(a: number);
    g7: number;
    private fq;
    protected get f1(): number;
    protected set f1(a: number);
    g8: number;
    title: any;
    o9: Brush;
    o5: Brush;
    pa: Brush;
    pb: Brush;
    pe: Brush;
    o8: Brush;
    pl: PenLineJoin;
    gw: number;
    g4: number;
    fy: number;
    f4: number;
    pj: PenLineCap;
    pi: DoubleCollection;
    toolTip: any;
    private bk;
    get bl(): SeriesHighlightingMode;
    set bl(a: SeriesHighlightingMode);
    protected bm(): SeriesHighlightingMode;
    protected ei(a: SeriesHighlightingMode): boolean;
    private fm;
    get fv(): number;
    set fv(a: number);
    gu: number;
    c8: boolean;
    dl: boolean;
    dz: boolean;
    et: boolean;
    dq: boolean;
    protected get_dr(): boolean;
    get dr(): boolean;
    g1: number;
    ph: Color;
    fb: boolean;
    g2: number;
    g3: number;
    f3: number;
    fu: number;
    my(): void;
    gv: number;
    fw: number;
    mz(): void;
    protected g0(): number;
    private cr;
    get dp(): boolean;
    set dp(a: boolean);
    ev: boolean;
    private b2;
    get b3(): SeriesVisibleRangeMode;
    set b3(a: SeriesVisibleRangeMode);
    b4(): SeriesVisibleRangeMode;
    b5: SeriesVisibleRangeMode;
    private bs;
    get bt(): SeriesOutlineMode;
    set bt(a: SeriesOutlineMode);
    bv(): SeriesOutlineMode;
    bu: SeriesOutlineMode;
    av(a: any): DataContext;
    hs: number;
    cb: TransitionInSpeedType;
    protected ca(): TransitionInSpeedType;
    hw: any;
    ml(): void;
    mq(): void;
    mk(): void;
    kz(): void;
    lk(): void;
    private static _fi;
    static fi(a: (arg1: number) => number, b: number, c: number): IEnumerable$1<number>;
    static fh(a: (arg1: number) => number, b: number): IEnumerable$1<number>;
    pk: PenLineCap;
    private bh;
    bi(): SeriesComponentsForView;
    mr(a: Canvas): void;
    gr(): number;
    gs(): number;
    private cv;
    protected get_e7(): boolean;
    protected set_e7(a: boolean): void;
    protected get e7(): boolean;
    protected set e7(a: boolean);
    get es(): boolean;
    eo: boolean;
    k0(): void;
    ax(a: any, b: Point, c: boolean): HighlightingInfo;
    ay(a: any, b: Point, c: boolean): HighlightingInfo;
    l1(a: Point, b: any, c: any, d: boolean): void;
    mv(a: Point): void;
    private kw;
    private k1;
    kv(a: IChartLegend, b: IChartLegend): void;
    private kx;
    mg(a: IFastItemsSourceProvider): void;
    mf(a: IFastItemsSourceProvider): void;
    protected a3(): IChartLegend;
    protected eu(): boolean;
    er(a: boolean): boolean;
    protected k6(a: Axis): void;
    protected me(a: Axis): void;
    bj(): SeriesComponentsFromView;
    m3(a: Canvas): void;
    mu(a: Point, b: (arg1: any) => void): void;
    protected get_e9(): boolean;
    get e9(): boolean;
    ma(a: RenderingContext, b: RenderingContext): void;
    mc(a: Rect): void;
    lh(a: NotifyCollectionChangedEventArgs): void;
    ls(a: number, b: any, c: any): void;
    lo(): void;
    lq(a: number, b: any): void;
    lr(a: number, b: any): void;
    mx(): void;
    h7: any;
    hc: (arg1: any) => any;
    ez(a: Point, b: boolean): boolean;
    protected _coercionMethods: any;
    protected get_coercionMethods(): any;
    protected set_coercionMethods(a: any): void;
    get coercionMethods(): any;
    set coercionMethods(a: any);
    private cq;
    protected get_expectFunctions(): boolean;
    protected set_expectFunctions(a: boolean): void;
    get expectFunctions(): boolean;
    set expectFunctions(a: boolean);
    au(a: Point, b: boolean): DataContext;
    private bo;
    get br(): SeriesHitTestMode;
    set br(a: SeriesHitTestMode);
    protected bq(): SeriesHitTestMode;
    private bn;
    get bp(): SeriesHitTestMode;
    set bp(a: SeriesHitTestMode);
    protected ci(a: string): IFastItemColumn$1<number>;
    protected cj(a: string): IFastItemColumn$1<number>;
    protected ck(a: string): IFastItemColumn$1<any>;
    protected get p7(): Rect;
    protected get_d6(): boolean;
    get d6(): boolean;
    protected get_d5(): boolean;
    get d5(): boolean;
    mt(a: boolean): void;
    ms(a: Brush, b: Brush): void;
    cp: (arg1: SeriesViewer) => void;
    protected k4(a: any, b: any): void;
    hx(): any;
    protected lc(a: any): void;
    private pm;
    lm(a: Point): void;
    protected ly(a: Point): void;
    ln(): void;
    lt(): void;
    ao(a: Axis): Axis;
    ag(): Axis[];
    gg(): number;
    static gh(a: IFastItemColumn$1<number>, b: ISortingAxis): number;
    static gi(a: IList$1<number>, b: ISortingAxis): number;
    lx(): void;
    private fs;
    get f5(): number;
    set f5(a: number);
    private ft;
    get gx(): number;
    set gx(a: number);
    protected m7(): void;
    h0(a: any): any;
    get im(): string;
    get ia(): string;
    get ib(): string;
    get ik(): string;
    get it(): string;
    get is(): string;
    get ip(): string;
    protected m2(): void;
    an(): ActualLegendItemBadgeShape;
    protected bb(a: LegendItemBadgeShape): LegendItemBadgeShape;
    private bc;
    getDataLegendBadge(): DataTemplate;
    private a5;
    getDataLegendBadgeContext(): any;
    getDataLegendBadgeShapeAndMarker(): string;
    i2(): string;
    i3(a: Series, b: DataTemplate): string;
    getDataLegendSeriesTitle(): string;
    gf(a: any, b: string): number;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    aw(): DataLegendSeriesGroup;
    getDataLegendAxisLabelFromCursorPosition(a: number, b: number): any;
    private ll;
    private fl;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class MarkerSeries extends Series {
    static $t: Type;
    qk: MarkerSeriesView;
    constructor();
    p9(a: SeriesPlotAreaMarginHorizontalMode, b: SeriesPlotAreaMarginVerticalMode): Thickness;
    l4(a: SeriesView): void;
    protected get_hasMarkers(): boolean;
    pc(): Brush;
    pd(): Brush;
    nj(): DataTemplate;
    i2(): string;
    ql: MarkerType;
    private qg;
    get qh(): MarkerOutlineMode;
    set qh(a: MarkerOutlineMode);
    qj(): MarkerOutlineMode;
    m5(a: MarkerOutlineMode): void;
    qi: MarkerOutlineMode;
    private qc;
    get qd(): MarkerFillMode;
    set qd(a: MarkerFillMode);
    qf(): MarkerFillMode;
    m4(a: MarkerFillMode): void;
    m6(a: number): void;
    qe: MarkerFillMode;
    q7: DataTemplate;
    qq: number;
    f6(): number;
    q5: DataTemplate;
    q6: DataTemplate;
    private static q4;
    static get q8(): DataTemplate;
    get rn(): Brush;
    set rn(a: Brush);
    static readonly rc: DependencyProperty;
    rl: Brush;
    ro: Brush;
    rm: Brush;
    rp: Style;
    qp: boolean;
    qn(): boolean;
    protected lz(): void;
    protected l9(a: any, b: string, c: any, d: any): void;
    static qu(a: MarkerType): string;
    static qm(a: Series, b: MarkerType): MarkerType;
    protected m1(): void;
    protected lc(a: any): void;
    protected qo(a: Point, b: boolean): boolean;
    au(a: Point, b: boolean): DataContext;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class SyncLink extends FrameworkElement implements INotifyPropertyChanged, IFastItemsSourceProvider {
    static $t: Type;
    constructor();
    ak: string;
    protected aq(a: any, b: string, c: any, d: any): void;
    releaseFastItemsSource(a: IEnumerable): IFastItemsSource;
    static aj: (arg1: IEnumerable) => IFastItemsSource;
    private static af;
    getFastItemsSource(a: IEnumerable): IFastItemsSource;
    ag(a: IEnumerable): IFastItemsSource;
    private ah;
    av: Rect;
    private aw;
    private ax;
    private ab;
    private ac;
    get ai(): IList$1<SeriesViewer>;
    private ad;
    al(a: SeriesViewer): void;
    as(a: SeriesViewer): void;
    private ao;
    private am;
    an(a: SeriesViewer, b: Point): void;
    ap(a: SeriesViewer, b: Rect): void;
    at(a: SeriesViewer, b: Rect): void;
    au(a: SeriesViewer, b: Rect, c: boolean): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected ar(a: string, b: any, c: any): void;
}
/**
 * @hidden
 */
export declare class SyncLinkManager extends Base {
    static $t: Type;
    private static b;
    static instance(): SyncLinkManager;
    private d;
    get e(): number;
    constructor();
    getLink(a: string): SyncLink;
    releaseLink(a: SyncLink): void;
}
/**
 * @hidden
 */
export declare class SyncManager extends Base {
    static $t: Type;
    static e(a: SeriesViewer): void;
    static c(a: SeriesViewer): void;
    static b(a: SeriesViewer, b: string, c: string): void;
    static d(a: DependencyObject, b: SyncSettings): void;
    static a(a: DependencyObject): SyncSettings;
}
/**
 * @hidden
 */
export declare class ChartCollection extends ObservableCollection$1<SeriesViewer> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class SeriesCollection extends ObservableCollection$1<Series> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class PlotAreaMouseEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Point, c: Point);
    private _chartPosition;
    get chartPosition(): Point;
    set chartPosition(a: Point);
    private _plotAreaPosition;
    get plotAreaPosition(): Point;
    set plotAreaPosition(a: Point);
    private _isDuringManipulation;
    get isDuringManipulation(): boolean;
    set isDuringManipulation(a: boolean);
    private _viewer;
    get viewer(): SeriesViewer;
    set viewer(a: SeriesViewer);
}
/**
 * @hidden
 */
export declare class PlotAreaMouseButtonEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Point, c: Point);
    private _chartPosition;
    get chartPosition(): Point;
    set chartPosition(a: Point);
    private _plotAreaPosition;
    get plotAreaPosition(): Point;
    set plotAreaPosition(a: Point);
    private _manipulationOccurred;
    get manipulationOccurred(): boolean;
    set manipulationOccurred(a: boolean);
    private _viewer;
    get viewer(): SeriesViewer;
    set viewer(a: SeriesViewer);
}
/**
 * @hidden
 */
export declare class ChartCursorEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Series, c: any);
    toString(): string;
    private _item;
    get item(): any;
    set item(a: any);
    private _series;
    get series(): Series;
    set series(a: Series);
    private _seriesViewer;
    get seriesViewer(): SeriesViewer;
    set seriesViewer(a: SeriesViewer);
    get chart(): XamDataChart;
}
/**
 * @hidden
 */
export declare class DataChartMouseButtonEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Series, c: any, d: MouseButtonEventArgs);
    toString(): string;
    protected g: MouseButtonEventArgs;
    get handled(): boolean;
    set handled(a: boolean);
    getPosition(a: UIElement): Point;
    get originalSource(): any;
    private _item;
    get item(): any;
    set item(a: any);
    private _series;
    get series(): Series;
    set series(a: Series);
    private _chart;
    get chart(): SeriesViewer;
    set chart(a: SeriesViewer);
}
/**
 * @hidden
 */
export declare class ChartMouseEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Series, c: any, d: MouseEventArgs);
    toString(): string;
    private f;
    getPosition(a: UIElement): Point;
    get originalSource(): any;
    private _item;
    get item(): any;
    set item(a: any);
    private _series;
    get series(): Series;
    set series(a: Series);
    private _chart;
    get chart(): SeriesViewer;
    set chart(a: SeriesViewer);
}
/**
 * @hidden
 */
export declare class AxisComponentsForView extends Base {
    static $t: Type;
    a: AxisLabelPanelBase;
}
/**
 * @hidden
 */
export declare class AxisLabelPanelBaseView extends Base {
    static $t: Type;
    protected a: AxisLabelPanelBase;
    aw: Path;
    constructor(a: AxisLabelPanelBase);
    aa(a: FrameworkElement, b: Rect, c: number, d: number, e: number, f: number): void;
    z(a: Rectangle, b: TextBlock, c: LabelPosition, d: Rect, e: number, f: number, g: number, h: number): void;
    ae(a: FrameworkElement): void;
    ah(a: any): void;
    ai(a: any, b: Size): void;
    aj(a: FrameworkElement, b: number): void;
    ar(a: Rectangle, b: TextBlock, c: LabelPosition, d: Rect, e: number, f: number, g: number, h: number, i: number): void;
    ad(a: Rectangle): void;
    x(a: TextBlock, b: number, c: number, d: number): string;
    af(): void;
    g(): IEnumerable$1<any>;
    l(a: any): number;
    n(a: any): number;
    an(): void;
    m(a: any): number;
    w(a: any): number;
    ax(a: any): Size;
    ac(): void;
    ak(): void;
    protected e: RenderingContext;
    f(): RenderingContext;
    al(a: RenderingContext): void;
    y(): void;
    protected am(): void;
    private av;
    protected ap(a: TextBlock): void;
    ao(): void;
    d(): FontInfo;
    at(): Brush;
    private c;
    ag(): void;
    private h;
    private as;
    private i;
    j(): number;
    k(): number;
    protected aq(): void;
    ab(a: Size): void;
    protected ay(): Thickness;
    v(): number;
    s(): number;
    t(): number;
    u(): number;
    au(): GeometryCollection;
    b(): PathRenderingInfo;
    r(): number;
    p(): number;
    q(): number;
    o(): number;
}
/**
 * @hidden
 */
export declare class AxisView extends Base implements ISchedulableRender {
    static $t: Type;
    protected a: Axis;
    constructor(a: Axis);
    aj(): void;
    al(a: any): void;
    ba: Path;
    bb: Path;
    bd: Path;
    bc: Path;
    a0(): TextBlock;
    at(a: TextBlock): void;
    av(a: TextBlock): void;
    au(a: TextBlock): void;
    bf(): Rectangle;
    s(a: Rectangle): void;
    u(a: Rectangle): void;
    t(a: Rectangle): void;
    am(): void;
    o(): boolean;
    get index(): number;
    ag(): void;
    ae(): void;
    aa(): void;
    ay(a: Visibility): void;
    aq(): void;
    z(a: AxisLabelSettings): void;
    private b;
    c(): AxisComponentsFromView;
    ac(a: GeometryCollection): void;
    a1(): GeometryCollection;
    e(): PathRenderingInfo;
    a4(): GeometryCollection;
    a2(): GeometryCollection;
    f(): PathRenderingInfo;
    a3(): GeometryCollection;
    g(): PathRenderingInfo;
    protected get d(): AxisLabelPanelBase;
    aw(a: Axis, b: Rect, c: Rect): void;
    ab(): void;
    as(a: number): void;
    ax(a: List$1<any>, b: List$1<LabelPosition>): void;
    ar(a: number): void;
    y(): void;
    private h;
    r(a: number): string;
    protected n(): boolean;
    l(): boolean;
    protected q(dataItem_: any): string;
    p(dataItem_: any): any;
    protected k: RenderingContext;
    j: RenderingContext;
    ai(a: RenderingContext, b: RenderingContext): void;
    private _isDirty;
    get isDirty(): boolean;
    set isDirty(a: boolean);
    protected ah(): void;
    undirty(a: boolean): void;
    private be;
    protected ao(a: boolean): void;
    postRender(): void;
    private a8;
    protected ap(): void;
    af(): void;
    ad(a: SeriesViewer): void;
    x(a: SeriesViewer): void;
    i(): FontInfo;
    m(): boolean;
    an(): void;
    w(): void;
    az(): void;
    v(a: AxisLabelSettings, b: string): void;
    preRender(): void;
    isValid(): boolean;
    a5(a: TextBlock): Point;
    a6(): Point;
    a9(): Rect;
    a7(a: TextBlock): Point;
    bg(a: TextBlock): Thickness;
    ak(): void;
}
/**
 * @hidden
 */
export declare class CategoryAxisBaseView extends AxisView {
    static $t: Type;
    protected bh: CategoryAxisBase;
    constructor(a: CategoryAxisBase);
    r(a: number): string;
    bi(a: List$1<any>): number;
}
/**
 * @hidden
 */
export declare class HorizontalAxisLabelPanelBaseView extends AxisLabelPanelBaseView {
    static $t: Type;
    protected az: HorizontalAxisLabelPanelBase;
    constructor(a: HorizontalAxisLabelPanelBase);
    a1(): void;
    a0(): boolean;
    a2(a: List$1<Rect>): void;
}
/**
 * @hidden
 */
export declare class NumericAxisBaseView extends AxisView {
    static $t: Type;
    protected bh: NumericAxisBase;
    constructor(a: NumericAxisBase);
    bi(): void;
    protected n(): boolean;
    l(): boolean;
    protected q(dataItem_: any): string;
    r(a: number): string;
}
/**
 * @hidden
 */
export declare class VerticalAxisLabelPanelView extends AxisLabelPanelBaseView {
    static $t: Type;
    protected az: VerticalAxisLabelPanel;
    constructor(a: VerticalAxisLabelPanel);
    a0(): void;
    d(): FontInfo;
    protected ay(): Thickness;
    at(): Brush;
    a1(a: List$1<Rect>, b: number): void;
}
/**
 * @hidden
 */
export declare class XamDataChartView extends SeriesViewerView {
    static $t: Type;
    constructor(a: XamDataChart);
    protected fn: XamDataChart;
    fr(a: any): void;
    protected ds(): void;
    d4(): void;
    fw: Brush;
    fs: Brush;
    ft: Brush;
    fv: Brush;
    fu: Brush;
    fp: number;
    fq: number;
    protected d1(): void;
    fo: FontInfo;
}
/**
 * @hidden
 */
export declare class SeriesView extends Base implements ISchedulableRender, IProvidesViewport {
    static $t: Type;
    protected e: Series;
    s: boolean;
    constructor(a: Series);
    getDefaultTooltipTemplate(): string;
    ap(): void;
    j(): IExecutionContext;
    private h;
    protected get i(): IExecutionContext;
    d: DataContext;
    as(): void;
    getEffectiveViewport(): Rect;
    az(): void;
    aj(): void;
    getMainContentViewport(): Rect;
    get w(): DomRenderer;
    private _isDirty;
    get isDirty(): boolean;
    set isDirty(a: boolean);
    protected get_index(): number;
    get index(): number;
    protected aq(): void;
    undirty(a: boolean): void;
    private bw;
    au(): void;
    private bn;
    bq(): Brush;
    v: number;
    private u;
    protected a4(a: boolean): void;
    private br;
    protected bd(a: any, b: number, c: boolean): void;
    protected bg(a: any, b: number, c: boolean): void;
    protected aa(a: number, b: boolean): any;
    protected ab(a: number): any;
    protected ac(a: number): any;
    protected be(a: any, b: number): void;
    protected bh(a: any, b: number): void;
    protected bf(a: any, b: number): void;
    protected bi(a: any, b: number): void;
    protected ba(a: boolean): void;
    protected bb(): void;
    protected bc(): void;
    private bm;
    protected bp(a: number): Brush;
    protected bo(): Brush;
    protected a6(a: RenderingContext, b: boolean): void;
    protected a5(a: RenderingContext, b: boolean): void;
    ax(): void;
    am(): void;
    an(): void;
    private f;
    g(): SeriesComponentsFromView;
    a9(a: Canvas): void;
    t(): boolean;
    aw(): void;
    av(): void;
    a7(): void;
    ah(): void;
    a8(): void;
    ai(): void;
    c(a: any): DataContext;
    protected k: RenderingContext;
    protected l: RenderingContext;
    ar(a: RenderingContext, b: RenderingContext): void;
    private bs;
    get bu(): Rect;
    set bu(a: Rect);
    bt: Rect;
    protected get_bv(): Rect;
    get bv(): Rect;
    private m;
    get q(): boolean;
    set q(a: boolean);
    ak(a: SeriesViewer): void;
    a: CanvasRenderScheduler;
    ag(a: SeriesViewer): void;
    postRender(): void;
    protected a0(): void;
    b(a: number): DataContext;
    a2(a: RenderSurface): void;
    al(a: any): void;
    bj(): void;
    at(): void;
    ay(): void;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    o(): boolean;
    protected r: boolean;
    bk(): void;
    a3(): void;
    protected af(): void;
    ao(): void;
    preRender(): void;
    isValid(): boolean;
    n: boolean;
    p: boolean;
    a1(a: RenderSurface): void;
    ad: string;
    bl(type_: StandardLegendItems): DataTemplate;
}
/**
 * @hidden
 */
export declare abstract class MarkerSeriesView extends SeriesView {
    static $t: Type;
    protected b1: MarkerSeries;
    private b5;
    private b7;
    private b6;
    constructor(a: MarkerSeries);
    as(): void;
    cg(): void;
    cq(): Size;
    cn(a: boolean): void;
    protected b4: List$1<Marker>;
    b0(): Marker;
    abstract cf(a: (arg1: Marker) => void): void;
    cj(a: Marker): void;
    cl(a: Marker): void;
    ck(a: Marker): void;
    b2(): boolean;
    ce(): void;
    b8(): void;
    cp(a: Marker): Rect;
    cb(a: string): void;
    cc(): void;
    b9(): void;
    cd(): void;
    ca(): void;
    cm(): void;
    b3: boolean;
    protected bh(a: any, b: number): void;
    private bx;
    protected bi(a: any, b: number): void;
    b(a: number): DataContext;
    private co;
    protected a5(a: RenderingContext, b: boolean): void;
    ch(a: HashPool$2<any, Marker>): void;
    ci(a: Pool$1<Marker>): void;
    by(a: Point): Marker;
    private bz;
}
/**
 * @hidden
 */
export declare class ChartAxisRangeChangedEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Axis, c: number, d: number, e: number, f: number);
    private _chart;
    get chart(): SeriesViewer;
    set chart(a: SeriesViewer);
    private _axis;
    get axis(): Axis;
    set axis(a: Axis);
    private _oldMinimumValue;
    get oldMinimumValue(): number;
    set oldMinimumValue(a: number);
    private _minimumValue;
    get minimumValue(): number;
    set minimumValue(a: number);
    private _oldMaximumValue;
    get oldMaximumValue(): number;
    set oldMaximumValue(a: number);
    private _maximumValue;
    get maximumValue(): number;
    set maximumValue(a: number);
}
