import { DomainChart } from "./DomainChart";
import { IEnumerable$1, Type } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { HorizontalAlignment } from "igniteui-angular-core";
import { VerticalAlignment } from "igniteui-angular-core";
import { Visibility } from "igniteui-angular-core";
import { YAxisLabelLocation } from "./YAxisLabelLocation";
import { XAxisLabelLocation } from "./XAxisLabelLocation";
import { Axis } from "./Axis";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { TitleSettings } from "./TitleSettings";
import { DataSeries } from "igniteui-angular-core";
import { XamDataChart } from "./XamDataChart";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { AxisLabelsLocation } from "./AxisLabelsLocation";
/**
 * @hidden
 */
export declare abstract class XYChart extends DomainChart {
    static $t: Type;
    provideContainer(a: any): void;
    protected r9(): void;
    protected sz(a: string, b: any, c: any): void;
    private v6;
    get v8(): (item: any) => string;
    set v8(a: (item: any) => string);
    private v7;
    get v9(): (item: any) => string;
    set v9(a: (item: any) => string);
    private wn;
    get xp(): number;
    set xp(a: number);
    private wp;
    get xr(): number;
    set xr(a: number);
    private wo;
    get xq(): number;
    set xq(a: number);
    private wm;
    get xo(): number;
    set xo(a: number);
    private w4;
    get x6(): number;
    set x6(a: number);
    private w6;
    get x8(): number;
    set x8(a: number);
    private w5;
    get x7(): number;
    set x7(a: number);
    private w3;
    get x5(): number;
    set x5(a: number);
    private abx;
    get acd(): Brush;
    set acd(a: Brush);
    private ab4;
    get ack(): Brush;
    set ack(a: Brush);
    private abv;
    get acb(): Brush;
    set acb(a: Brush);
    private abw;
    get acc(): Brush;
    set acc(a: Brush);
    private wy;
    get x0(): number;
    set x0(a: number);
    private xf;
    get yh(): number;
    set yh(a: number);
    private wx;
    get xz(): number;
    set xz(a: number);
    private xe;
    get yg(): number;
    set yg(a: number);
    private w0;
    get x2(): number;
    set x2(a: number);
    private xh;
    get yj(): number;
    set yj(a: number);
    private wz;
    get x1(): number;
    set x1(a: number);
    private xg;
    get yi(): number;
    set yi(a: number);
    private ww;
    get xy(): number;
    set xy(a: number);
    private xd;
    get yf(): number;
    set yf(a: number);
    private ab3;
    get acj(): Brush;
    set acj(a: Brush);
    private aca;
    get acq(): Brush;
    set acq(a: Brush);
    protected s0(a: string, b: any, c: any): void;
    private yp;
    get zd(): string;
    set zd(a: string);
    private yt;
    get aai(): string;
    set aai(a: string);
    private yr;
    get z1(): string;
    set z1(a: string);
    private yv;
    get aa6(): string;
    set aa6(a: string);
    private abc;
    private abe;
    protected th(a: DataSeries): void;
    protected abstract v4(): Axis;
    protected abstract v5(): Axis;
    protected abf(a: (arg1: Axis) => void): void;
    protected abg(a: (arg1: Axis) => void, b: string): void;
    protected abl(a: (arg1: Axis) => void, b: boolean): void;
    protected abk(a: (arg1: Axis) => void): void;
    protected rt(a: (arg1: Axis) => void, b: boolean): void;
    protected abj(a: (arg1: TitleSettings) => void): void;
    protected abo(a: (arg1: TitleSettings) => void): void;
    protected abm(a: (arg1: AxisLabelSettings) => void): void;
    protected abh(a: (arg1: AxisLabelSettings) => void): void;
    xi(a: number): number;
    xk(a: number): number;
    xj(a: number): number;
    xl(a: number): number;
    protected te(a: XamDataChart): void;
    static yy(a: CategoryAxisBase, b: IEnumerable$1<DataSeries>): string;
    protected r4(a: XamDataChart): void;
    protected abb(a: Axis): void;
    protected abd(a: Axis): void;
    protected r1(): void;
    protected aa9(a: Axis, b: (arg1: AxisLabelSettings) => void): void;
    protected aba(a: Axis, b: (arg1: TitleSettings) => void): void;
    protected sw(a: string, b: any, c: any): void;
    abn(): void;
    abi(): void;
    wb(a: YAxisLabelLocation): AxisLabelsLocation;
    wa(a: XAxisLabelLocation): AxisLabelsLocation;
    private yk;
    get ym(): any;
    set ym(a: any);
    private yl;
    get yn(): any;
    set yn(a: any);
    private aby;
    get ace(): Brush;
    set ace(a: Brush);
    private ab5;
    get acl(): Brush;
    set acl(a: Brush);
    private wq;
    get xs(): number;
    set xs(a: number);
    private w7;
    get x9(): number;
    set x9(a: number);
    private wr;
    get xt(): number;
    set xt(a: number);
    private w8;
    get ya(): number;
    set ya(a: number);
    private ab0;
    get acg(): Brush;
    set acg(a: Brush);
    private ab7;
    get acn(): Brush;
    set acn(a: Brush);
    private ab1;
    get ach(): Brush;
    set ach(a: Brush);
    private ab8;
    get aco(): Brush;
    set aco(a: Brush);
    private ws;
    get xu(): number;
    set xu(a: number);
    private w9;
    get yb(): number;
    set yb(a: number);
    private wt;
    get xv(): number;
    set xv(a: number);
    private xa;
    get yc(): number;
    set yc(a: number);
    private ab2;
    get aci(): Brush;
    set aci(a: Brush);
    private ab9;
    get acp(): Brush;
    set acp(a: Brush);
    private wu;
    get xw(): number;
    set xw(a: number);
    private xb;
    get yd(): number;
    set yd(a: number);
    private yq;
    get zs(): string;
    set zs(a: string);
    private yu;
    get aax(): string;
    set aax(a: string);
    private abz;
    get acf(): Brush;
    set acf(a: Brush);
    private ab6;
    get acm(): Brush;
    set acm(a: Brush);
    private wl;
    get xn(): number;
    set xn(a: number);
    private w2;
    get x4(): number;
    set x4(a: number);
    private wk;
    get xm(): number;
    set xm(a: number);
    private w1;
    get x3(): number;
    set x3(a: number);
    private wv;
    get xx(): number;
    set xx(a: number);
    private xc;
    get ye(): number;
    set ye(a: number);
    private wg;
    get wi(): boolean;
    set wi(a: boolean);
    private wh;
    get wj(): boolean;
    set wj(a: boolean);
    private abq;
    get abt(): HorizontalAlignment;
    set abt(a: HorizontalAlignment);
    private act;
    get acw(): VerticalAlignment;
    set acw(a: VerticalAlignment);
    private abp;
    get abs(): HorizontalAlignment;
    set abs(a: HorizontalAlignment);
    private abr;
    protected get_abu(): HorizontalAlignment;
    protected set_abu(a: HorizontalAlignment): void;
    get abu(): HorizontalAlignment;
    set abu(a: HorizontalAlignment);
    private acr;
    get acu(): VerticalAlignment;
    set acu(a: VerticalAlignment);
    private acs;
    get acv(): VerticalAlignment;
    set acv(a: VerticalAlignment);
    private acx;
    get acz(): Visibility;
    set acz(a: Visibility);
    private acy;
    get ac0(): Visibility;
    set ac0(a: Visibility);
    private we;
    protected get_wf(): YAxisLabelLocation;
    protected set_wf(a: YAxisLabelLocation): void;
    get wf(): YAxisLabelLocation;
    set wf(a: YAxisLabelLocation);
    private wc;
    protected get_wd(): XAxisLabelLocation;
    protected set_wd(a: XAxisLabelLocation): void;
    get wd(): XAxisLabelLocation;
    set wd(a: XAxisLabelLocation);
    private yo;
    get y4(): string;
    set y4(a: string);
    private v0;
    get v2(): any[];
    set v2(a: any[]);
    private ys;
    get z9(): string;
    set z9(a: string);
    private v1;
    get v3(): any[];
    set v3(a: any[]);
}
